!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!module computes Cl(TT) and Cl(BB) in flat sky. Also B_lll(BTT) and B_lll(TTT). !!!!!!!!!!
!Can be modified to print other spectra D. Meerburg 2016!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module CMBFlat

  use settings
  use interpolation

  implicit none 
  !not pretty, also need to fix this:
  real(dl), public :: CLTT(lmaxScal+10), CLBB(lmaxPoltens+10), CLEEt(lmaxPolScal+10), CLEE(lmaxPolScal+10)
  integer, public  :: public_intlmaxPolTens
  integer, public  :: public_intlmaxPolScal
  integer, public  :: public_intlmaxS
contains

  subroutine Compute_CL_flat


    integer     :: i, imax = 100000000, j, n, eof
    real(dl), allocatable    :: TransferS(:,:,:) 
    real(dl), allocatable    :: TransferPolTens(:,:,:)
    real(dl), allocatable    :: TransferPolScal(:,:,:) 

    real(dl), allocatable    :: karrS(:)
    real(dl), allocatable    :: karrPolTens(:),  karrPolScal(:) !number of tau samples for each k
    real(dl)    :: k, tau, T1, T2, T3, T4
    integer     :: intellmaxS, intellmaxPolTens, intellmaxPolScal
    integer     :: intkmaxS, intkmaxPolTens, intkmaxPolScal, templ
    real(dl)    :: dkS, dkT, kintresS, kintresTB, kintresTE   
    real(dl)    :: qS, qT, q2S, q2T , q2S1, q2S2, q2T1, q2T2
    integer :: ell, s
    integer, allocatable :: ellarrS(:), ellarrPolTens(:), ellarrPolScal(:)
    character(100) :: fnSLSS,fnPolTLSS,fnPolSLSS,CLBfile, CLSfile,CLEfile,CLESfile
    real(dl) :: kintegrandS, kintegrandT, kintegrandTE
    integer :: count
    integer,allocatable :: kmaxInt(:)
    real(dl) :: prefac

    !required for limited stack size MacOsX + openmp



    if (AppLss) then 
       fnSLSS = Trim(homefolder)//Trim(NameTransferT)//Trim(Scaltxt)
       fnPolTLSS = Trim(homefolder)//Trim(NameTransferB)//Trim(PolTtxt)
       fnPolSLSS = Trim(homefolder)//Trim(NameTransferE)//Trim(PolStxt)
       CLSfile = Trim(homefolder)//Trim(rootnamecl)//trim('_clTT.txt')
       CLBfile = Trim(homefolder)//Trim(rootnamecl)//trim('_clBB.txt')
       CLEfile = Trim(homefolder)//Trim(rootnamecl)//trim('_clEEt.txt')
       CLESfile = Trim(homefolder)//Trim(rootnamecl)//trim('_clEE.txt')

    else
       fnSLSS = Trim(homefolder)//Trim(NameTransferT)//Trim('b')//Trim(Scaltxt)
       fnPolTLSS = Trim(homefolder)//Trim(NameTransferB)//Trim('b')//Trim(PolTtxt)
       fnPolSLSS = Trim(homefolder)//Trim(NameTransferE)//Trim('b')//Trim(PolStxt)
       CLSfile = Trim(homefolder)//Trim(rootnamecl)//trim('_clTTb.txt')
       CLBfile = Trim(homefolder)//Trim(rootnamecl)//trim('_clBBb.txt')
    endif
    if (scalars .and. Tmode) then
       allocate(TransferS(4,lmaxScal+10,2*lmaxScal))
       allocate(karrS(2*lmaxScal))
       allocate(ellarrS(lmaxScal+10))

       j = 0
       n = 1
       templ = lmin-1
       open(unit=21,file=fnSLSS, status='old')
       do i = 1, imax

          if(AppLSS) then 
             read(21,'(I4,3E17.7)',iostat=eof) ell, k, T1, T2
          else
             read(21,'(I4,5E17.7)',iostat=eof) ell, k, T1, T2, T3, T4
          endif
          !write(*,*) ell, k, T1, T2
          if (eof .ne. 0 ) exit !end of file
          if (ell > templ) then
             j = j + 1
             n = 1	
          endif
          !write(*,*) i
          templ = ell
          ellarrS(j) = ell
          karrS(n) = k
          TransferS(1,j,n) = T1
          TransferS(2,j,n) = T2
          TransferS(3,j,n) = T3
          TransferS(4,j,n) = T4
          n = n + 1		
       enddo
       intellmaxS = j
       intkmaxS = n-1
       close(21)
       public_intlmaxS = intellmaxS
    endif

    
    if (polarization .and. tensors) then

       allocate(TransferPolTens(4,lmaxPolTens+10,3*lmaxPolTens))
       allocate(karrPolTens(3*lmaxPolTens))
       allocate(ellarrPolTens(lmaxPoltens+10))
       j = 0
       n = 1
       templ = lmin-1
       open(unit=21,file=fnPolTLSS, status='old')
       do i = 1, imax
          if(AppLSS) then 
             read(21,'(I4,3E17.7)',iostat=eof) ell, k, T1, T2
          else
             read(21,'(I4,5E17.7)',iostat=eof) ell, k, T1, T2, T3, T4
          endif
          !if (j .eq. 10) write(*,*) s, k, tau, S1, S2, S3 
          if (eof .ne. 0 ) exit !end of file
          if (ell > templ) then

             j = j + 1
             n = 1

          endif
          templ = ell
          ellarrPolTens(j) = ell
          karrPolTens(n) = k
          TransferPolTens(1,j,n) = T1
          TransferPolTens(2,j,n) = T2
          TransferPolTens(3,j,n) = T3
          TransferPolTens(4,j,n) = T4
          n = n + 1		
       enddo
       intellmaxPolTens = j
       intkmaxPolTens = n-1
       close(21)
       !ell = 1000

       public_intlmaxPolTens = intellmaxPolTens

    endif


    if (polarization .and. scalars) then
       allocate(TransferPolScal(4,lmaxPolScal+10,3*lmaxPolScal))
       allocate(karrPolScal(3*lmaxPolScal))
       allocate(ellarrPolScal(lmaxPolScal+10))
       j = 0
       n = 1
       templ = lmin-1
       open(unit=21,file=fnPolSLSS, status='old')
       do i = 1, imax
          if(AppLSS) then 
             read(21,'(I4,3E17.7)',iostat=eof) ell, k, T1, T2
          else
             read(21,'(I4,5E17.7)',iostat=eof) ell, k, T1, T2, T3, T4
          endif
          !if (j .eq. 10) write(*,*) s, k, tau, S1, S2, S3 
          if (eof .ne. 0 ) exit !end of file
          if (ell > templ) then

             j = j + 1
             n = 1

          endif
          templ = ell
          ellarrPolScal(j) = ell
          karrPolScal(n) = k
          TransferPolScal(1,j,n) = T1
          TransferPolScal(2,j,n) = T2
          TransferPolScal(3,j,n) = T3
          TransferPolScal(4,j,n) = T4
          n = n + 1		
       enddo
       intellmaxPolScal = j
       intkmaxPolScal = n-1
       close(21)
       !ell = 1000

       public_intlmaxPolScal = intellmaxPolScal

    endif

    allocate(kmaxInt(2*lmaxScal))

    !determine intkmax per ell
!!$    do i = 1, intellmaxS
!!$       count = 1
!!$       do j = 1, intkmaxS
!!$          !this is just a crazy guess, but it works pretty well
!!$          !first of these is better, but second one is ok as well, and lowers 
!!$          !the sampling even more. This is necessary for bispectrum.
!!$          !if (karrS(j) .ge. 2.d0*sqrt(1.0*lmaxS)*sqrt(1.d0*ellarrS(i))/tau0) exit
!!$          if (karrS(j) .ge. 2.d0*(1.0*lmaxS)**(1./3.)*(1.d0*ellarrS(i))**(2./3.)/tau0) exit
!!$          count = count + 1
!!$       enddo
!!$       kmaxInt(i) = count-1
!!$       !write(*,*) ellarrS(i),kmaxInt(i)
!!$    enddo

    if (scalars .and. Tmode) then
       open(unit=21,file=CLSfile, status="replace")
       s = 1
       do j = 1, intellmaxS !loop over ell
          !this should work, even if you decide to use
          !a preset table in \ell for the Transfer functions. 
          ell = ellarrS(j)
          kintresS = 0.d0
          !flat sky TT 
          do i = 1, intkmaxS! kmaxInt(j) !Integrate over k
             if (i < intkmaxS) then 
                dkS = karrS(i+1) - karrS(i)
             else 
                dkS = karrS(i) - karrS(i-1)
             endif

             q2S1 = sqrt(karrS(i)**2+(ell/(tauRS-tau0))**2)
             q2S2 = sqrt(karrS(i+1)**2+(ell/(tauRS-tau0))**2)
             if (AppLSS) then 
                !recall j = ell, i = k
                kintegrandS = ((TransferS(1,j,i)**2+TransferS(2,j,i)**2)/q2S1**3 + &
                     (TransferS(1,j,i+1)**2+TransferS(2,j,i+1)**2)/q2S2**3)/2.0d0	
                !kintresS = kintresS + (TransferS(1,j,i)**2+TransferS(2,j,i)**2)*dkS/q2S**3
                kintresS = kintresS + kintegrandS*dkS
             else

                kintegrandS = ((TransferS(1,j,i)*TransferS(3,j,i) + & 
                     TransferS(2,j,i)*TransferS(4,j,i)) + &
                     (TransferS(1,j,i+1)*TransferS(3,j,i+1) + & 
                     TransferS(2,j,i+1)*TransferS(4,j,i+1)))/2.0d0
                kintresS = kintresS + kintegrandS*dkS
                !(TransferS(1,j,i)*TransferS(3,j,i) + & 
                !					TransferS(2,j,i)*TransferS(4,j,i))*dkS
             endif

          enddo
          if (AppLSS) then 
             !There is a 1/2pi from each a_l, then (2pi)^3 from the power spectrum, thus
             !leaving (2*pi). Since I did not include this pi, the following is C_l/(2pi) instead of C_l
             write(21,*) ell, CMBuK*(TauRS-Tau0)**2*As*ell*(ell+1.d0)*kintresS
             CLTT(j) =  CMBuK*As*(TauRS-Tau0)**2*kintresS
          else 
             write(21,*) ell, CMBuK*As*ell*(ell+1.d0)*kintresS
             CLTT(j) =  CMBuK*As*kintresS
          endif
       enddo
       close(21)
       
       deallocate(ellarrS)

       deallocate(TransferS)

       deallocate(karrS)

    endif
    
    if(polarization .and. tensors) then 
       open(unit=28,file=CLBfile, status="replace")
       open(unit=29,file=CLEfile, status="replace")

       s = 1
       do j = 1, intellmaxPoltens !loop over ell
          ell = ellarrPolTens(j)
          kintresTB = 0.d0
          kintresTE = 0.d0

          !flat sky TT 
          do i = 1, intkmaxPolTens !Integrate over k
             if (i < intkmaxPolTens) then 
                dkT = karrPolTens(i+1) - karrPolTens(i)
             else 
                dkT = karrPolTens(i) - karrPolTens(i-1)
             endif
             q2T = sqrt(karrPolTens(i)**2+(ell/(tauRT-tau0))**2)
             !write(*,*) karrT(i), q2T, karrT(i)/q2T 
             if (AppLSS) then 
                !this seems to lead to the best result. Not sure why, is not the same as Maresuke. if
                !-This is true for CAMB, where the source function was defined for B, i.e. S(B)
                !-We now changed this (Feb 2016) to CLASS source function S(P). They are correct and lead to a
                !good result.
                
                if(Bmode) then
                   prefac = karrPolTens(i)/q2T
                   kintresTB = kintresTB + prefac**2*(TransferPolTens(1,j,i)**2+TransferPolTens(2,j,i)**2)*dkT/q2T**3
                   !kintresTB = kintresTB + (TransferPolTens(1,j,i)**2+TransferPolTens(2,j,i)**2)*dkT/q2T**3
                endif
                if(Emode) then
                   prefac =  (ell/q2T/(TauRT-Tau0))**2
                   kintresTE = kintresTE + (2-prefac)**2*(TransferPolTens(1,j,i)**2+TransferPolTens(2,j,i)**2)*dkT/q2T**3
                endif
                !if (ell .eq. 100) write(*,*) karrT(i), q2T, kintresT
             else
                kintresTB = kintresTB + (TransferPolTens(1,j,i)*TransferPolTens(3,j,i) + & 
                     TransferPolTens(2,j,i)*TransferPolTens(4,j,i))*dkT
             endif

          enddo
          s = s + 1
          if (AppLSS) then !in muK^2. Compares correctly to full sky.  CMBuK*
             
             if (Bmode) then 
                write(28,*) ell, 4*CMBuK*As*TtoS*ell*(ell+1.d0)*kintresTB*(TauRT-Tau0)**2
                CLBB(j) =  4*CMBuK*kintresTB*As*TtoS*(TauRT-Tau0)**2
             endif
             if(Emode) then
                write(29,*) ell, CMBuK*As*ell*(ell+1.d0)*TtoS*kintresTE*(TauRT-Tau0)**2
                
                CLEEt(j) =  CMBuK*kintresTE*As*TtoS*(TauRT-Tau0)**2
             endif
             
          else
             write(28,*) ell, CMBuK*As*TtoS*ell*(ell+1.d0)*kintresTB
             CLBB(j) =  CMBuK*kintresTB*As*TtoS*(TauRT-Tau0)**2

          endif
       enddo
       close(28)
       close(29)
       deallocate(ellarrPolTens)
       deallocate(TransferPolTens)
       deallocate(karrPolTens)
    endif

     if(polarization .and. scalars) then 
       open(unit=29,file=CLESfile, status="replace")

       write(*,*) intellmaxPolScal
       do j = 1, intellmaxPolScal !loop over ell
          ell = ellarrPolScal(j)
          kintresTE = 0.d0

          !flat sky TT 
          do i = 1, intkmaxPolScal !Integrate over k
             if (i < intkmaxPolScal) then 
                dkT = karrPolScal(i+1) - karrPolScal(i)
             else 
                dkT = karrPolScal(i) - karrPolScal(i-1)
             endif
             q2T = sqrt(karrPolScal(i)**2+(ell/(tauRS-tau0))**2)
             q2T1 = sqrt(karrPolScal(i)**2+(ell/(tauRS-tau0))**2)
             q2T2 = sqrt(karrPolScal(i+1)**2+(ell/(tauRS-tau0))**2)
             !write(*,*) karrT(i), q2T, karrT(i)/q2T 
             if (AppLSS) then 

                prefac =  (ell/q2T/(TauRS-Tau0))**2
                kintresTE = kintresTE + prefac**2*(TransferPolScal(1,j,i)**2+TransferPolScal(2,j,i)**2)*dkT/q2T**3
                !kintegrandTE = ((TransferPolScal(1,j,i)**2+TransferPolScal(2,j,i)**2)/q2T1**3 + &
                 !    (TransferPolScal(1,j,i+1)**2+TransferPolScal(2,j,i+1)**2)/q2T2**3)/2.0d0	
                !kintresS = kintresS + (TransferS(1,j,i)**2+TransferS(2,j,i)**2)*dkS/q2S**3
                !kintresTE = kintresTE + kintegrandTE*dkT
                !write(*,*) kintresTE 
                !if (ell .eq. 100) write(*,*) karrT(i), q2T, kintresT
             else
                kintresTB = kintresTB + (TransferPolScal(1,j,i)*TransferPolScal(3,j,i) + & 
                     TransferPolScal(2,j,i)*TransferPolScal(4,j,i))*dkT
                write(*,*) kintresTE 

             endif

          enddo
          if (AppLSS) then !in muK^2. Compares correctly to full sky.  CMBuK*
                !(3/8) from CLASS
                write(29,*) ell, CMBuK*As*ell*(ell+1.d0)*kintresTE*(TauRS-Tau0)**2             
                CLEE(j) =  CMBuK*kintresTE*As*(TauRS-Tau0)**2
             
          else

          endif
       enddo
       close(29)
       deallocate(ellarrPolScal)
       deallocate(TransferPolScal)
       deallocate(karrPolScal)
    endif
    deallocate(kmaxInt)
  end subroutine Compute_CL_flat

  
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!BTT!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


  subroutine Compute_Blll_TTB_flat(shape, diag_only,testlmax, testkmax)
    !logical, intent(in) :: want_SN
    integer, intent(in) :: shape
    logical, intent(in) :: diag_only !only diagonal?
    integer, intent(in) :: testlmax, testkmax !for testing
    real(dl) :: DSN1, DSN2, B2, sigmaBTT
    integer  :: i, imax = 100000000, j, n, s, eof 
    real(dl), allocatable    :: TransferS(:,:,:) 
    real(dl), allocatable    :: TransferPolTens(:,:,:)
    real(dl), allocatable    :: TransferPolScal(:,:,:) 
    real(dl), allocatable    :: karrS(:), karrPolTens(:), karrPolScal(:)
    real(dl)    :: k, tau, T1, T2
    integer     :: intellmaxS, intellmaxPolTens, intellmaxPolScal, intellminPolTens
    integer     :: intkmaxS, intkmaxPolTens, intkmaxPolScal, templ
    !real(dl)    :: dkS, dkT, kintresS, kintresTB, kintresTE   
    real(dl)    :: dk1, dk2, kintres1, kintres2  
    integer 	:: ell, ell1, ell2, ell3, il, ellfac,deltaell
    integer     :: k1, k2
    real(dl)    :: q3a, q3b, kzSa, kzSb
    real(dl)    :: q1, q2, Fa, Fb, kta, ktb, TranTTemp1, TranTTemp2, kzTa, kzTb
    real(dl)    :: TranSTempCos1,TranSTempCos2,TranSTempSin1,TranSTempSin2
    integer, allocatable :: ellarrS(:), ellarrPolTens(:), ellarrPolScal(:)

    !integer 	:: ellarrS(2500), ellarrPolTens(1010)
    real(dl)    :: bispeca, bispecb

    real(dl), allocatable :: sp1t(:,:), sp2t(:,:), sp3t(:,:)
    real(dl), allocatable :: Blll(:,:,:)
    integer :: count
    real(dl) :: Rell
    integer,allocatable :: kmaxInt(:)
    character(120) :: B_BTTfile, SNfile, NoiseData 
    character(120) :: fnSLSS,fnPolTLSS,fnPolSLSS,CLTfile, CLSfile
    real(dl),allocatable :: TransferCos1(:,:,:), TransferCos2(:,:,:)  
    real(dl),allocatable :: TransferSin1(:,:,:), TransferSin2(:,:,:)  
    real(dl) :: SinFac
    integer :: l1, l2, l3, l1min
    !to lower the number of steps; currently does not work
    integer :: DownSample
    character(80) :: ShapeName
    real :: FlocalSW


    
    !just to be sure
    scalars  = .true. 
    polarization = .true. 
    !for now we can only do this. 
    AppLSS = .true.	
    !diag_only = .false.	
    if(diag_only) then 
       write(*,*) ""
       write(*,'(A31)') "Only computing single slice BTT"
    else
       write(*,*) ""
       write(*,'(A31)') "Computing Full BTT Bispectrum.."
       if(shape .eq. 1) then
          ShapeName  = 'Local       '
       elseif(shape .eq. 2) then
          ShapeName  = 'Equilateral '
       elseif(shape .eq. 3) then
          ShapeName  = 'Orthogonal  '
       elseif(shape .eq. 4) then
          ShapeName  = 'Flat/Enfoled'
       else
          ShapeName  = 'Unknown     '
       endif
       
       write(*,'(A6,X,A12)') "Shape:", ShapeName
    endif

    !required for limited stack size MacOsX + openmp
    !allocate(TransferS(2,2500,3000))
    !allocate(TransferT(2,2500,3000))

    allocate(TransferPolTens(3*lmaxPolTens,lmaxPolTens+10,4))
    allocate(karrPolTens(3*lmaxPolTens))
    allocate(ellarrPolTens(lmaxPoltens+10))
    allocate(TransferS(2*lmaxScal, lmaxScal+10, 4))
    allocate(karrS(2*lmaxScal))
    allocate(ellarrS(lmaxScal+10))
    allocate(kmaxInt(5000))

    if (AppLss) then 
       fnSLSS = Trim(homefolder)//Trim(NameTransferT)//Trim(Scaltxt)
       fnPolTLSS = Trim(homefolder)//Trim(NameTransferB)//Trim(PolTtxt)
       fnPolSLSS = Trim(homefolder)//Trim(NameTransferE)//Trim(PolStxt)
       B_BTTfile = Trim(homefolder)//Trim(rootnamebl)//trim('_BTT_SFSR2.txt')
    else
       fnSLSS = Trim(homefolder)//Trim(NameTransferT)//Trim('b')//Trim(Scaltxt)
       fnPolTLSS = Trim(homefolder)//Trim(NameTransferB)//Trim('b')//Trim(PolTtxt)
       fnPolSLSS = Trim(homefolder)//Trim(NameTransferE)//Trim('b')//Trim(PolStxt)
       B_BTTfile = Trim(homefolder)//Trim(rootnamebl)//trim('_Blll_BTTb.txt')
    endif
    j = 0
    n = 1
    templ = lmin-1
    open(unit=21,file=fnSLSS, status='old')
    do i = 1, imax

       read(21,'(I4,3E17.7)',iostat=eof) ell, k, T1, T2
       !write(*,*) ell, k, T1, T2
       if (eof < 0 ) exit !end of file
       if (ell > templ) then
          j = j + 1
          n = 1	
          !write(*,*) "Here!"
       endif
       !write(*,*) i
       templ = ell
       ellarrS(j) = ell
       karrS(n) = k
       TransferS(n,j,1) = T1
       TransferS(n,j,2) = T2
       n = n + 1		
    enddo
    intellmaxS = j
    intkmaxS = n-1
    close(21)
    write(*,'(A30)') "<<<<<<<<<<<<Scalars>>>>>>>>>>>>>"
    write(*,'(A25,I5)') "Number of ell in scal:     ", intellmaxS
    write(*,'(A25,I5)') "Number of k in scal:       ", intkmaxS
    write(*,'(A25,I5)') "Delta ell:                 ", ellarrS(2)-ellarrS(1)
    write(*,'(A25,F5.2)') "kmax:                      ", karrS(intkmaxS)
    write(*,'(A25,I5)') "lmax:                      ", ellarrS(intellmaxS)
    j = 0
    n = 1
    templ = lmin-1
    open(unit=21,file=fnPolTLSS, status='old')
    do i = 1, imax

       read(21,'(I4,3E17.7)',iostat=eof) ell, k, T1, T2
       !if (j .eq. 10) write(*,*) s, k, tau, S1, S2, S3 
       if (eof < 0 ) exit !end of file
       if (ell > templ) then

          j = j + 1
          n = 1

       endif
       templ = ell
       ellarrPolTens(j) = ell
       karrPolTens(n) = k
       TransferPolTens(n,j,1) = T1
       TransferPolTens(n,j,2) = T2
       n = n + 1		
    enddo
    intellmaxPolTens = j
    intkmaxPolTens = n-1
    close(21)
    !ell = 1000
    write(*,'(A30)') "<<<<<<<<<Polarization>>>>>>>>"
    write(*,'(A25,I5)') "Number of ell in tens:     ", intellmaxPolTens
    write(*,'(A25,I5)') "Number of k in tens:       ", intkmaxPolTens
    write(*,'(A25,I5)') "Delta ell:                 ", ellarrPolTens(2)-ellarrPolTens(1)
    write(*,'(A25,F5.2)') "kmax:                      ", karrPolTens(intkmaxPolTens)
    write(*,'(A25,I5)') "lmax:                      ", ellarrPolTens(intellmaxPolTens)

    !lmaxS = ellarrS(intellmaxS)
    do i = 1, intellmaxS
       count = 1
       do j = 1, intkmaxS
          !this is just a crazy guess, but it works pretty well
          !first of these is better, but second one is ok as well, and lowers 
          !the sampling even more. This is necessary for bispectrum.
          !if (karrS(j) .ge. 2.d0*sqrt(1.0*lmaxS)*sqrt(1.d0*ellarrS(i))/tau0) exit
          if (karrS(j) .ge. 2.d0*(1.0*ellarrS(intellmaxS))**(1./3.)*(1.d0*ellarrS(i))**(2./3.)/tau0) exit
          count = count + 1
       enddo
       if (testkmax .ne. 0) then 
          kmaxInt(i) = testkmax
       else
          kmaxInt(i) = count-1
       endif
       !write(*,*) ellarrS(i),kmaxInt(i)
    enddo
    !for testing:
    write(*,*) ""
    !for testing:
    if (testlmax .ne. 0) then 
       intellmaxS = testlmax 
       intellmaxPolTens = testlmax 
       write(*,'(A25,I5)') "test lmax:                 ", ellarrS(intellmaxS)
       write(*,'(A25,I5)') "test lmax:                 ", ellarrPolTens(intellmaxPolTens)
    endif
    !for testing
    if (testkmax .ne. 0) then 
       intkmaxS = testkmax
       intkmaxPolTens = 2*testkmax
       write(*,'(A25,F5.2)') "tens test kmax:            ", karrPolTens(intkmaxPolTens)
       write(*,'(A25,F5.2)') "scal test kmax:            ", karrS(intkmaxS)
    endif

    !lowering ellmaxT by hand:
    !intellmaxT = 256 !so for delta ell = 20, ell_max = 490
    !intellmaxS = 256

    write(*,'(A25,I5)') "testSlmax:                 ", ellarrS(intellmaxS)
    write(*,'(A25,I5)') "testTlmax:                 ", ellarrPolTens(intellmaxPolTens)
    allocate(TransferCos1(intkmaxS,intkmaxS,intellmaxPolTens))
    allocate(TransferCos2(intkmaxS,intkmaxS,intellmaxPolTens))

    allocate(TransferSin1(intkmaxS,intkmaxS,intellmaxPolTens))
    allocate(TransferSin2(intkmaxS,intkmaxS,intellmaxPolTens))

    i_progress = int(intellmaxPolTens/pstep)
    write(*,*) ""
    write(*,'(A52)') "Precomputing Spline Coefficients B-mode Polarization"
    do i = 1, pstep
       write(*,'(a)',advance='no')  '*'
    enddo
    write(*,*) ""

    allocate(Blll(intellmaxPolTens,intellmaxS,intellmaxS))
    !precompute at points needed. Using relatively fast interpolation scheme. Still slow. Extrapolation estimates it would take about
    !4 hours on my own machine for the full bispectrum. Have
    !thought how to make this faster, but seems impossible at this point. Using 32 cores would only require 30 minutes. 

    !$OMP PARALLEL DO DEFAUlT(SHARED) &
    !$OMP PRIVATE(j,i,s,ell3,k1,k2), &
    !$OMP PRIVATE(kzTa,kzTb), &
    !$OMP PRIVATE(TranSTempSin1,TranSTempSin2), &
    !$OMP PRIVATE(TranSTempCos1,TranSTempCos2)
    do s = 1, intellmaxPolTens
       ell3  = ellarrPolTens(s)
       !write(*,*) ell3
       do k1 = 1, intkmaxS
          !write(*,*) k1
          do k2 = 1, intkmaxS 
             !it is the sum of the k of the two scalars. These will generally be larger. 
             !To accomodate, you can increase ell max for tensors when precomputing the 
             !source functions. I might do that
             kzTa = karrS(k1)+karrS(k2)

             if(kzTa .ge. karrPolTens(intkmaxPolTens)) then 
                !associated transfer functions set to zero. 
                TransferCos1(k2,k1,s) = 0.d0
                TransferSin1(k2,k1,s) = 0.d0
             else
                call linint(kzTa,TranSTempCos1,karrPolTens(1:intkmaxPolTens),TransferPolTens(1:intkmaxPolTens,s,2),intkmaxPolTens)
                call linint(kzTa,TranSTempSin1,karrPolTens(1:intkmaxPolTens),TransferPolTens(1:intkmaxPolTens,s,1),intkmaxPolTens)
                TransferCos1(k2,k1,s) = TranSTempCos1
                TransferSin1(k2,k1,s) = TranSTempSin1
             endif
          enddo
          do k2 = 1, intkmaxS 
             !write(*,*) TranSTempSin1
             kzTb = abs(karrS(k1)-karrS(k2))
             !otherwise, out of range:
             if (kzTb .ge. karrPolTens(intkmaxPolTens)) then 
                !associated transfer functions set to zero:
                TransferCos2(k2,k1,s) = 0.d0
                TransferSin2(k2,k1,s) = 0.d0
             else
                call linint(kzTb,TranSTempCos2,karrPolTens(1:intkmaxPolTens),TransferPolTens(1:intkmaxPolTens,s,2),intkmaxPolTens)
                call linint(kzTb,TranSTempSin2,karrPolTens(1:intkmaxPolTens),TransferPolTens(1:intkmaxPolTens,s,1),intkmaxPolTens)
                !if (ell3 .eq. 100 .and. k1 .eq. 100) write(*,*) kzSa,TranSTemp1, karrS(k2),TransferS(2,s,k2) 

                TransferCos2(k2,k1,s) = TranSTempCos2
                !sine changes sign. 
                if(k2 .ge. k1) then 
                   TransferSin2(k2,k1,s) = -TranSTempSin2
                else
                   TransferSin2(k2,k1,s) = TranSTempSin2
                endif
             endif
          enddo

       enddo
       if(mod(s,i_progress) .eq. 0) write(*,'(a)',advance='no')  '*'
    enddo
    !$OMP END PARALLEL DO

    !deallocate
    deallocate(karrPolTens)

    !split up the B-loop into pieces. This should work
    !to speed up code (run on multiple cores)
    intellminPolTens = 1
    DownSample = 1 !only compute every 'DownSample' times. Works, but not yet with S/N.
    !intellmaxT = 2
    write(*,*) ""

    write(*,'(A40)') "<<<<<<<<<<Computing Bispectrum>>>>>>>>>>"
    open(unit=28,file=B_BTTfile, status="replace")

    if(diag_only) then 
       !$OMP PARALLEL DO DEFAUlT(SHARED)  &
       !$OMP PRIVATE(ell1,ell2,ell3,j,i,s,k1,k2), &
       !$OMP PRIVATE(q1,q2,kzSa,kzSb,q3a,q3b,dk2,dk1,kta,ktb), &
       !$OMP PRIVATE(kintres2,kintres1,bispeca,bispecb,Fa,Fb,SinFac, FlocalSW)
       do j = 136, intellmaxS  !loop over ells, was 136
          !ell2 = ellarrS(j)
          !ell3 = ell2
          !ell1 = 100
          i = j - 5
          !j = i + 20
          s = 76
          ell1 = ellarrS(j)
          ell2 = ellarrS(i)
          ell3 = ellarrPolTens(s)

	  SinFac = 1!sqrt(1.d0-((ell1**2+ell3**2-ell2**2)/(2.d0*ell1*ell3))**2)
          !write(*,*) SinFac
          !for pairs of values that lead to NAN sine, cycle loop
          !These do not satisfy triangle constraint according to Joel. 
          if(SinFac .ne. Sinfac) then
       	         Blll(s,i,j) = 0.d0
      	         cycle
                 !removes all modes with zero outcome
          endif
          !write(*,*) ell1, ell2, ell3
          !s = 10
          ! ell3 = ellarrS(s) !any number below ellmaxT (so 500). 
          !reset:
          kintres1 = 0.0d0
          do k1 = 1,  kmaxInt(j) !intkmaxS !integrals over k. 
             dk1 = karrS(k1+1) - karrS(k1)
             kintres2 = 0.0d0
             do k2 = 1, kmaxInt(i) !intkmaxS ! 


                dk2 = karrS(k2+1) - karrS(k2)

                q1 = sqrt(karrS(k1)**2+(ell1/(tauRS-tau0))**2)
                q2 = sqrt(karrS(k2)**2+(ell2/(tauRS-tau0))**2)

                kzSa = karrS(k1)+karrS(k2)
                kzSb = karrS(k1)-karrS(k2)

                q3a = sqrt((kzSa)**2+(ell3/(tauRT-tau0))**2)
                q3b = sqrt((kzSb)**2+(ell3/(tauRT-tau0))**2)

                kta = q1 + q2 + q3a
                ktb = q1 + q2 + q3b

                !shape, see notes (this is prop to 1/k^8)
                !bispeca = (-kta + (q1*q2+q2*q3a+q3a*q1)/kta + q1*q2*q3a/kta**2)/(q1*q2*q3a)**3
                !bispecb = (-ktb + (q1*q2+q2*q3b+q3b*q1)/ktb + q1*q2*q3b/ktb**2)/(q1*q2*q3b)**3 


		!my new USR shapes, proportional to 1/k^6 ((q1**2 + q2**2)/2)**3*
		!bispeca = ((q1**2 + q2**2)/2)**3*q3a**2/(q1**2*q2**2)*(72/kta**3 + &
		!	72/kta**5*(2*q1**2 + 2*q2**2 + 3*(q1*q2+q2*q3a+q3a*q1)) + &
		!	360/kta**6*((q1 + q2)*(q1**2 + q1*q2 + q2**2) + q3a*(q1**2 + 3*q1*q2 + q2**2)) + &
		!	2160*q1*q2/kta**7*(q1**2 + q2**2 + q1*q2 + q2*q3a + q3a*q1) + 5040*q1**2*q2**2/kta**7)/(q1*q2*q3a)**3
		!bispecb = ((q1**2 + q2**2)/2)**3*q3b**2/(q1**2*q2**2)*(72/ktb**3 + &
		!	72/ktb**5*(2*q1**2 + 2*q2**2 + 3*(q1*q2+q2*q3b+q3b*q1)) + &
		!	360/ktb**6*((q1 + q2)*(q1**2 + q1*q2 + q2**2) + q3b*(q1**2 + 3*q1*q2 + q2**2)) + &
		!	2160*q1*q2/ktb**7*(q1**2 + q2**2 + q1*q2 + q2*q3b + q3b*q1) + 5040*q1**2*q2**2/ktb**7)/(q1*q2*q3b)**3
		


		bispeca = 1.d0/(q1*q2)**3 + 1.d0/(q3a*q2)**3 + 1.d0/(q3a*q1)**3
                bispecb = 1.d0/(q1*q2)**3 + 1.d0/(q3b*q2)**3 + 1.d0/(q3b*q1)**3
                !local:
                if(shape .eq. 1) then 
                   bispeca = bispeca/(q1*q2)
                   bispecb = bispecb/(q1*q2)
                endif
                !equilateral, same story. Also included rel. normalization.
                if(shape .eq. 2) then 
                   bispeca = 3.d0*(-bispeca-2.d0/(q1*q2*q3a)**2+1.d0/(q3a*q1**2*q2**3)+1.d0/(q1*q3a**2*q2**3) + &
                        1.d0/(q1*q2**2*q3a**3) + 1.d0/(q3a*q2**2*q1**3) + 1.d0/(q2*q1**2*q3a**3) + &
                        1.d0/(q2*q3a**2*q1**3))/(q1*q2)
                   bispecb = 3.d0*(-bispecb-2.d0/(q1*q2*q3b)**2+1.d0/(q3b*q1**2*q2**3)+1.d0/(q1*q3b**2*q2**3) + &
                        1.d0/(q1*q2**2*q3b**3) + 1.d0/(q3b*q2**2*q1**3) + 1.d0/(q2*q1**2*q3b**3) + &
                        1.d0/(q2*q3b**2*q1**3))/(q1*q2)
                endif

                !orthogonal, same story. Also included rel. normalization.
                if(shape .eq. 3) then
                   bispeca = 3.d0*(-3.0*bispeca-8.d0/(q1*q2*q3a)**2+3.d0/(q3a*q1**2*q2**3)+3.d0/(q1*q3a**2*q2**3) + &
                        3.d0/(q1*q2**2*q3a**3) + 3.d0/(q3a*q2**2*q1**3) + 3.d0/(q2*q1**2*q3a**3) + &
                        3.d0/(q2*q3a**2*q1**3))/(q1*q2)
                   bispecb = 3.d0*(-3.0*bispecb-8.d0/(q1*q2*q3b)**2+3.d0/(q3b*q1**2*q2**3)+3.d0/(q1*q3b**2*q2**3) + &
                        3.d0/(q1*q2**2*q3b**3) + 3.d0/(q3b*q2**2*q1**3) + 3.d0/(q2*q1**2*q3b**3) + &
                        3.d0/(q2*q3b**2*q1**3))/(q1*q2)
                endif

                !flat or enfolded:
                if(shape .eq. 4) then
                   bispeca = 3.d0*(bispeca+3.d0/(q1*q2*q3a)**2-1.d0/(q3a*q1**2*q2**3)-1.d0/(q1*q3a**2*q2**3) - &
                        1.d0/(q1*q2**2*q3a**3) - 1.d0/(q3a*q2**2*q1**3) - 1.d0/(q2*q1**2*q3a**3) - &
                        1.d0/(q2*q3a**2*q1**3))/(q1*q2)
                   bispecb = 3.d0*(bispecb+3.d0/(q1*q2*q3b)**2-1.d0/(q3b*q1**2*q2**3)-1.d0/(q1*q3b**2*q2**3) - &
                        1.d0/(q1*q2**2*q3b**3) - 1.d0/(q3b*q2**2*q1**3) - 1.d0/(q2*q1**2*q3b**3) - &
                        1.d0/(q2*q3b**2*q1**3))/(q1*q2)
                endif


       	        !SFSR shape
  	        if(shape .eq. 5) then
	           bispeca = (-kta + (q1*q2+q2*q3a+q3a*q1)/kta + q1*q2*q3a/kta**2)/(q1**2*q2**2*q3a**3)/(q1*q2)
                   bispecb = (-ktb + (q1*q2+q2*q3b+q3b*q1)/ktb + q1*q2*q3b/ktb**2)/(q1**2*q2**2*q3b**3)/(q1*q2)
  	        end if

	        !USR shape
	        if(shape .eq. 6) then
  	           bispeca = ((q1**2 + q2**2)/2)**3*q3a**2/q1/q2*(72/kta**3 + 72/kta**5*(2*q1**2 + 2*q2**2 + 3*(q1*q2+q2*q3a+q3a*q1)) + &
  	       	      360/kta**6*((q1 + q2)*(q1**2 + q1*q2 + q2**2) + q3a*(q1**2 + 3*q1*q2 + q2**2)) + &
	    	      2160*q1*q2/kta**7*(q1**2 + q2**2 + q1*q2 + q2*q3a + q3a*q1) + 5040*q1**2*q2**2/kta**7)/(q1*q2*q3a)**3/(q1*q2)
	           bispecb = ((q1**2 + q2**2)/2)**3*q3b**2/q1/q2*(72/ktb**3 + 72/ktb**5*(2*q1**2 + 2*q2**2 + 3*(q1*q2+q2*q3b+q3b*q1)) + &
 		      360/ktb**6*((q1 + q2)*(q1**2 + q1*q2 + q2**2) + q3b*(q1**2 + 3*q1*q2 + q2**2)) + &
		      2160*q1*q2/ktb**7*(q1**2 + q2**2 + q1*q2 + q2*q3b + q3b*q1) + 5040*q1**2*q2**2/ktb**7)/(q1*q2*q3b)**3/(q1*q2)
  	        end if
                !this factor is prop to k^2; so Fa*bispeca prop to 1/k^6 as it should
                Fa =-ell1**2/(tau0-tauRS)**2*(ell1**2+ell3**2-ell2**2)/2.d0/ell1/ell3*(kzSa/q3a)**2 + &
                     ell1*ell3/(tau0-tauRS)**2*(karrS(k1)/q3a)*(kzSa/q3a) 
                !Fa =ell1*ell3/(tau0-tauRS)**2/q3a**2*(karrS(k1)**2-karrS(k2)**2)/2.d0
                Fb =-ell1**2/(tau0-tauRS)**2*(ell1**2+ell3**2-ell2**2)/2.d0/ell1/ell3*(kzSb/q3b)**2 + &
                     ell1*ell3/(tau0-tauRS)**2*(karrS(k1)/q3b)*(kzSb/q3b)
                !Fb =ell1*ell3/(tau0-tauRS)**2/q3b**2*(karrS(k1)**2-karrS(k2)**2)/2.d0

                !note that this is effectively the same as TTT: 
                kintres2 = kintres2 +  (Fa*bispeca*TransferCos1(k2,k1,s)*(TransferS(k2,j,1)*TransferS(k2,i,2) - & 
                     TransferS(k1,j,1)*TransferS(k2,i,1)) + &
                     Fa*bispeca*TransferSin1(k2,k1,s)*(TransferS(k1,j,1)*TransferS(k2,i,2) + & 
                     TransferS(k1,j,2)*TransferS(k2,i,1)) + &
                     Fb*bispecb*TransferCos2(k2,k1,s)*(TransferS(k1,j,2)*TransferS(k2,i,2) + & 
                     TransferS(k1,j,1)*TransferS(k2,i,1)) + &
                     Fb*bispecb*TransferSin2(k2,k1,s)*(TransferS(k1,j,1)*TransferS(k2,i,2) - & 
                     TransferS(k1,j,2)*TransferS(k2,i,1)))*dk2

             enddo
             !integration over k1
             kintres1  = kintres1+kintres2*dk1

          enddo
          !Babich, page 3 (local norm), for f_NL = 1
          !only (2 pi)^2 because the bispectrum is devided by (2 pi)^2
          !the factor 4 comes from the trigonometric identities above
          !As^2 is the amplitude of the primordial power spectrum 
          !If it is ok, we could add this to the paper as evidence that we got this right (even as a insanity check). 
          !the only problem would be that local NGS would get most of their signal to noise from the squeezed limit
          !although, I think it is not as bad as for the bias. 
          !Blll(s,i,j) = kintres1
          !Blll(j,i,s) = kintres1
          !cosine factor
          FlocalSW = 1./(ell1*(ell1+1.)*ell2*(ell2+1.)) + 1./(ell1*(ell1+1.)*ell3*(ell3+1.)) + 1./(ell3*(ell3+1.)*ell2*(ell2+1.))
          if(wantRelFlocal) then 
          	Blll(s,i,j) = (4.d0*pi)**2*sqrt(2.d0)*(tau0-tauRS)**2*kintres1*As**2*(COBE_CMBTemp*1d6)**3*SinFac/FlocalSW
          else
		Blll(s,i,j) = (4.d0*pi)**2*sqrt(2.d0)*(tau0-tauRS)**2*kintres1*As**2*(COBE_CMBTemp*1d6)**3*SinFac
	  endif
          !here we go. These will not be printed in order:
          write(28,'(3I5,2E17.7)') ell1, ell2, ell3, Blll(s,i,j), FlocalSW

          write(*,'(3I5,2E17.7)') ell1, ell2, ell3, Blll(s,i,j), SinFac

       enddo
       !$OMP END PARALLEL DO 
    else
       !makeSCHEDULE(DYNAMIC)
       !you want to do dynamic omp because the outer loop is slow for low values of ell1
       !you can probably optimze this by adjusting chunks (default = 1, works pretty good, factor of 3 improv)
       !$OMP PARALLEL DO DEFAUlT(SHARED) SCHEDULE(DYNAMIC), &
       !$OMP PRIVATE(ell1,ell2,ell3,j,i,s,k1,k2), &
       !$OMP PRIVATE(q1,q2,kzSa,kzSb,q3a,q3b,dk2,dk1,kta,ktb), &
       !$OMP PRIVATE(kintres2,kintres1,bispeca,bispecb,Fa,Fb,SinFac)
       do j = 1, intellmaxS, DownSample !loop over ells
          ell1 = ellarrS(j)
          !write(*,*) ell1
          do i = j, intellmaxS, DownSample !only for i .ge. j
             ell2 = ellarrS(i)
             do s = intellminPolTens, intellmaxPolTens, DownSample !should do all ell
                ell3 = ellarrPolTens(s)
                SinFac = sqrt(1.d0-((ell1**2+ell3**2-ell2**2)/(2.d0*ell1*ell3))**2)
                !for pairs of values that lead to NAN sine, cycle loop
                !These do not satisfy triangle constraint according to Joel. 
                if(SinFac .ne. Sinfac) then
                   Blll(s,i,j) = 0.d0
                   cycle
                   !removes all modes with zero outcome
                endif
                kintres1 = 0.0d0
                do k1 = 1, kmaxInt(j) !integrals over k. 
                   dk1 = karrS(k1+1) - karrS(k1)
                   kintres2 = 0.0d0
                   do k2 = 1, kmaxInt(i) 		

                      dk2 = karrS(k2+1) - karrS(k2)

                      q1 = sqrt(karrS(k1)**2+(ell1/(tauRS-tau0))**2)
                      q2 = sqrt(karrS(k2)**2+(ell2/(tauRS-tau0))**2)

                      kzSa = karrS(k1)+karrS(k2)
                      kzSb = karrS(k1)-karrS(k2)

                      q3a = sqrt((kzSa)**2+(ell3/(tauRT-tau0))**2)
                      q3b = sqrt((kzSb)**2+(ell3/(tauRT-tau0))**2)

                      kta = q1 + q2 + q3a
                      ktb = q1 + q2 + q3b

                      !shape, see notes (this is prop to 1/k^8)
                      !bispeca = (-kta + (q1*q2+q2*q3a+q3a*q1)/kta + q1*q2*q3a/kta**2)/(q1*q2*q3a)**3
                      !bispecb = (-ktb + (q1*q2+q2*q3b+q3b*q1)/ktb + q1*q2*q3b/ktb**2)/(q1*q2*q3b)**3 
                      !trying some alternatives (looks like flat):
                      !bispeca = (q1*q2*q3a/kta**2)/(q1*q2*q3a)**3
                      !bispecb = (q1*q2*q3b/ktb**2)/(q1*q2*q3b)**3
                      !local, has to be 1/k^7 and symmetric in k1 and k2:


                      bispeca = 1.d0/(q1*q2)**3 + 1.d0/(q3a*q2)**3 + 1.d0/(q3a*q1)**3
                      bispecb = 1.d0/(q1*q2)**3 + 1.d0/(q3b*q2)**3 + 1.d0/(q3b*q1)**3
                      !local:
                      if(shape .eq. 1) then 
                         bispeca = bispeca/(q1*q2)
                         bispecb = bispecb/(q1*q2)
                      endif
                      !equilateral, same story. Also included rel. normalization.
                      if(shape .eq. 2) then 
                         bispeca = 3.d0*(-bispeca-2.d0/(q1*q2*q3a)**2+1.d0/(q3a*q1**2*q2**3)+1.d0/(q1*q3a**2*q2**3) + &
                              1.d0/(q1*q2**2*q3a**3) + 1.d0/(q3a*q2**2*q1**3) + 1.d0/(q2*q1**2*q3a**3) + &
                              1.d0/(q2*q3a**2*q1**3))/(q1*q2)
                         bispecb = 3.d0*(-bispecb-2.d0/(q1*q2*q3b)**2+1.d0/(q3b*q1**2*q2**3)+1.d0/(q1*q3b**2*q2**3) + &
                              1.d0/(q1*q2**2*q3b**3) + 1.d0/(q3b*q2**2*q1**3) + 1.d0/(q2*q1**2*q3b**3) + &
                              1.d0/(q2*q3b**2*q1**3))/(q1*q2)
                      endif

                      !orthogonal, same story. Also included rel. normalization.
                      if(shape .eq. 3) then
                         bispeca = 3.d0*(-3.0*bispeca-8.d0/(q1*q2*q3a)**2+3.d0/(q3a*q1**2*q2**3)+3.d0/(q1*q3a**2*q2**3) + &
                              3.d0/(q1*q2**2*q3a**3) + 3.d0/(q3a*q2**2*q1**3) + 3.d0/(q2*q1**2*q3a**3) + &
                              3.d0/(q2*q3a**2*q1**3))/(q1*q2)
                         bispecb = 3.d0*(-3.0*bispecb-8.d0/(q1*q2*q3b)**2+3.d0/(q3b*q1**2*q2**3)+3.d0/(q1*q3b**2*q2**3) + &
                              3.d0/(q1*q2**2*q3b**3) + 3.d0/(q3b*q2**2*q1**3) + 3.d0/(q2*q1**2*q3b**3) + &
                              3.d0/(q2*q3b**2*q1**3))/(q1*q2)
                      endif

                      !flat or enfolded:
                      if(shape .eq. 4) then
                         bispeca = 3.d0*(bispeca+3.d0/(q1*q2*q3a)**2-1.d0/(q3a*q1**2*q2**3)-1.d0/(q1*q3a**2*q2**3) - &
                              1.d0/(q1*q2**2*q3a**3) - 1.d0/(q3a*q2**2*q1**3) - 1.d0/(q2*q1**2*q3a**3) - &
                              1.d0/(q2*q3a**2*q1**3))/(q1*q2)
                         bispecb = 3.d0*(bispecb+3.d0/(q1*q2*q3b)**2-1.d0/(q3b*q1**2*q2**3)-1.d0/(q1*q3b**2*q2**3) - &
                              1.d0/(q1*q2**2*q3b**3) - 1.d0/(q3b*q2**2*q1**3) - 1.d0/(q2*q1**2*q3b**3) - &
                              1.d0/(q2*q3b**2*q1**3))/(q1*q2)
                      endif


	   	      !SFSR shape
		      if(shape .eq. 5) then
		         bispeca = (-kta + (q1*q2+q2*q3a+q3a*q1)/kta + q1*q2*q3a/kta**2)/(q1**2*q2**2*q3a**3)/(q1*q2)
                         bispecb = (-ktb + (q1*q2+q2*q3b+q3b*q1)/ktb + q1*q2*q3b/ktb**2)/(q1**2*q2**2*q3b**3)/(q1*q2)
		      end if

		      !USR shape
		      if(shape .eq. 6) then
		         bispeca = ((q1**2 + q2**2)/2)**3*q3a**2/q1/q2*(72/kta**3 + 72/kta**5*(2*q1**2 + 2*q2**2 + 3*(q1*q2+q2*q3a+q3a*q1)) + &
		    	      360/kta**6*((q1 + q2)*(q1**2 + q1*q2 + q2**2) + q3a*(q1**2 + 3*q1*q2 + q2**2)) + &
			      2160*q1*q2/kta**7*(q1**2 + q2**2 + q1*q2 + q2*q3a + q3a*q1) + 5040*q1**2*q2**2/kta**7)/(q1*q2*q3a)**3/(q1*q2)
		         bispecb = ((q1**2 + q2**2)/2)**3*q3b**2/q1/q2*(72/ktb**3 + 72/ktb**5*(2*q1**2 + 2*q2**2 + 3*(q1*q2+q2*q3b+q3b*q1)) + &
			      360/ktb**6*((q1 + q2)*(q1**2 + q1*q2 + q2**2) + q3b*(q1**2 + 3*q1*q2 + q2**2)) + &
			      2160*q1*q2/ktb**7*(q1**2 + q2**2 + q1*q2 + q2*q3b + q3b*q1) + 5040*q1**2*q2**2/ktb**7)/(q1*q2*q3b)**3/(q1*q2)
		      end if

                      !this factor is prop to k^2; so Fa*bispeca prop to 1/k^6 as it should
                      Fa =-ell1**2/(tau0-tauRS)**2*(ell1**2+ell3**2-ell2**2)/2.d0/ell1/ell3*(kzSa/q3a)**2 + &
                           ell1*ell3/(tau0-tauRS)**2*(karrS(k1)/q3a)*(kzSa/q3a) 
                      !Fa =ell1*ell3/(tau0-tauRS)**2/q3a**2*(karrS(k1)**2-karrS(k2)**2)/2.d0
                      Fb =-ell1**2/(tau0-tauRS)**2*(ell1**2+ell3**2-ell2**2)/2.d0/ell1/ell3*(kzSb/q3b)**2 + &
                           ell1*ell3/(tau0-tauRS)**2*(karrS(k1)/q3b)*(kzSb/q3b)
                      !Fb =ell1*ell3/(tau0-tauRS)**2/q3b**2*(karrS(k1)**2-karrS(k2)**2)/2.d0

                      !note that this is effectively the same as TTT:
                      kintres2 = kintres2 +  (Fa*bispeca*TransferCos1(k2,k1,s)*(TransferS(k1,j,2)*TransferS(k2,i,2) - & 
                           TransferS(k1,j,1)*TransferS(k2,i,1)) + &
                           Fa*bispeca*TransferSin1(k2,k1,s)*(TransferS(k1,j,1)*TransferS(k2,i,2) + & 
                           TransferS(k1,j,2)*TransferS(k2,i,1)) + &
                           Fb*bispecb*TransferCos2(k2,k1,s)*(TransferS(k1,j,2)*TransferS(k2,i,2) + & 
                           TransferS(k1,j,1)*TransferS(k2,i,1)) + &
                           Fb*bispecb*TransferSin2(k2,k1,s)*(TransferS(k1,j,1)*TransferS(k2,i,2) - & 
                           TransferS(k1,j,2)*TransferS(k2,i,1)))*dk2

                   enddo
                   kintres1  = kintres1+kintres2*dk1

                enddo
                !bispectrum (up to some factors) In (mu K)^2
                Blll(s,i,j) = (4.d0*pi)**2*sqrt(2.d0)*(tau0-tauRS)**2*kintres1*As**2*(COBE_CMBTemp*1d6)**3*SinFac
                !write(*,'(3I5, E17.7)') ell1, ell2, ell3, Blll(s,i,j)
                !here we go. These will not be printed in order:

                !for check write the diagonal
                if(ell1 .eq. ell2 .and. ell2 .eq. ell3) write(*,'(3I5, E17.7)') ell1, ell2, ell3, Blll(s,i,j)
             enddo
          enddo

       enddo
       !$OMP END PARALLEL DO 
    endif
    !deallocate all that is not needed:
    deallocate(TransferCos1)
    deallocate(TransferCos2)
    deallocate(TransferSin1)
    deallocate(TransferSin2)
    deallocate(TransferS)
    deallocate(TransferPolTens)
    deallocate(karrS)
    deallocate(kmaxInt)
    if(diag_only) then 
       close(28) 
    else 
       do j = 1, intellmaxS, DownSample !loop over ells
          ell1 = ellarrS(j)
          !write(*,*) ell1
          do i = j, intellmaxS, DownSample !only for i .ge. j
             ell2 = ellarrS(i)
             do s = intellminPolTens, intellmaxPoltens, DownSample !should do all ell   
                ell3 = ellarrPolTens(s)
                write(28,'(3I5, E17.7)') ell1, ell2, ell3, Blll(s,i,j)
                !association. Needed for S/N. 
                Blll(s,j,i) = Blll(s,i,j)
             enddo
          enddo
       enddo
       close(28)
    endif
    !final deallocation
    deallocate(Blll)
    deallocate(ellarrPolTens)
    deallocate(ellarrS)

  end subroutine Compute_Blll_TTB_flat
  


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!BTE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  
  subroutine Compute_Blll_ETB_flat(shape, diag_only,testlmax, testkmax)
    !logical, intent(in) :: want_SN
    integer, intent(in) :: shape
    logical, intent(in) :: diag_only !only diagonal?
    integer, intent(in) :: testlmax, testkmax !for testing
    real(dl) :: DSN1, DSN2, B2, sigmaBTE
    integer  :: i, imax = 100000000, j, n, s, eof 
    real(dl), allocatable    :: TransferS(:,:,:) 
    real(dl), allocatable    :: TransferPolTens(:,:,:)
    real(dl), allocatable    :: TransferPolScal(:,:,:) 
    real(dl), allocatable    :: karrS(:), karrPolTens(:), karrPolScal(:)
    real(dl)    :: k, tau, T1, T2
    integer     :: intellmaxS, intellmaxPolTens, intellmaxPolScal,intellminPolTens
    integer     :: intkmaxS, intkmaxPolTens, intkmaxPolScal, templ
    !real(dl)    :: dkS, dkT, kintresS, kintresTB, kintresTE   
    real(dl)    :: dk1, dk2, kintres1, kintres2  
    integer 	:: ell, ell1, ell2, ell3, il, ellfac,deltaell
    integer     :: k1, k2
    real(dl)    :: q3a, q3b, kzSa, kzSb
    real(dl)    :: q1, q2, Fa, Fb, kta, ktb, TranTTemp1, TranTTemp2, kzTa, kzTb
    real(dl)    :: TranSTempCos1,TranSTempCos2,TranSTempSin1,TranSTempSin2
    integer, allocatable :: ellarrS(:), ellarrPolTens(:), ellarrPolScal(:)

    !integer 	:: ellarrS(2500), ellarrPolTens(1010)
    real(dl)    :: bispeca, bispecb

    real(dl), allocatable :: sp1t(:,:), sp2t(:,:), sp3t(:,:)
    real(dl), allocatable :: Blll(:,:,:)
    integer :: count
    real(dl) :: Rell
    integer,allocatable :: kmaxIntT(:), kmaxIntE(:)
    character(120) :: B_BTEfile, SNfile, NoiseData 
    character(120) :: fnSLSS,fnPolTLSS,fnPolSLSS,CLTfile, CLSfile
    real(dl),allocatable :: TransferCos1(:,:,:), TransferCos2(:,:,:)  
    real(dl),allocatable :: TransferSin1(:,:,:), TransferSin2(:,:,:)  
    real(dl) :: SinFac
    integer :: l1, l2, l3, l1min
    !to lower the number of steps; currently does not work
    integer :: DownSample
    character(80) :: ShapeName
    real :: FlocalSW



    !just to be sure
    scalars  = .true. 
    polarization = .true. 
    !for now we can only do this. 
    AppLSS = .true.	
    !diag_only = .false.	
    if(diag_only) then 
       write(*,*) ""
       write(*,'(A31)') "Only computing single slice BTE"
    else
       write(*,*) ""
       write(*,'(A31)') "Computing Full BTE Bispectrum.."
       if(shape .eq. 1) then
          ShapeName  = 'Local       '
       elseif(shape .eq. 2) then
          ShapeName  = 'Equilateral '
       elseif(shape .eq. 3) then
          ShapeName  = 'Orthogonal  '
       elseif(shape .eq. 4) then
          ShapeName  = 'Flat/Enfoled'
       elseif(shape .eq. 5) then
          ShapeName  = 'SFSR        '
       elseif(shape .eq. 6) then
          ShapeName  = 'USR         '
       else
          ShapeName  = 'Unknown     '
       endif

       write(*,'(A6,X,A12)') "Shape:", ShapeName
    endif

    !required for limited stack size MacOsX + openmp
    !allocate(TransferS(2,2500,3000))
    !allocate(TransferT(2,2500,3000))

    allocate(TransferPolTens(3*lmaxPolTens,lmaxPolTens+10,4))
    allocate(karrPolTens(3*lmaxPolTens))
    allocate(ellarrPolTens(lmaxPoltens+10))

    allocate(TransferPolScal(2*lmaxPolScal,lmaxPolScal+10,4))
    allocate(karrPolScal(2*lmaxPolScal))
    allocate(ellarrPolScal(lmaxPolScal+10))

    allocate(TransferS(2*lmaxScal, lmaxScal+10, 4))
    allocate(karrS(2*lmaxScal))
    allocate(ellarrS(lmaxScal+10))

    allocate(kmaxIntT(5000))
    allocate(kmaxIntE(5000))

    if (AppLss) then 
       fnSLSS = Trim(homefolder)//Trim(NameTransferT)//Trim(Scaltxt)
       fnPolTLSS = Trim(homefolder)//Trim(NameTransferB)//Trim(PolTtxt)
       fnPolSLSS = Trim(homefolder)//Trim(NameTransferE)//Trim(PolStxt)
       B_BTEfile = Trim(homefolder)//Trim(rootnamebl)//trim('_BTE_local.txt')
    else
       fnSLSS = Trim(homefolder)//Trim(NameTransferT)//Trim('b')//Trim(Scaltxt)
       fnPolTLSS = Trim(homefolder)//Trim(NameTransferB)//Trim('b')//Trim(PolTtxt)
       fnPolSLSS = Trim(homefolder)//Trim(NameTransferE)//Trim('b')//Trim(PolStxt)
       B_BTEfile = Trim(homefolder)//Trim(rootnamebl)//trim('_Blll_BTEb.txt')
    endif
    j = 0
    n = 1
    templ = lmin-1
    open(unit=21,file=fnPolSLSS, status='old')
    do i = 1, imax
       read(21,'(I4,3E17.7)',iostat=eof) ell, k, T1, T2

       !if (j .eq. 10) write(*,*) s, k, tau, S1, S2, S3 
       if (eof .ne. 0 ) exit !end of file
       if (ell > templ) then

          j = j + 1
          n = 1

       endif
       templ = ell
       ellarrPolScal(j) = ell
       karrPolScal(n) = k
       TransferPolScal(n,j,1) = T1
       TransferPolScal(n,j,2) = T2
       n = n + 1		
    enddo
    intellmaxPolScal = j
    intkmaxPolScal = n-1
    close(21)
    write(*,'(A30)') "<<<<<<Scalar-Polarization>>>>>"
    write(*,'(A25,I5)') "Number of ell in scal(p):  ", intellmaxPolScal
    write(*,'(A25,I5)') "Number of k in scal:       ", intkmaxPolScal
    write(*,'(A25,I5)') "Delta ell:                 ", ellarrPolScal(2)-ellarrPolScal(1)
    write(*,'(A25,F5.2)') "kmax:                      ", karrPolScal(intkmaxPolScal)
    write(*,'(A25,I5)') "lmax:                      ", ellarrPolScal(intellmaxPolScal)

    j = 0
    n = 1
    templ = lmin-1
    open(unit=21,file=fnSLSS, status='old')
    do i = 1, imax

       read(21,'(I4,3E17.7)',iostat=eof) ell, k, T1, T2
       !write(*,*) ell, k, T1, T2
       if (eof < 0 ) exit !end of file
       if (ell > templ) then
          j = j + 1
          n = 1	
          !write(*,*) "Here!"
       endif
       !write(*,*) i
       templ = ell
       ellarrS(j) = ell
       karrS(n) = k
       TransferS(n,j,1) = T1
       TransferS(n,j,2) = T2
       n = n + 1		
    enddo
    intellmaxS = j
    intkmaxS = n-1
    close(21)
    write(*,'(A30)') "<<<<<<<<<<<<Scalars>>>>>>>>>>>>>"
    write(*,'(A25,I5)') "Number of ell in scal:     ", intellmaxS
    write(*,'(A25,I5)') "Number of k in scal:       ", intkmaxS
    write(*,'(A25,I5)') "Delta ell:                 ", ellarrS(2)-ellarrS(1)
    write(*,'(A25,F5.2)') "kmax:                      ", karrS(intkmaxS)
    write(*,'(A25,I5)') "lmax:                      ", ellarrS(intellmaxS)

    j = 0
    n = 1
    templ = lmin-1
    open(unit=21,file=fnPolTLSS, status='old')
    do i = 1, imax

       read(21,'(I4,3E17.7)',iostat=eof) ell, k, T1, T2
       !if (j .eq. 10) write(*,*) s, k, tau, S1, S2, S3 
       if (eof < 0 ) exit !end of file
       if (ell > templ) then

          j = j + 1
          n = 1

       endif
       templ = ell
       ellarrPolTens(j) = ell
       karrPolTens(n) = k
       TransferPolTens(n,j,1) = T1 !switched
       TransferPolTens(n,j,2) = T2
       n = n + 1		
    enddo
    intellmaxPolTens = j
    intkmaxPolTens = n-1
    close(21)
    !ell = 1000
    write(*,'(A30)') "<<<<<<<<<Tensor-Polarization>>>>>>>>"
    write(*,'(A25,I5)') "Number of ell in tens:     ", intellmaxPolTens
    write(*,'(A25,I5)') "Number of k in tens:       ", intkmaxPolTens
    write(*,'(A25,I5)') "Delta ell:                 ", ellarrPolTens(2)-ellarrPolTens(1)
    write(*,'(A25,F5.2)') "kmax:                      ", karrPolTens(intkmaxPolTens)
    write(*,'(A25,I5)') "lmax:                      ", ellarrPolTens(intellmaxPolTens)

    !lmaxS = ellarrPolScal(intellmaxPolScal)
    do i = 1, intellmaxPolScal
       count = 1
       do j = 1, intkmaxPolScal
          !this is just a crazy guess, but it works pretty well
          !first of these is better, but second one is ok as well, and lowers 
          !the sampling even more. This is necessary for bispectrum.
          !if (karrS(j) .ge. 2.d0*sqrt(1.0*lmaxS)*sqrt(1.d0*ellarrPolScal(i))/tau0) exit
          if (karrPolScal(j) .ge. 2.d0*(1.0*ellarrPolScal(intellmaxPolScal))**(1./3.)*(1.d0*ellarrPolScal(i))**(2./3.)/tau0) exit
          count = count + 1
       enddo
       if (testkmax .ne. 0) then 
          kmaxIntE(i) = testkmax
       else
          kmaxIntE(i) = count-1
       endif
       !write(*,*) ellarrPolScal(i),kmaxIntE(i)
    enddo

    do i = 1, intellmaxS
       count = 1
       do j = 1, intkmaxS
          !this is just a crazy guess, but it works pretty well
          !first of these is better, but second one is ok as well, and lowers 
          !the sampling even more. This is necessary for bispectrum.
          !if (karrS(j) .ge. 2.d0*sqrt(1.0*lmaxS)*sqrt(1.d0*ellarrS(i))/tau0) exit
          if (karrS(j) .ge. 2.d0*(1.0*ellarrS(intellmaxS))**(1./3.)*(1.d0*ellarrS(i))**(2./3.)/tau0) exit
          count = count + 1
       enddo
       if (testkmax .ne. 0) then 
          kmaxIntT(i) = testkmax
       else
          kmaxIntT(i) = count-1
       endif
       !write(*,*) ellarrS(i),kmaxIntT(i)
    enddo

    !for testing:
    write(*,*) ""
    !for testing:
    if (testlmax .ne. 0) then 
       intellmaxPoltens = testlmax 
       intellmaxS = testlmax 
       intellmaxPolScal = testlmax 
       write(*,'(A25,I5)') "test lmax:                 ", ellarrPolScal(intellmaxPoltens)
       write(*,'(A25,I5)') "test lmax:                 ", ellarrS(intellmaxS)
       write(*,'(A25,I5)') "test lmax:                 ", ellarrPolTens(intellmaxPolScal)
    endif
    !for testing
    if (testkmax .ne. 0) then 
       intkmaxPolScal = testkmax
       intellmaxS = testlmax 
       intkmaxPolTens = 2*testkmax
       write(*,'(A25,F5.2)') "tens test kmax:            ", karrPolTens(intkmaxPolTens)
       write(*,'(A25,I5)') "scal test lmax:                 ", karrS(intkmaxS)
       write(*,'(A25,F5.2)') "scalpol test kmax:            ", karrS(intkmaxPolScal)
    endif

    !lowering ellmaxT by hand:
    !intellmaxT = 256 !so for delta ell = 20, ell_max = 490
    !intellmaxPolScal = 256

    write(*,'(A25,I5)') "testElmax:                 ", ellarrPolScal(intellmaxPolScal)
    write(*,'(A25,I5)') "testTlmax:                 ", ellarrPolTens(intellmaxPolTens)
    write(*,'(A25,I5)') "testSlmax:                 ", ellarrS(intellmaxS)
    allocate(TransferCos1(intkmaxPolScal,intkmaxS,intellmaxPolTens))
    allocate(TransferCos2(intkmaxPolScal,intkmaxS,intellmaxPolTens))

    allocate(TransferSin1(intkmaxPolScal,intkmaxS,intellmaxPolTens))
    allocate(TransferSin2(intkmaxPolScal,intkmaxS,intellmaxPolTens))

    i_progress = int(intellmaxPolTens/pstep)
    write(*,*) ""
    write(*,'(A52)') "Precomputing Spline Coefficients B-mode Polarization"
    do i = 1, pstep
       write(*,'(a)',advance='no')  '*'
    enddo
    write(*,*) ""

    allocate(Blll(intellmaxPolTens,intellmaxS,intellmaxPolScal))
    !precompute at points needed. Using relatively fast interpolation scheme. Still slow. Extrapolation estimates it would take about
    !4 hours on my own machine for the full bispectrum. Have
    !thought how to make this faster, but seems impossible at this point. Using 32 cores would only require 30 minutes. 

    !$OMP PARALLEL DO DEFAUlT(SHARED) &
    !$OMP PRIVATE(j,i,s,ell3,k1,k2), &
    !$OMP PRIVATE(kzTa,kzTb), &
    !$OMP PRIVATE(TranSTempSin1,TranSTempSin2), &
    !$OMP PRIVATE(TranSTempCos1,TranSTempCos2)
    do s = 1, intellmaxPolTens
       ell3  = ellarrPolTens(s)
       !write(*,*) ell3
       do k1 = 1, intkmaxS
          !write(*,*) k1
          do k2 = 1, intkmaxPolScal 
             !it is the sum of the k of the two scalars. These will generally be larger. 
             !To accomodate, you can increase ell max for tensors when precomputing the 
             !source functions. I might do that
             kzTa = karrS(k1)+karrPolScal(k2)

             if(kzTa .ge. karrPolTens(intkmaxPolTens)) then 
                !associated transfer functions set to zero. 
                TransferCos1(k2,k1,s) = 0.d0
                TransferSin1(k2,k1,s) = 0.d0
             else
                call linint(kzTa,TranSTempCos1,karrPolTens(1:intkmaxPolTens),TransferPolTens(1:intkmaxPolTens,s,2),intkmaxPolTens)
                call linint(kzTa,TranSTempSin1,karrPolTens(1:intkmaxPolTens),TransferPolTens(1:intkmaxPolTens,s,1),intkmaxPolTens)
                TransferCos1(k2,k1,s) = TranSTempCos1
                TransferSin1(k2,k1,s) = TranSTempSin1
             endif
          enddo
          do k2 = 1, intkmaxPolScal 
             !write(*,*) TranSTempSin1
             kzTb = abs(karrS(k1)-karrPolScal(k2))
             !otherwise, out of range:
             if (kzTb .ge. karrPolTens(intkmaxPolTens)) then 
                !associated transfer functions set to zero:
                TransferCos2(k2,k1,s) = 0.d0
                TransferSin2(k2,k1,s) = 0.d0
             else
                call linint(kzTb,TranSTempCos2,karrPolTens(1:intkmaxPolTens),TransferPolTens(1:intkmaxPolTens,s,2),intkmaxPolTens)
                call linint(kzTb,TranSTempSin2,karrPolTens(1:intkmaxPolTens),TransferPolTens(1:intkmaxPolTens,s,1),intkmaxPolTens)
                !if (ell3 .eq. 100 .and. k1 .eq. 100) write(*,*) kzSa,TranSTemp1, karrS(k2),TransferS(2,s,k2) 

                TransferCos2(k2,k1,s) = TranSTempCos2
                !sine changes sign. 
                if(k2 .ge. k1) then 
                   TransferSin2(k2,k1,s) = -TranSTempSin2
                else
                   TransferSin2(k2,k1,s) = TranSTempSin2
                endif
             endif
          enddo

       enddo
       if(mod(s,i_progress) .eq. 0) write(*,'(a)',advance='no')  '*'
    enddo
    !$OMP END PARALLEL DO

    !deallocate
    deallocate(karrPolTens)

    !split up the B-loop into pieces. This should work
    !to speed up code (run on multiple cores)
    intellminPolTens = 1
    DownSample = 1 !only compute every 'DownSample' times. Works, but not yet with S/N.
    !intellmaxT = 2
    write(*,*) ""

    write(*,'(A40)') "<<<<<<<<<<Computing Bispectrum>>>>>>>>>>"
    open(unit=28,file=B_BTEfile, status="replace")

    if(diag_only) then 
       !$OMP PARALLEL DO DEFAUlT(SHARED)  &
       !$OMP PRIVATE(ell1,ell2,ell3,j,i,s,k1,k2), &
       !$OMP PRIVATE(q1,q2,kzSa,kzSb,q3a,q3b,dk2,dk1,kta,ktb), &
       !$OMP PRIVATE(kintres2,kintres1,bispeca,bispecb,Fa,Fb,SinFac, FlocalSW)
       do j = 136, intellmaxs  !loop over ells, was 136
          !ell2 = ellarrS(j)
          !ell3 = ell2
          !ell1 = 100
          i = j - 5
          !j = i + 20
          s = 76
          ell1 = ellarrS(j)
          ell2 = ellarrPolScal(i)
          ell3 = ellarrPolTens(s)
          SinFac = 1!sqrt(1.d0-((ell1**2+ell3**2-ell2**2)/(2.d0*ell1*ell3))**2)
          !for pairs of values that lead to NAN sine, cycle loop
          !These do not satisfy triangle constraint according to Joel. 
          if(SinFac .ne. Sinfac) then
                Blll(s,i,j) = 0.d0
          	cycle
          !removes all modes with zero outcome
          endif
          !write(*,*) ell1, ell2, ell3
          !s = 10
          ! ell3 = ellarrPolScal(s) !any number below ellmaxT (so 500). 
          !reset:
          kintres1 = 0.0d0
          do k1 = 1,  kmaxIntE(j) !intkmaxPolScal !integrals over k. 
             dk1 = karrS(k1+1) - karrS(k1)
             kintres2 = 0.0d0
             do k2 = 1, kmaxIntE(i) !intkmaxPolScal ! 


                dk2 = karrPolScal(k2+1) - karrPolScal(k2)

                q1 = sqrt(karrS(k1)**2+(ell1/(tauRS-tau0))**2)
                q2 = sqrt(karrPolScal(k2)**2+(ell2/(tauRS-tau0))**2)

                kzSa = karrS(k1)+karrPolScal(k2)
                kzSb = karrS(k1)-karrPolScal(k2)

                q3a = sqrt((kzSa)**2+(ell3/(tauRT-tau0))**2)
                q3b = sqrt((kzSb)**2+(ell3/(tauRT-tau0))**2)

                kta = q1 + q2 + q3a
                ktb = q1 + q2 + q3b

		!HWINCH2016                
		!SFSR shape, see notes (this is prop to 1/k^6)
        	!bispeca = (-kta + (q1*q2+q2*q3a+q3a*q1)/kta + q1*q2*q3a/kta**2)/(q1**2*q2**2*q3a**3)
                !bispecb = (-ktb + (q1*q2+q2*q3b+q3b*q1)/ktb + q1*q2*q3b/ktb**2)/(q1**2*q2**2*q3b**3) 
		
		!my new USR shapes, proportional to 1/k^6 ((q1**2 + q2**2)/2)**3*
		!bispeca = ((q1**2 + q2**2)/2)**3*q3a**2/q1/q2*(72/kta**3 + 72/kta**5*(2*q1**2 + 2*q2**2 + 3*(q1*q2+q2*q3a+q3a*q1)) + &
		!	360/kta**6*((q1 + q2)*(q1**2 + q1*q2 + q2**2) + q3a*(q1**2 + 3*q1*q2 + q2**2)) + &
		!	2160*q1*q2/kta**7*(q1**2 + q2**2 + q1*q2 + q2*q3a + q3a*q1) + 5040*q1**2*q2**2/kta**7)/(q1*q2*q3a)**3
		!bispecb = ((q1**2 + q2**2)/2)**3*q3b**2/q1/q2*(72/ktb**3 + 72/ktb**5*(2*q1**2 + 2*q2**2 + 3*(q1*q2+q2*q3b+q3b*q1)) + &
		!	360/ktb**6*((q1 + q2)*(q1**2 + q1*q2 + q2**2) + q3b*(q1**2 + 3*q1*q2 + q2**2)) + &
		!	2160*q1*q2/ktb**7*(q1**2 + q2**2 + q1*q2 + q2*q3b + q3b*q1) + 5040*q1**2*q2**2/ktb**7)/(q1*q2*q3b)**3
		


                !local:
                if(shape .eq. 1) then 
                   bispeca = 1.d0/(q1*q2)**3 + 1.d0/(q3a*q2)**3 + 1.d0/(q3a*q1)**3
                   bispecb = 1.d0/(q1*q2)**3 + 1.d0/(q3b*q2)**3 + 1.d0/(q3b*q1)**3
                endif
                !equilateral, same story. Also included rel. normalization.
                if(shape .eq. 2) then 
                   bispeca = 3.d0*(-(1.d0/(q1*q2)**3 + 1.d0/(q3a*q2)**3 + 1.d0/(q3a*q1)**3) - &
			2.d0/(q1*q2*q3a)**2+1.d0/(q3a*q1**2*q2**3)+1.d0/(q1*q3a**2*q2**3) + &
                        1.d0/(q1*q2**2*q3a**3) + 1.d0/(q3a*q2**2*q1**3) + 1.d0/(q2*q1**2*q3a**3) + &
                        1.d0/(q2*q3a**2*q1**3))
                   bispecb = 3.d0*(-(1.d0/(q1*q2)**3 + 1.d0/(q3b*q2)**3 + 1.d0/(q3b*q1)**3)- &
			2.d0/(q1*q2*q3b)**2+1.d0/(q3b*q1**2*q2**3)+1.d0/(q1*q3b**2*q2**3) + &
                        1.d0/(q1*q2**2*q3b**3) + 1.d0/(q3b*q2**2*q1**3) + 1.d0/(q2*q1**2*q3b**3) + &
                        1.d0/(q2*q3b**2*q1**3))
                endif

                !orthogonal, same story. Also included rel. normalization.
                if(shape .eq. 3) then
                   bispeca = 3.d0*(-3.0*(1.d0/(q1*q2)**3 + 1.d0/(q3a*q2)**3 + 1.d0/(q3a*q1)**3)- &
			8.d0/(q1*q2*q3a)**2+3.d0/(q3a*q1**2*q2**3)+3.d0/(q1*q3a**2*q2**3) + &
                        3.d0/(q1*q2**2*q3a**3) + 3.d0/(q3a*q2**2*q1**3) + 3.d0/(q2*q1**2*q3a**3) + &
                        3.d0/(q2*q3a**2*q1**3))/(q1*q2)
                   bispecb = 3.d0*(-3.0*(1.d0/(q1*q2)**3 + 1.d0/(q3b*q2)**3 + 1.d0/(q3b*q1)**3)- &
			8.d0/(q1*q2*q3b)**2+3.d0/(q3b*q1**2*q2**3)+3.d0/(q1*q3b**2*q2**3) + &
                        3.d0/(q1*q2**2*q3b**3) + 3.d0/(q3b*q2**2*q1**3) + 3.d0/(q2*q1**2*q3b**3) + &
                        3.d0/(q2*q3b**2*q1**3))
                endif

                !flat or enfolded:
                if(shape .eq. 4) then
                   bispeca = 3.d0*(1.d0/(q1*q2)**3 + 1.d0/(q3a*q2)**3 + 1.d0/(q3a*q1)**3 + &
			3.d0/(q1*q2*q3a)**2-1.d0/(q3a*q1**2*q2**3)-1.d0/(q1*q3a**2*q2**3) - &
                        1.d0/(q1*q2**2*q3a**3) - 1.d0/(q3a*q2**2*q1**3) - 1.d0/(q2*q1**2*q3a**3) - &
                        1.d0/(q2*q3a**2*q1**3))/(q1*q2)
                   bispecb = 3.d0*(1.d0/(q1*q2)**3 + 1.d0/(q3b*q2)**3 + 1.d0/(q3b*q1)**3 + &
			3.d0/(q1*q2*q3b)**2-1.d0/(q3b*q1**2*q2**3)-1.d0/(q1*q3b**2*q2**3) - &
                        1.d0/(q1*q2**2*q3b**3) - 1.d0/(q3b*q2**2*q1**3) - 1.d0/(q2*q1**2*q3b**3) - &
                        1.d0/(q2*q3b**2*q1**3))
                endif

		!SFSR shape
		if(shape .eq. 5) then
		   bispeca = (-kta + (q1*q2+q2*q3a+q3a*q1)/kta + q1*q2*q3a/kta**2)/(q1**2*q2**2*q3a**3)
                   bispecb = (-ktb + (q1*q2+q2*q3b+q3b*q1)/ktb + q1*q2*q3b/ktb**2)/(q1**2*q2**2*q3b**3) 
		end if

		!USR shape
		if(shape .eq. 6) then
		   bispeca = ((q1**2 + q2**2)/2)**3*q3a**2/q1/q2*(72/kta**3 + 72/kta**5*(2*q1**2 + 2*q2**2 + 3*(q1*q2+q2*q3a+q3a*q1)) + &
			360/kta**6*((q1 + q2)*(q1**2 + q1*q2 + q2**2) + q3a*(q1**2 + 3*q1*q2 + q2**2)) + &
			2160*q1*q2/kta**7*(q1**2 + q2**2 + q1*q2 + q2*q3a + q3a*q1) + 5040*q1**2*q2**2/kta**7)/(q1*q2*q3a)**3
		   bispecb = ((q1**2 + q2**2)/2)**3*q3b**2/q1/q2*(72/ktb**3 + 72/ktb**5*(2*q1**2 + 2*q2**2 + 3*(q1*q2+q2*q3b+q3b*q1)) + &
			360/ktb**6*((q1 + q2)*(q1**2 + q1*q2 + q2**2) + q3b*(q1**2 + 3*q1*q2 + q2**2)) + &
			2160*q1*q2/ktb**7*(q1**2 + q2**2 + q1*q2 + q2*q3b + q3b*q1) + 5040*q1**2*q2**2/ktb**7)/(q1*q2*q3b)**3
		end if

                Fa =(ell2/(tau0-tauRS))**2/(q2**3*q1)*&
		     (-ell1**2/(tau0-tauRS)**2*(ell1**2+ell3**2-ell2**2)/2.d0/ell1/ell3*(kzSa/q3a)**2 + &
                     ell1*ell3/(tau0-tauRS)**2*(karrPolScal(k1)/q3a)*(kzSa/q3a)) 
                !Fa =ell1*ell3/(tau0-tauRS)**2/q3a**2*(karrS(k1)**2-karrS(k2)**2)/2.d0
                Fb =(ell2**2/(tau0-tauRS)**2)/(q1*q2**3)*&
		     (-ell1**2/(tau0-tauRS)**2*(ell1**2+ell3**2-ell2**2)/2.d0/ell1/ell3*(kzSb/q3b)**2 + &
                     ell1*ell3/(tau0-tauRS)**2*(karrPolScal(k1)/q3b)*(kzSb/q3b))
                !Fb =ell1*ell3/(tau0-tauRS)**2/q3b**2*(karrS(k1)**2-karrS(k2)**2)/2.d0
		
		!old shapes for BTT
		!Fa =(-ell1**2/(tau0-tauRS)**2*(ell1**2+ell3**2-ell2**2)/2.d0/ell1/ell3*(kzSa/q3a)**2 + &
                !   	ell1*ell3/(tau0-tauRS)**2*(karrPolScal(k1)/q3a)*(kzSa/q3a))
		!Fb =(-ell1**2/(tau0-tauRS)**2*(ell1**2+ell3**2-ell2**2)/2.d0/ell1/ell3*(kzSb/q3b)**2 + &
                !   	ell1*ell3/(tau0-tauRS)**2*(karrPolScal(k1)/q3b)*(kzSb/q3b))
                

                !note that this is effectively the same as TTT:
                kintres2 = kintres2 +  (Fa*bispeca*TransferCos1(k2,k1,s)*(TransferS(k1,j,2)*TransferPolScal(k2,i,2) - & 
                     TransferS(k1,j,1)*TransferPolScal(k2,i,1)) + &
                     Fa*bispeca*TransferSin1(k2,k1,s)*(TransferS(k1,j,1)*TransferPolScal(k2,i,2) + & 
                     TransferS(k1,j,2)*TransferPolScal(k2,i,1)) + &
                     Fb*bispecb*TransferCos2(k2,k1,s)*(TransferS(k1,j,2)*TransferPolScal(k2,i,2) + & 
                     TransferS(k1,j,1)*TransferPolScal(k2,i,1)) + &
                     Fb*bispecb*TransferSin2(k2,k1,s)*(TransferS(k1,j,1)*TransferPolScal(k2,i,2) - & 
                     TransferS(k1,j,2)*TransferPolScal(k2,i,1)))*dk2

             enddo
             !integration over k1
             kintres1  = kintres1+kintres2*dk1

          enddo
          !Babich, page 3 (local norm), for f_NL = 1
          !only (2 pi)^2 because the bispectrum is devided by (2 pi)^2
          !the factor 4 comes from the trigonometric identities above
          !As^2 is the amplitude of the primordial power spectrum 
          !If it is ok, we could add this to the paper as evidence that we got this right (even as a insanity check). 
          !the only problem would be that local NGS would get most of their signal to noise from the squeezed limit
          !although, I think it is not as bad as for the bias. 
          !Blll(s,i,j) = kintres1
          !Blll(j,i,s) = kintres1
          !cosine factor
          if(wantRelFlocal) then 
		FlocalSW = 1./(ell1*(ell1+1.)*ell2*(ell2+1.)) + 1./(ell1*(ell1+1.)*ell3*(ell3+1.)) + 1./(ell3*(ell3+1.)*ell2*(ell2+1.))
        	Blll(s,i,j) = (4.d0*pi)**2*sqrt(2.d0)*(tau0-tauRS)**2*kintres1*As**2*(COBE_CMBTemp*1d6)**3*SinFac/FlocalSW
          else
		Blll(s,i,j) = (4.d0*pi)**2*sqrt(2.d0)*(tau0-tauRS)**2*kintres1*As**2*(COBE_CMBTemp*1d6)**3*SinFac
	  endif
          !here we go. These will not be printed in order:
          write(28,'(3I5, 2E17.7)') ell1, ell2, ell3, Blll(s,i,j)

          write(*,'(3I5, E17.7)') ell1, ell2, ell3, Blll(s,i,j)

       enddo
       !$OMP END PARALLEL DO 
    else
       !makeSCHEDULE(DYNAMIC)
       !you want to do dynamic omp because the outer loop is slow for low values of ell1
       !you can probably optimze this by adjusting chunks (default = 1, works pretty good, factor of 3 improv)
       !$OMP PARALLEL DO DEFAUlT(SHARED) SCHEDULE(DYNAMIC), &
       !$OMP PRIVATE(ell1,ell2,ell3,j,i,s,k1,k2), &
       !$OMP PRIVATE(q1,q2,kzSa,kzSb,q3a,q3b,dk2,dk1,kta,ktb), &
       !$OMP PRIVATE(kintres2,kintres1,bispeca,bispecb,Fa,Fb,SinFac)
       do j = 1, intellmaxS, DownSample !loop over ells
          ell1 = ellarrS(j)
          !write(*,*) ell1
          do i = 1, intellmaxPolScal, DownSample !only for i .ge. j
             ell2 = ellarrPolScal(i)
             do s = intellminPolTens, intellmaxPolTens, DownSample !should do all ell
                ell3 = ellarrPolTens(s)
                SinFac = sqrt(1.d0-((ell1**2+ell3**2-ell2**2)/(2.d0*ell1*ell3))**2)
                !for pairs of values that lead to NAN sine, cycle loop
                !These do not satisfy triangle constraint according to Joel. 
                if(SinFac .ne. Sinfac) then
                   Blll(s,i,j) = 0.d0
                   cycle
                   !removes all modes with zero outcome
                endif
                kintres1 = 0.0d0
                do k1 = 1, kmaxIntT(j) !integrals over k. 
                   dk1 = karrS(k1+1) - karrS(k1)
                   kintres2 = 0.0d0
                   do k2 = 1, kmaxIntE(i) 		

                      dk2 = karrPolScal(k2+1) - karrPolScal(k2)

                      q1 = sqrt(karrS(k1)**2+(ell1/(tauRS-tau0))**2)
                      q2 = sqrt(karrPolScal(k2)**2+(ell2/(tauRS-tau0))**2)

                      kzSa = karrS(k1)+karrPolScal(k2)
                      kzSb = karrS(k1)-karrPolScal(k2)

                      q3a = sqrt((kzSa)**2+(ell3/(tauRT-tau0))**2)
                      q3b = sqrt((kzSb)**2+(ell3/(tauRT-tau0))**2)

                      kta = q1 + q2 + q3a
                      ktb = q1 + q2 + q3b

                      !shape, see notes (this is prop to 1/k^8)
                      !bispeca = (-kta + (q1*q2+q2*q3a+q3a*q1)/kta + q1*q2*q3a/kta**2)/(q1*q2*q3a)**3
                      !bispecb = (-ktb + (q1*q2+q2*q3b+q3b*q1)/ktb + q1*q2*q3b/ktb**2)/(q1*q2*q3b)**3 
                      !trying some alternatives (looks like flat):
                      !bispeca = (q1*q2*q3a/kta**2)/(q1*q2*q3a)**3
                      !bispecb = (q1*q2*q3b/ktb**2)/(q1*q2*q3b)**3
                      !local, has to be 1/k^7 and symmetric in k1 and k2:


                      bispeca = 1.d0/(q1*q2)**3 + 1.d0/(q3a*q2)**3 + 1.d0/(q3a*q1)**3
                      bispecb = 1.d0/(q1*q2)**3 + 1.d0/(q3b*q2)**3 + 1.d0/(q3b*q1)**3
                      !local:
                      if(shape .eq. 1) then 
                         bispeca = bispeca
                         bispecb = bispecb
                      endif
                      !equilateral, same story. Also included rel. normalization.
                      if(shape .eq. 2) then 
                         bispeca = 3.d0*(-bispeca-2.d0/(q1*q2*q3a)**2+1.d0/(q3a*q1**2*q2**3)+1.d0/(q1*q3a**2*q2**3) + &
                              1.d0/(q1*q2**2*q3a**3) + 1.d0/(q3a*q2**2*q1**3) + 1.d0/(q2*q1**2*q3a**3) + &
                              1.d0/(q2*q3a**2*q1**3))
                         bispecb = 3.d0*(-bispecb-2.d0/(q1*q2*q3b)**2+1.d0/(q3b*q1**2*q2**3)+1.d0/(q1*q3b**2*q2**3) + &
                              1.d0/(q1*q2**2*q3b**3) + 1.d0/(q3b*q2**2*q1**3) + 1.d0/(q2*q1**2*q3b**3) + &
                              1.d0/(q2*q3b**2*q1**3))
                      endif

                      !orthogonal, same story. Also included rel. normalization.
                      if(shape .eq. 3) then
                         bispeca = 3.d0*(-3.0*bispeca-8.d0/(q1*q2*q3a)**2+3.d0/(q3a*q1**2*q2**3)+3.d0/(q1*q3a**2*q2**3) + &
                              3.d0/(q1*q2**2*q3a**3) + 3.d0/(q3a*q2**2*q1**3) + 3.d0/(q2*q1**2*q3a**3) + &
                              3.d0/(q2*q3a**2*q1**3))
                         bispecb = 3.d0*(-3.0*bispecb-8.d0/(q1*q2*q3b)**2+3.d0/(q3b*q1**2*q2**3)+3.d0/(q1*q3b**2*q2**3) + &
                              3.d0/(q1*q2**2*q3b**3) + 3.d0/(q3b*q2**2*q1**3) + 3.d0/(q2*q1**2*q3b**3) + &
                              3.d0/(q2*q3b**2*q1**3))
                      endif

                      !flat or enfolded:
                      if(shape .eq. 4) then
                         bispeca = 3.d0*(bispeca+3.d0/(q1*q2*q3a)**2-1.d0/(q3a*q1**2*q2**3)-1.d0/(q1*q3a**2*q2**3) - &
                              1.d0/(q1*q2**2*q3a**3) - 1.d0/(q3a*q2**2*q1**3) - 1.d0/(q2*q1**2*q3a**3) - &
                              1.d0/(q2*q3a**2*q1**3))
                         bispecb = 3.d0*(bispecb+3.d0/(q1*q2*q3b)**2-1.d0/(q3b*q1**2*q2**3)-1.d0/(q1*q3b**2*q2**3) - &
                              1.d0/(q1*q2**2*q3b**3) - 1.d0/(q3b*q2**2*q1**3) - 1.d0/(q2*q1**2*q3b**3) - &
                              1.d0/(q2*q3b**2*q1**3))
                      endif

			!SFSR shape
			if(shape .eq. 5) then
			   bispeca = (-kta + (q1*q2+q2*q3a+q3a*q1)/kta + q1*q2*q3a/kta**2)/(q1**2*q2**2*q3a**3)
            	      	   bispecb = (-ktb + (q1*q2+q2*q3b+q3b*q1)/ktb + q1*q2*q3b/ktb**2)/(q1**2*q2**2*q3b**3) 
			end if

			!USR shape
			if(shape .eq. 6) then
			   bispeca = ((q1**2 + q2**2)/2)**3*q3a**2/q1/q2*(72/kta**3 + 72/kta**5*(2*q1**2 + 2*q2**2 + 3*(q1*q2+q2*q3a+q3a*q1)) + &
				360/kta**6*((q1 + q2)*(q1**2 + q1*q2 + q2**2) + q3a*(q1**2 + 3*q1*q2 + q2**2)) + &
				2160*q1*q2/kta**7*(q1**2 + q2**2 + q1*q2 + q2*q3a + q3a*q1) + 5040*q1**2*q2**2/kta**7)/(q1*q2*q3a)**3
			   bispecb = ((q1**2 + q2**2)/2)**3*q3b**2/q1/q2*(72/ktb**3 + 72/ktb**5*(2*q1**2 + 2*q2**2 + 3*(q1*q2+q2*q3b+q3b*q1)) + &
				360/ktb**6*((q1 + q2)*(q1**2 + q1*q2 + q2**2) + q3b*(q1**2 + 3*q1*q2 + q2**2)) + &
				2160*q1*q2/ktb**7*(q1**2 + q2**2 + q1*q2 + q2*q3b + q3b*q1) + 5040*q1**2*q2**2/ktb**7)/(q1*q2*q3b)**3
			end if

                      !this factor is prop to k^2; so Fa*bispeca prop to 1/k^6 as it should
                      Fa =(ell2/(tau0-tauRS))**2/(q1*q2**3)*&
			     (-ell1**2/(tau0-tauRS)**2*(ell1**2+ell3**2-ell2**2)/2.d0/ell1/ell3*(kzSa/q3a)**2 + &
              		       ell1*ell3/(tau0-tauRS)**2*(karrPolScal(k1)/q3a)*(kzSa/q3a)) 
              	     !Fa =ell1*ell3/(tau0-tauRS)**2/q3a**2*(karrS(k1)**2-karrS(k2)**2)/2.d0
             	      Fb =(ell2**2/(tau0-tauRS)**2)/(q1*q2**3)*&
			     (-ell1**2/(tau0-tauRS)**2*(ell1**2+ell3**2-ell2**2)/2.d0/ell1/ell3*(kzSb/q3b)**2 + &
            	             ell1*ell3/(tau0-tauRS)**2*(karrPolScal(k1)/q3b)*(kzSb/q3b))
            	     !Fb =ell1*ell3/(tau0-tauRS)**2/q3b**2*(karrS(k1)**2-karrS(k2)**2)/2.d0
		
                      !note that this is effectively the same as TTT:
                      kintres2 = kintres2 +  (Fa*bispeca*TransferCos1(k2,k1,s)*(TransferS(k1,j,2)*TransferPolScal(k2,i,2) - & 
                           TransferS(k1,j,1)*TransferPolScal(k2,i,1)) + &
                           Fa*bispeca*TransferSin1(k2,k1,s)*(TransferS(k1,j,1)*TransferPolScal(k2,i,2) + & 
                           TransferS(k1,j,2)*TransferPolScal(k2,i,1)) + &
                           Fb*bispecb*TransferCos2(k2,k1,s)*(TransferS(k1,j,2)*TransferPolScal(k2,i,2) + & 
                           TransferS(k1,j,1)*TransferPolScal(k2,i,1)) + &
                           Fb*bispecb*TransferSin2(k2,k1,s)*(TransferS(k1,j,1)*TransferPolScal(k2,i,2) - & 
                           TransferS(k1,j,2)*TransferPolScal(k2,i,1)))*dk2

                   enddo
                   kintres1  = kintres1+kintres2*dk1

                enddo
                !bispectrum (up to some factors) In (mu K)^2
                Blll(s,i,j) = (4.d0*pi)**2*sqrt(2.d0)*(tau0-tauRS)**2*kintres1*As**2*(COBE_CMBTemp*1d6)**3*SinFac
                !write(*,'(3I5, E17.7)') ell1, ell2, ell3, Blll(s,i,j)
                !here we go. These will not be printed in order:

                !for check write the diagonal
                if(ell1 .eq. ell2 .and. ell2 .eq. ell3) write(*,'(3I5, E17.7)') ell1, ell2, ell3, Blll(s,i,j)
             enddo
          enddo

       enddo
       !$OMP END PARALLEL DO 
    endif
    !deallocate all that is not needed:
    deallocate(TransferCos1)
    deallocate(TransferCos2)
    deallocate(TransferSin1)
    deallocate(TransferSin2)
    deallocate(TransferPolScal)
    deallocate(TransferPolTens)
    deallocate(karrPolScal)
    deallocate(kmaxIntE)
    deallocate(kmaxIntT)
    if(diag_only) then 
       close(28) 
    else 
       do j = 1, intellmaxPolScal, DownSample !loop over ells
          ell1 = ellarrPolScal(j)
          !write(*,*) ell1
          do i = j, intellmaxPolScal, DownSample !only for i .ge. j
             ell2 = ellarrPolScal(i)
             do s = intellminPolTens, intellmaxPoltens, DownSample !should do all ell   
                ell3 = ellarrPolTens(s)
                write(28,'(3I5, E17.7)') ell1, ell2, ell3, Blll(s,i,j)
                !association. Needed for S/N. 
                Blll(s,j,i) = Blll(s,i,j)
             enddo
          enddo
       enddo
       close(28)
    endif
    !final deallocation
    deallocate(Blll)
    deallocate(ellarrPolTens)
    deallocate(ellarrPolScal)

  end subroutine Compute_Blll_ETB_flat



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!BEE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  
  subroutine Compute_Blll_EEB_flat(shape, diag_only,testlmax, testkmax)
    !logical, intent(in) :: want_SN
    integer, intent(in) :: shape
    logical, intent(in) :: diag_only !only diagonal?
    integer, intent(in) :: testlmax, testkmax !for testing
    real(dl) :: DSN1, DSN2, B2, sigmaBEE
    integer  :: i, imax = 100000000, j, n, s, eof 
    real(dl), allocatable    :: TransferS(:,:,:) 
    real(dl), allocatable    :: TransferPolTens(:,:,:)
    real(dl), allocatable    :: TransferPolScal(:,:,:) 
    real(dl), allocatable    :: karrS(:), karrPolTens(:), karrPolScal(:)
    real(dl)    :: k, tau, T1, T2
    integer     :: intellmaxS, intellmaxPolTens, intellmaxPolScal,intellminPolTens
    integer     :: intkmaxS, intkmaxPolTens, intkmaxPolScal, templ
    !real(dl)    :: dkS, dkT, kintresS, kintresTB, kintresTE   
    real(dl)    :: dk1, dk2, kintres1, kintres2  
    integer 	:: ell, ell1, ell2, ell3, il, ellfac,deltaell
    integer     :: k1, k2
    real(dl)    :: q3a, q3b, kzSa, kzSb
    real(dl)    :: q1, q2, Fa, Fb, kta, ktb, TranTTemp1, TranTTemp2, kzTa, kzTb
    real(dl)    :: TranSTempCos1,TranSTempCos2,TranSTempSin1,TranSTempSin2
    integer, allocatable :: ellarrS(:), ellarrPolTens(:), ellarrPolScal(:)

    !integer 	:: ellarrS(2500), ellarrPolTens(1010)
    real(dl)    :: bispeca, bispecb

    real(dl), allocatable :: sp1t(:,:), sp2t(:,:), sp3t(:,:)
    real(dl), allocatable :: Blll(:,:,:)
    integer :: count
    real(dl) :: Rell
    integer,allocatable :: kmaxInt(:)
    character(120) :: B_BEEfile, SNfile, NoiseData 
    character(120) :: fnSLSS,fnPolTLSS,fnPolSLSS,CLTfile, CLSfile
    real(dl),allocatable :: TransferCos1(:,:,:), TransferCos2(:,:,:)  
    real(dl),allocatable :: TransferSin1(:,:,:), TransferSin2(:,:,:)  
    real(dl) :: SinFac
    integer :: l1, l2, l3, l1min
    !to lower the number of steps; currently does not work
    integer :: DownSample
    character(80) :: ShapeName
    real :: FlocalSW



    !just to be sure
    scalars  = .true. 
    polarization = .true. 
    !for now we can only do this. 
    AppLSS = .true.	
    !diag_only = .false.	
    if(diag_only) then 
       write(*,*) ""
       write(*,'(A31)') "Only computing single slice BEE"
    else
       write(*,*) ""
       write(*,'(A31)') "Computing Full BEE Bispectrum.."
       if(shape .eq. 1) then
          ShapeName  = 'Local       '
       elseif(shape .eq. 2) then
          ShapeName  = 'Equilateral '
       elseif(shape .eq. 3) then
          ShapeName  = 'Orthogonal  '
       elseif(shape .eq. 4) then
          ShapeName  = 'Flat/Enfoled'
       elseif(shape .eq. 5) then
          ShapeName  = 'SFSR        '
       elseif(shape .eq. 6) then
          ShapeName  = 'USR         '
       else
          ShapeName  = 'Unknown     '
       endif

       write(*,'(A6,X,A12)') "Shape:", ShapeName
    endif

    !required for limited stack size MacOsX + openmp
    !allocate(TransferS(2,2500,3000))
    !allocate(TransferT(2,2500,3000))

    allocate(TransferPolTens(3*lmaxPolTens,lmaxPolTens+10,4))
    allocate(karrPolTens(3*lmaxPolTens))
    allocate(ellarrPolTens(lmaxPoltens+10))
    allocate(TransferPolScal(2*lmaxPolScal,lmaxPolScal+10,4))
    allocate(karrPolScal(2*lmaxPolScal))
    allocate(ellarrPolScal(lmaxPolScal+10))
    allocate(kmaxInt(5000))

    if (AppLss) then 
       fnSLSS = Trim(homefolder)//Trim(NameTransferT)//Trim(Scaltxt)
       fnPolTLSS = Trim(homefolder)//Trim(NameTransferB)//Trim(PolTtxt)
       fnPolSLSS = Trim(homefolder)//Trim(NameTransferE)//Trim(PolStxt)
       B_BEEfile = Trim(homefolder)//Trim(rootnamebl)//trim('_BEE_USRfull2.txt')
    else
       fnSLSS = Trim(homefolder)//Trim(NameTransferT)//Trim('b')//Trim(Scaltxt)
       fnPolTLSS = Trim(homefolder)//Trim(NameTransferB)//Trim('b')//Trim(PolTtxt)
       fnPolSLSS = Trim(homefolder)//Trim(NameTransferE)//Trim('b')//Trim(PolStxt)
       B_BEEfile = Trim(homefolder)//Trim(rootnamebl)//trim('_Blll_BEEb.txt')
    endif
    j = 0
    n = 1
    templ = lmin-1
    open(unit=21,file=fnPolSLSS, status='old')
    do i = 1, imax
       read(21,'(I4,3E17.7)',iostat=eof) ell, k, T1, T2

       !if (j .eq. 10) write(*,*) s, k, tau, S1, S2, S3 
       if (eof .ne. 0 ) exit !end of file
       if (ell > templ) then

          j = j + 1
          n = 1

       endif
       templ = ell
       ellarrPolScal(j) = ell
       karrPolScal(n) = k
       TransferPolScal(n,j,1) = T1
       TransferPolScal(n,j,2) = T2
       n = n + 1		
    enddo
    intellmaxPolScal = j
    intkmaxPolScal = n-1
    close(21)
    write(*,'(A30)') "<<<<<<Scalar-Polarization>>>>>"
    write(*,'(A25,I5)') "Number of ell in scal(p):  ", intellmaxPolScal
    write(*,'(A25,I5)') "Number of k in scal:       ", intkmaxPolScal
    write(*,'(A25,I5)') "Delta ell:                 ", ellarrPolScal(2)-ellarrPolScal(1)
    write(*,'(A25,F5.2)') "kmax:                      ", karrPolScal(intkmaxPolScal)
    write(*,'(A25,I5)') "lmax:                      ", ellarrPolScal(intellmaxPolScal)
    j = 0
    n = 1
    templ = lmin-1
    open(unit=21,file=fnPolTLSS, status='old')
    do i = 1, imax

       read(21,'(I4,3E17.7)',iostat=eof) ell, k, T1, T2
       !if (j .eq. 10) write(*,*) s, k, tau, S1, S2, S3 
       if (eof < 0 ) exit !end of file
       if (ell > templ) then

          j = j + 1
          n = 1

       endif
       templ = ell
       ellarrPolTens(j) = ell
       karrPolTens(n) = k
       TransferPolTens(n,j,1) = T1 !switched
       TransferPolTens(n,j,2) = T2
       n = n + 1		
    enddo
    intellmaxPolTens = j
    intkmaxPolTens = n-1
    close(21)
    !ell = 1000
    write(*,'(A30)') "<<<<<<<<<Polarization>>>>>>>>"
    write(*,'(A25,I5)') "Number of ell in tens:     ", intellmaxPolTens
    write(*,'(A25,I5)') "Number of k in tens:       ", intkmaxPolTens
    write(*,'(A25,I5)') "Delta ell:                 ", ellarrPolTens(2)-ellarrPolTens(1)
    write(*,'(A25,F5.2)') "kmax:                      ", karrPolTens(intkmaxPolTens)
    write(*,'(A25,I5)') "lmax:                      ", ellarrPolTens(intellmaxPolTens)

    !lmaxS = ellarrPolScal(intellmaxPolScal)
    do i = 1, intellmaxPolScal
       count = 1
       do j = 1, intkmaxPolScal
          !this is just a crazy guess, but it works pretty well
          !first of these is better, but second one is ok as well, and lowers 
          !the sampling even more. This is necessary for bispectrum.
          !if (karrS(j) .ge. 2.d0*sqrt(1.0*lmaxS)*sqrt(1.d0*ellarrPolScal(i))/tau0) exit
          if (karrPolScal(j) .ge. 2.d0*(1.0*ellarrPolScal(intellmaxPolScal))**(1./3.)*(1.d0*ellarrPolScal(i))**(2./3.)/tau0) exit
          count = count + 1
       enddo
       if (testkmax .ne. 0) then 
          kmaxInt(i) = testkmax
       else
          kmaxInt(i) = count-1
       endif
       !write(*,*) ellarrPolScal(i),kmaxInt(i)
    enddo
    !for testing:
    write(*,*) ""
    !for testing:
    if (testlmax .ne. 0) then 
       intellmaxPoltens = testlmax 
       intellmaxPolScal = testlmax 
       write(*,'(A25,I5)') "test lmax:                 ", ellarrPolScal(intellmaxPoltens)
       write(*,'(A25,I5)') "test lmax:                 ", ellarrPolTens(intellmaxPolScal)
    endif
    !for testing
    if (testkmax .ne. 0) then 
       intkmaxPolScal = testkmax
       intkmaxPolTens = 2*testkmax
       write(*,'(A25,F5.2)') "tens test kmax:            ", karrPolTens(intkmaxPolTens)
       write(*,'(A25,F5.2)') "scal test kmax:            ", karrS(intkmaxPolScal)
    endif

    !lowering ellmaxT by hand:
    !intellmaxT = 256 !so for delta ell = 20, ell_max = 490
    !intellmaxPolScal = 256

    write(*,'(A25,I5)') "testSlmax:                 ", ellarrPolScal(intellmaxPolScal)
    write(*,'(A25,I5)') "testTlmax:                 ", ellarrPolTens(intellmaxPolTens)
    allocate(TransferCos1(intkmaxPolScal,intkmaxPolScal,intellmaxPolTens))
    allocate(TransferCos2(intkmaxPolScal,intkmaxPolScal,intellmaxPolTens))

    allocate(TransferSin1(intkmaxPolScal,intkmaxPolScal,intellmaxPolTens))
    allocate(TransferSin2(intkmaxPolScal,intkmaxPolScal,intellmaxPolTens))

    i_progress = int(intellmaxPolTens/pstep)
    write(*,*) ""
    write(*,'(A52)') "Precomputing Spline Coefficients B-mode Polarization"
    do i = 1, pstep
       write(*,'(a)',advance='no')  '*'
    enddo
    write(*,*) ""

    allocate(Blll(intellmaxPolTens,intellmaxPolScal,intellmaxPolScal))
    !precompute at points needed. Using relatively fast interpolation scheme. Still slow. Extrapolation estimates it would take about
    !4 hours on my own machine for the full bispectrum. Have
    !thought how to make this faster, but seems impossible at this point. Using 32 cores would only require 30 minutes. 

    !$OMP PARALLEL DO DEFAUlT(SHARED) &
    !$OMP PRIVATE(j,i,s,ell3,k1,k2), &
    !$OMP PRIVATE(kzTa,kzTb), &
    !$OMP PRIVATE(TranSTempSin1,TranSTempSin2), &
    !$OMP PRIVATE(TranSTempCos1,TranSTempCos2)
    do s = 1, intellmaxPolTens
       ell3  = ellarrPolTens(s)
       !write(*,*) ell3
       do k1 = 1, intkmaxPolScal
          !write(*,*) k1
          do k2 = 1, intkmaxPolScal 
             !it is the sum of the k of the two scalars. These will generally be larger. 
             !To accomodate, you can increase ell max for tensors when precomputing the 
             !source functions. I might do that
             kzTa = karrPolScal(k1)+karrPolScal(k2)

             if(kzTa .ge. karrPolTens(intkmaxPolTens)) then 
                !associated transfer functions set to zero. 
                TransferCos1(k2,k1,s) = 0.d0
                TransferSin1(k2,k1,s) = 0.d0
             else
                call linint(kzTa,TranSTempCos1,karrPolTens(1:intkmaxPolTens),TransferPolTens(1:intkmaxPolTens,s,2),intkmaxPolTens)
                call linint(kzTa,TranSTempSin1,karrPolTens(1:intkmaxPolTens),TransferPolTens(1:intkmaxPolTens,s,1),intkmaxPolTens)
                TransferCos1(k2,k1,s) = TranSTempCos1
                TransferSin1(k2,k1,s) = TranSTempSin1
             endif
          enddo
          do k2 = 1, intkmaxPolScal 
             !write(*,*) TranSTempSin1
             kzTb = abs(karrPolScal(k1)-karrPolScal(k2))
             !otherwise, out of range:
             if (kzTb .ge. karrPolTens(intkmaxPolTens)) then 
                !associated transfer functions set to zero:
                TransferCos2(k2,k1,s) = 0.d0
                TransferSin2(k2,k1,s) = 0.d0
             else
                call linint(kzTb,TranSTempCos2,karrPolTens(1:intkmaxPolTens),TransferPolTens(1:intkmaxPolTens,s,2),intkmaxPolTens)
                call linint(kzTb,TranSTempSin2,karrPolTens(1:intkmaxPolTens),TransferPolTens(1:intkmaxPolTens,s,1),intkmaxPolTens)
                !if (ell3 .eq. 100 .and. k1 .eq. 100) write(*,*) kzSa,TranSTemp1, karrS(k2),TransferS(2,s,k2) 

                TransferCos2(k2,k1,s) = TranSTempCos2
                !sine changes sign. 
                if(k2 .ge. k1) then 
                   TransferSin2(k2,k1,s) = -TranSTempSin2
                else
                   TransferSin2(k2,k1,s) = TranSTempSin2
                endif
             endif
          enddo

       enddo
       if(mod(s,i_progress) .eq. 0) write(*,'(a)',advance='no')  '*'
    enddo
    !$OMP END PARALLEL DO

    !deallocate
    deallocate(karrPolTens)

    !split up the B-loop into pieces. This should work
    !to speed up code (run on multiple cores)
    intellminPolTens = 1
    DownSample = 1 !only compute every 'DownSample' times. Works, but not yet with S/N.
    !intellmaxT = 2
    write(*,*) ""

    write(*,'(A40)') "<<<<<<<<<<Computing Bispectrum>>>>>>>>>>"
    open(unit=28,file=B_BEEfile, status="replace")

    if(diag_only) then 
       !$OMP PARALLEL DO DEFAUlT(SHARED)  &
       !$OMP PRIVATE(ell1,ell2,ell3,j,i,s,k1,k2), &
       !$OMP PRIVATE(q1,q2,kzSa,kzSb,q3a,q3b,dk2,dk1,kta,ktb), &
       !$OMP PRIVATE(kintres2,kintres1,bispeca,bispecb,Fa,Fb,SinFac, FlocalSW)
       do j = 136, intellmaxPolScal  !loop over ells, was 136
          !ell2 = ellarrS(j)
          !ell3 = ell2
          !ell1 = 100
          i = j - 5
          !j = i + 20
          s = 76
          ell1 = ellarrPolScal(j)
          ell2 = ellarrPolScal(i)
          ell3 = ellarrPolTens(s)
          SinFac = 1!sqrt(1.d0-((ell1**2+ell3**2-ell2**2)/(2.d0*ell1*ell3))**2)
          !for pairs of values that lead to NAN sine, cycle loop
          !These do not satisfy triangle constraint according to Joel. 
          if(SinFac .ne. Sinfac) then
                Blll(s,i,j) = 0.d0
          	cycle
          !removes all modes with zero outcome
          endif
          !write(*,*) ell1, ell2, ell3
          !s = 10
          ! ell3 = ellarrPolScal(s) !any number below ellmaxT (so 500). 
          !reset:
          kintres1 = 0.0d0
          do k1 = 1,  kmaxInt(j) !intkmaxPolScal !integrals over k. 
             dk1 = karrPolScal(k1+1) - karrPolScal(k1)
             kintres2 = 0.0d0
             do k2 = 1, kmaxInt(i) !intkmaxPolScal ! 


                dk2 = karrPolScal(k2+1) - karrPolScal(k2)

                q1 = sqrt(karrPolScal(k1)**2+(ell1/(tauRS-tau0))**2)
                q2 = sqrt(karrPolScal(k2)**2+(ell2/(tauRS-tau0))**2)

                kzSa = karrPolScal(k1)+karrPolScal(k2)
                kzSb = karrPolScal(k1)-karrPolScal(k2)

                q3a = sqrt((kzSa)**2+(ell3/(tauRT-tau0))**2)
                q3b = sqrt((kzSb)**2+(ell3/(tauRT-tau0))**2)

                kta = q1 + q2 + q3a
                ktb = q1 + q2 + q3b

		!HWINCH2016                
		!SFSR shape, see notes (this is prop to 1/k^6)
        	!bispeca = (-kta + (q1*q2+q2*q3a+q3a*q1)/kta + q1*q2*q3a/kta**2)/(q1**2*q2**2*q3a**3)
                !bispecb = (-ktb + (q1*q2+q2*q3b+q3b*q1)/ktb + q1*q2*q3b/ktb**2)/(q1**2*q2**2*q3b**3) 
		
		!my new USR shapes, proportional to 1/k^6 ((q1**2 + q2**2)/2)**3*
		!bispeca = ((q1**2 + q2**2)/2)**3*q3a**2/q1/q2*(72/kta**3 + 72/kta**5*(2*q1**2 + 2*q2**2 + 3*(q1*q2+q2*q3a+q3a*q1)) + &
		!	360/kta**6*((q1 + q2)*(q1**2 + q1*q2 + q2**2) + q3a*(q1**2 + 3*q1*q2 + q2**2)) + &
		!	2160*q1*q2/kta**7*(q1**2 + q2**2 + q1*q2 + q2*q3a + q3a*q1) + 5040*q1**2*q2**2/kta**7)/(q1*q2*q3a)**3
		!bispecb = ((q1**2 + q2**2)/2)**3*q3b**2/q1/q2*(72/ktb**3 + 72/ktb**5*(2*q1**2 + 2*q2**2 + 3*(q1*q2+q2*q3b+q3b*q1)) + &
		!	360/ktb**6*((q1 + q2)*(q1**2 + q1*q2 + q2**2) + q3b*(q1**2 + 3*q1*q2 + q2**2)) + &
		!	2160*q1*q2/ktb**7*(q1**2 + q2**2 + q1*q2 + q2*q3b + q3b*q1) + 5040*q1**2*q2**2/ktb**7)/(q1*q2*q3b)**3
		


                !local:
                if(shape .eq. 1) then 
                   bispeca = 1.d0/(q1*q2)**3 + 1.d0/(q3a*q2)**3 + 1.d0/(q3a*q1)**3
                   bispecb = 1.d0/(q1*q2)**3 + 1.d0/(q3b*q2)**3 + 1.d0/(q3b*q1)**3
                endif
                !equilateral, same story. Also included rel. normalization.
                if(shape .eq. 2) then 
                   bispeca = 3.d0*(-(1.d0/(q1*q2)**3 + 1.d0/(q3a*q2)**3 + 1.d0/(q3a*q1)**3) - &
			2.d0/(q1*q2*q3a)**2+1.d0/(q3a*q1**2*q2**3)+1.d0/(q1*q3a**2*q2**3) + &
                        1.d0/(q1*q2**2*q3a**3) + 1.d0/(q3a*q2**2*q1**3) + 1.d0/(q2*q1**2*q3a**3) + &
                        1.d0/(q2*q3a**2*q1**3))
                   bispecb = 3.d0*(-(1.d0/(q1*q2)**3 + 1.d0/(q3b*q2)**3 + 1.d0/(q3b*q1)**3)- &
			2.d0/(q1*q2*q3b)**2+1.d0/(q3b*q1**2*q2**3)+1.d0/(q1*q3b**2*q2**3) + &
                        1.d0/(q1*q2**2*q3b**3) + 1.d0/(q3b*q2**2*q1**3) + 1.d0/(q2*q1**2*q3b**3) + &
                        1.d0/(q2*q3b**2*q1**3))
                endif

                !orthogonal, same story. Also included rel. normalization.
                if(shape .eq. 3) then
                   bispeca = 3.d0*(-3.0*(1.d0/(q1*q2)**3 + 1.d0/(q3a*q2)**3 + 1.d0/(q3a*q1)**3)- &
			8.d0/(q1*q2*q3a)**2+3.d0/(q3a*q1**2*q2**3)+3.d0/(q1*q3a**2*q2**3) + &
                        3.d0/(q1*q2**2*q3a**3) + 3.d0/(q3a*q2**2*q1**3) + 3.d0/(q2*q1**2*q3a**3) + &
                        3.d0/(q2*q3a**2*q1**3))/(q1*q2)
                   bispecb = 3.d0*(-3.0*(1.d0/(q1*q2)**3 + 1.d0/(q3b*q2)**3 + 1.d0/(q3b*q1)**3)- &
			8.d0/(q1*q2*q3b)**2+3.d0/(q3b*q1**2*q2**3)+3.d0/(q1*q3b**2*q2**3) + &
                        3.d0/(q1*q2**2*q3b**3) + 3.d0/(q3b*q2**2*q1**3) + 3.d0/(q2*q1**2*q3b**3) + &
                        3.d0/(q2*q3b**2*q1**3))
                endif

                !flat or enfolded:
                if(shape .eq. 4) then
                   bispeca = 3.d0*(1.d0/(q1*q2)**3 + 1.d0/(q3a*q2)**3 + 1.d0/(q3a*q1)**3 + &
			3.d0/(q1*q2*q3a)**2-1.d0/(q3a*q1**2*q2**3)-1.d0/(q1*q3a**2*q2**3) - &
                        1.d0/(q1*q2**2*q3a**3) - 1.d0/(q3a*q2**2*q1**3) - 1.d0/(q2*q1**2*q3a**3) - &
                        1.d0/(q2*q3a**2*q1**3))/(q1*q2)
                   bispecb = 3.d0*(1.d0/(q1*q2)**3 + 1.d0/(q3b*q2)**3 + 1.d0/(q3b*q1)**3 + &
			3.d0/(q1*q2*q3b)**2-1.d0/(q3b*q1**2*q2**3)-1.d0/(q1*q3b**2*q2**3) - &
                        1.d0/(q1*q2**2*q3b**3) - 1.d0/(q3b*q2**2*q1**3) - 1.d0/(q2*q1**2*q3b**3) - &
                        1.d0/(q2*q3b**2*q1**3))
                endif

		!SFSR shape
		if(shape .eq. 5) then
		   bispeca = (-kta + (q1*q2+q2*q3a+q3a*q1)/kta + q1*q2*q3a/kta**2)/(q1**2*q2**2*q3a**3)
                   bispecb = (-ktb + (q1*q2+q2*q3b+q3b*q1)/ktb + q1*q2*q3b/ktb**2)/(q1**2*q2**2*q3b**3) 
		end if

		!USR shape
		if(shape .eq. 6) then
		   bispeca = ((q1**2 + q2**2)/2)**3*q3a**2/q1/q2*(72/kta**3 + 72/kta**5*(2*q1**2 + 2*q2**2 + 3*(q1*q2+q2*q3a+q3a*q1)) + &
			360/kta**6*((q1 + q2)*(q1**2 + q1*q2 + q2**2) + q3a*(q1**2 + 3*q1*q2 + q2**2)) + &
			2160*q1*q2/kta**7*(q1**2 + q2**2 + q1*q2 + q2*q3a + q3a*q1) + 5040*q1**2*q2**2/kta**7)/(q1*q2*q3a)**3
		   bispecb = ((q1**2 + q2**2)/2)**3*q3b**2/q1/q2*(72/ktb**3 + 72/ktb**5*(2*q1**2 + 2*q2**2 + 3*(q1*q2+q2*q3b+q3b*q1)) + &
			360/ktb**6*((q1 + q2)*(q1**2 + q1*q2 + q2**2) + q3b*(q1**2 + 3*q1*q2 + q2**2)) + &
			2160*q1*q2/ktb**7*(q1**2 + q2**2 + q1*q2 + q2*q3b + q3b*q1) + 5040*q1**2*q2**2/ktb**7)/(q1*q2*q3b)**3
		end if

                Fa =(ell2/(tau0-tauRS))**2*(ell1/(tau0-tauRS))**2/(q1**3*q2**3)*&
		     (-ell1**2/(tau0-tauRS)**2*(ell1**2+ell3**2-ell2**2)/2.d0/ell1/ell3*(kzSa/q3a)**2 + &
                     ell1*ell3/(tau0-tauRS)**2*(karrPolScal(k1)/q3a)*(kzSa/q3a)) 
                !Fa =ell1*ell3/(tau0-tauRS)**2/q3a**2*(karrS(k1)**2-karrS(k2)**2)/2.d0
                Fb =(ell2**2/(tau0-tauRS)**2)*(ell1**2/(tau0-tauRS)**2)/(q1**3*q2**3)*&
		     (-ell1**2/(tau0-tauRS)**2*(ell1**2+ell3**2-ell2**2)/2.d0/ell1/ell3*(kzSb/q3b)**2 + &
                     ell1*ell3/(tau0-tauRS)**2*(karrPolScal(k1)/q3b)*(kzSb/q3b))
                !Fb =ell1*ell3/(tau0-tauRS)**2/q3b**2*(karrS(k1)**2-karrS(k2)**2)/2.d0
		
		!old shapes for BTT
		!Fa =(-ell1**2/(tau0-tauRS)**2*(ell1**2+ell3**2-ell2**2)/2.d0/ell1/ell3*(kzSa/q3a)**2 + &
                !   	ell1*ell3/(tau0-tauRS)**2*(karrPolScal(k1)/q3a)*(kzSa/q3a))
		!Fb =(-ell1**2/(tau0-tauRS)**2*(ell1**2+ell3**2-ell2**2)/2.d0/ell1/ell3*(kzSb/q3b)**2 + &
                !   	ell1*ell3/(tau0-tauRS)**2*(karrPolScal(k1)/q3b)*(kzSb/q3b))
                

                !note that this is effectively the same as TTT:
                kintres2 = kintres2 +  (Fa*bispeca*TransferCos1(k2,k1,s)*(TransferPolScal(k1,j,2)*TransferPolScal(k2,i,2) - & 
                     TransferPolScal(k1,j,1)*TransferPolScal(k2,i,1)) + &
                     Fa*bispeca*TransferSin1(k2,k1,s)*(TransferPolScal(k1,j,1)*TransferPolScal(k2,i,2) + & 
                     TransferPolScal(k1,j,2)*TransferPolScal(k2,i,1)) + &
                     Fb*bispecb*TransferCos2(k2,k1,s)*(TransferPolScal(k1,j,2)*TransferPolScal(k2,i,2) + & 
                     TransferPolScal(k1,j,1)*TransferPolScal(k2,i,1)) + &
                     Fb*bispecb*TransferSin2(k2,k1,s)*(TransferPolScal(k1,j,1)*TransferPolScal(k2,i,2) - & 
                     TransferPolScal(k1,j,2)*TransferPolScal(k2,i,1)))*dk2

             enddo
             !integration over k1
             kintres1  = kintres1+kintres2*dk1

          enddo
          !Babich, page 3 (local norm), for f_NL = 1
          !only (2 pi)^2 because the bispectrum is devided by (2 pi)^2
          !the factor 4 comes from the trigonometric identities above
          !As^2 is the amplitude of the primordial power spectrum 
          !If it is ok, we could add this to the paper as evidence that we got this right (even as a insanity check). 
          !the only problem would be that local NGS would get most of their signal to noise from the squeezed limit
          !although, I think it is not as bad as for the bias. 
          !Blll(s,i,j) = kintres1
          !Blll(j,i,s) = kintres1
          !cosine factor
          if(wantRelFlocal) then 
		FlocalSW = 1./(ell1*(ell1+1.)*ell2*(ell2+1.)) + 1./(ell1*(ell1+1.)*ell3*(ell3+1.)) + 1./(ell3*(ell3+1.)*ell2*(ell2+1.))
        	Blll(s,i,j) = (4.d0*pi)**2*sqrt(2.d0)*(tau0-tauRS)**2*kintres1*As**2*(COBE_CMBTemp*1d6)**3*SinFac/FlocalSW
          else
		Blll(s,i,j) = (4.d0*pi)**2*sqrt(2.d0)*(tau0-tauRS)**2*kintres1*As**2*(COBE_CMBTemp*1d6)**3*SinFac
	  endif
          !here we go. These will not be printed in order:
          write(28,'(3I5, 2E17.7)') ell1, ell2, ell3, Blll(s,i,j)

          write(*,'(3I5, E17.7)') ell1, ell2, ell3, Blll(s,i,j)

       enddo
       !$OMP END PARALLEL DO 
    else
       !makeSCHEDULE(DYNAMIC)
       !you want to do dynamic omp because the outer loop is slow for low values of ell1
       !you can probably optimze this by adjusting chunks (default = 1, works pretty good, factor of 3 improv)
       !$OMP PARALLEL DO DEFAUlT(SHARED) SCHEDULE(DYNAMIC), &
       !$OMP PRIVATE(ell1,ell2,ell3,j,i,s,k1,k2), &
       !$OMP PRIVATE(q1,q2,kzSa,kzSb,q3a,q3b,dk2,dk1,kta,ktb), &
       !$OMP PRIVATE(kintres2,kintres1,bispeca,bispecb,Fa,Fb,SinFac)
       do j = 1, intellmaxPolScal, DownSample !loop over ells
          ell1 = ellarrPolScal(j)
          !write(*,*) ell1
          do i = j, intellmaxPolScal, DownSample !only for i .ge. j
             ell2 = ellarrPolScal(i)
             do s = intellminPolTens, intellmaxPolTens, DownSample !should do all ell
                ell3 = ellarrPolTens(s)
                SinFac = sqrt(1.d0-((ell1**2+ell3**2-ell2**2)/(2.d0*ell1*ell3))**2)
                !for pairs of values that lead to NAN sine, cycle loop
                !These do not satisfy triangle constraint according to Joel. 
                if(SinFac .ne. Sinfac) then
                   Blll(s,i,j) = 0.d0
                   cycle
                   !removes all modes with zero outcome
                endif
                kintres1 = 0.0d0
                do k1 = 1, kmaxInt(j) !integrals over k. 
                   dk1 = karrPolScal(k1+1) - karrPolScal(k1)
                   kintres2 = 0.0d0
                   do k2 = 1, kmaxInt(i) 		

                      dk2 = karrPolScal(k2+1) - karrPolScal(k2)

                      q1 = sqrt(karrPolScal(k1)**2+(ell1/(tauRS-tau0))**2)
                      q2 = sqrt(karrPolScal(k2)**2+(ell2/(tauRS-tau0))**2)

                      kzSa = karrPolScal(k1)+karrPolScal(k2)
                      kzSb = karrPolScal(k1)-karrPolScal(k2)

                      q3a = sqrt((kzSa)**2+(ell3/(tauRT-tau0))**2)
                      q3b = sqrt((kzSb)**2+(ell3/(tauRT-tau0))**2)

                      kta = q1 + q2 + q3a
                      ktb = q1 + q2 + q3b

                      !shape, see notes (this is prop to 1/k^8)
                      !bispeca = (-kta + (q1*q2+q2*q3a+q3a*q1)/kta + q1*q2*q3a/kta**2)/(q1*q2*q3a)**3
                      !bispecb = (-ktb + (q1*q2+q2*q3b+q3b*q1)/ktb + q1*q2*q3b/ktb**2)/(q1*q2*q3b)**3 
                      !trying some alternatives (looks like flat):
                      !bispeca = (q1*q2*q3a/kta**2)/(q1*q2*q3a)**3
                      !bispecb = (q1*q2*q3b/ktb**2)/(q1*q2*q3b)**3
                      !local, has to be 1/k^7 and symmetric in k1 and k2:


                      bispeca = 1.d0/(q1*q2)**3 + 1.d0/(q3a*q2)**3 + 1.d0/(q3a*q1)**3
                      bispecb = 1.d0/(q1*q2)**3 + 1.d0/(q3b*q2)**3 + 1.d0/(q3b*q1)**3
                      !local:
                      if(shape .eq. 1) then 
                         bispeca = bispeca
                         bispecb = bispecb
                      endif
                      !equilateral, same story. Also included rel. normalization.
                      if(shape .eq. 2) then 
                         bispeca = 3.d0*(-bispeca-2.d0/(q1*q2*q3a)**2+1.d0/(q3a*q1**2*q2**3)+1.d0/(q1*q3a**2*q2**3) + &
                              1.d0/(q1*q2**2*q3a**3) + 1.d0/(q3a*q2**2*q1**3) + 1.d0/(q2*q1**2*q3a**3) + &
                              1.d0/(q2*q3a**2*q1**3))
                         bispecb = 3.d0*(-bispecb-2.d0/(q1*q2*q3b)**2+1.d0/(q3b*q1**2*q2**3)+1.d0/(q1*q3b**2*q2**3) + &
                              1.d0/(q1*q2**2*q3b**3) + 1.d0/(q3b*q2**2*q1**3) + 1.d0/(q2*q1**2*q3b**3) + &
                              1.d0/(q2*q3b**2*q1**3))
                      endif

                      !orthogonal, same story. Also included rel. normalization.
                      if(shape .eq. 3) then
                         bispeca = 3.d0*(-3.0*bispeca-8.d0/(q1*q2*q3a)**2+3.d0/(q3a*q1**2*q2**3)+3.d0/(q1*q3a**2*q2**3) + &
                              3.d0/(q1*q2**2*q3a**3) + 3.d0/(q3a*q2**2*q1**3) + 3.d0/(q2*q1**2*q3a**3) + &
                              3.d0/(q2*q3a**2*q1**3))
                         bispecb = 3.d0*(-3.0*bispecb-8.d0/(q1*q2*q3b)**2+3.d0/(q3b*q1**2*q2**3)+3.d0/(q1*q3b**2*q2**3) + &
                              3.d0/(q1*q2**2*q3b**3) + 3.d0/(q3b*q2**2*q1**3) + 3.d0/(q2*q1**2*q3b**3) + &
                              3.d0/(q2*q3b**2*q1**3))
                      endif

                      !flat or enfolded:
                      if(shape .eq. 4) then
                         bispeca = 3.d0*(bispeca+3.d0/(q1*q2*q3a)**2-1.d0/(q3a*q1**2*q2**3)-1.d0/(q1*q3a**2*q2**3) - &
                              1.d0/(q1*q2**2*q3a**3) - 1.d0/(q3a*q2**2*q1**3) - 1.d0/(q2*q1**2*q3a**3) - &
                              1.d0/(q2*q3a**2*q1**3))
                         bispecb = 3.d0*(bispecb+3.d0/(q1*q2*q3b)**2-1.d0/(q3b*q1**2*q2**3)-1.d0/(q1*q3b**2*q2**3) - &
                              1.d0/(q1*q2**2*q3b**3) - 1.d0/(q3b*q2**2*q1**3) - 1.d0/(q2*q1**2*q3b**3) - &
                              1.d0/(q2*q3b**2*q1**3))
                      endif

			!SFSR shape
			if(shape .eq. 5) then
			   bispeca = (-kta + (q1*q2+q2*q3a+q3a*q1)/kta + q1*q2*q3a/kta**2)/(q1**2*q2**2*q3a**3)
            	      	   bispecb = (-ktb + (q1*q2+q2*q3b+q3b*q1)/ktb + q1*q2*q3b/ktb**2)/(q1**2*q2**2*q3b**3) 
			end if

			!USR shape
			if(shape .eq. 6) then
			   bispeca = ((q1**2 + q2**2)/2)**3*q3a**2/q1/q2*(72/kta**3 + 72/kta**5*(2*q1**2 + 2*q2**2 + 3*(q1*q2+q2*q3a+q3a*q1)) + &
				360/kta**6*((q1 + q2)*(q1**2 + q1*q2 + q2**2) + q3a*(q1**2 + 3*q1*q2 + q2**2)) + &
				2160*q1*q2/kta**7*(q1**2 + q2**2 + q1*q2 + q2*q3a + q3a*q1) + 5040*q1**2*q2**2/kta**7)/(q1*q2*q3a)**3
			   bispecb = ((q1**2 + q2**2)/2)**3*q3b**2/q1/q2*(72/ktb**3 + 72/ktb**5*(2*q1**2 + 2*q2**2 + 3*(q1*q2+q2*q3b+q3b*q1)) + &
				360/ktb**6*((q1 + q2)*(q1**2 + q1*q2 + q2**2) + q3b*(q1**2 + 3*q1*q2 + q2**2)) + &
				2160*q1*q2/ktb**7*(q1**2 + q2**2 + q1*q2 + q2*q3b + q3b*q1) + 5040*q1**2*q2**2/ktb**7)/(q1*q2*q3b)**3
			end if

                      !this factor is prop to k^2; so Fa*bispeca prop to 1/k^6 as it should
                      Fa =(ell2/(tau0-tauRS))**2*(ell1/(tau0-tauRS))**2/(q1**3*q2**3)*&
			     (-ell1**2/(tau0-tauRS)**2*(ell1**2+ell3**2-ell2**2)/2.d0/ell1/ell3*(kzSa/q3a)**2 + &
              		       ell1*ell3/(tau0-tauRS)**2*(karrPolScal(k1)/q3a)*(kzSa/q3a)) 
              	     !Fa =ell1*ell3/(tau0-tauRS)**2/q3a**2*(karrS(k1)**2-karrS(k2)**2)/2.d0
             	      Fb =(ell2**2/(tau0-tauRS)**2)*(ell1**2/(tau0-tauRS)**2)/(q1**3*q2**3)*&
			     (-ell1**2/(tau0-tauRS)**2*(ell1**2+ell3**2-ell2**2)/2.d0/ell1/ell3*(kzSb/q3b)**2 + &
            	             ell1*ell3/(tau0-tauRS)**2*(karrPolScal(k1)/q3b)*(kzSb/q3b))
            	     !Fb =ell1*ell3/(tau0-tauRS)**2/q3b**2*(karrS(k1)**2-karrS(k2)**2)/2.d0
		
                      !note that this is effectively the same as TTT:
                      kintres2 = kintres2 +  (Fa*bispeca*TransferCos1(k2,k1,s)*(TransferPolScal(k1,j,2)*TransferPolScal(k2,i,2) - & 
                           TransferPolScal(k1,j,1)*TransferPolScal(k2,i,1)) + &
                           Fa*bispeca*TransferSin1(k2,k1,s)*(TransferPolScal(k1,j,1)*TransferPolScal(k2,i,2) + & 
                           TransferPolScal(k1,j,2)*TransferPolScal(k2,i,1)) + &
                           Fb*bispecb*TransferCos2(k2,k1,s)*(TransferPolScal(k1,j,2)*TransferPolScal(k2,i,2) + & 
                           TransferPolScal(k1,j,1)*TransferPolScal(k2,i,1)) + &
                           Fb*bispecb*TransferSin2(k2,k1,s)*(TransferPolScal(k1,j,1)*TransferPolScal(k2,i,2) - & 
                           TransferPolScal(k1,j,2)*TransferPolScal(k2,i,1)))*dk2

                   enddo
                   kintres1  = kintres1+kintres2*dk1

                enddo
                !bispectrum (up to some factors) In (mu K)^2
                Blll(s,i,j) = (4.d0*pi)**2*sqrt(2.d0)*(tau0-tauRS)**2*kintres1*As**2*(COBE_CMBTemp*1d6)**3*SinFac
                !write(*,'(3I5, E17.7)') ell1, ell2, ell3, Blll(s,i,j)
                !here we go. These will not be printed in order:

                !for check write the diagonal
                if(ell1 .eq. ell2 .and. ell2 .eq. ell3) write(*,'(3I5, E17.7)') ell1, ell2, ell3, Blll(s,i,j)
             enddo
          enddo

       enddo
       !$OMP END PARALLEL DO 
    endif
    !deallocate all that is not needed:
    deallocate(TransferCos1)
    deallocate(TransferCos2)
    deallocate(TransferSin1)
    deallocate(TransferSin2)
    deallocate(TransferPolScal)
    deallocate(TransferPolTens)
    deallocate(karrPolScal)
    deallocate(kmaxInt)
    if(diag_only) then 
       close(28) 
    else 
       do j = 1, intellmaxPolScal, DownSample !loop over ells
          ell1 = ellarrPolScal(j)
          !write(*,*) ell1
          do i = j, intellmaxPolScal, DownSample !only for i .ge. j
             ell2 = ellarrPolScal(i)
             do s = intellminPolTens, intellmaxPoltens, DownSample !should do all ell   
                ell3 = ellarrPolTens(s)
                write(28,'(3I5, E17.7)') ell1, ell2, ell3, Blll(s,i,j)
                !association. Needed for S/N. 
                Blll(s,j,i) = Blll(s,i,j)
             enddo
          enddo
       enddo
       close(28)
    endif
    !final deallocation
    deallocate(Blll)
    deallocate(ellarrPolTens)
    deallocate(ellarrPolScal)

  end subroutine Compute_Blll_EEB_flat




  subroutine Compute_Blll_TTT_flat(shape,diag_only,testlmax, testkmax)
    !routine from babich et al. As a check for the BTT version. 
    logical, intent(in) :: diag_only !only diagonal?
    integer, intent(in) :: shape
    integer, intent(in) :: testlmax, testkmax !for testing
    real(dl) :: DSN,DSN1,DSN2, B2, sigmaTTT
    integer  :: i, imax = 100000000, j, n, s, eof 
    real(dl), allocatable    :: TransferS(:,:,:) 
    real(dl), allocatable    :: karrS(:)
    real(dl)    :: k, tau, T1, T2
    integer     :: intellmaxS
    integer     :: intkmaxS, templ
    real(dl)    :: Rell, dk1, dk2, kintres1, kintres2  
    integer 	::  ell, ell1, ell2, ell3, il
    integer     :: k1, k2
    real(dl)    :: q1, q2, q3a, q3b, kzSa, kzSb
    real(dl)    :: TranSTempCos1,TranSTempCos2,TranSTempSin1,TranSTempSin2 
    integer 	:: ellarrS(2500) 
    real(dl)    :: blocala, blocalb
    real(dl)    :: bispeca, bispecb
    real(dl)    :: deltaell
    real(dl), allocatable :: sp1t(:,:), sp2t(:,:), sp3t(:,:)
    real(dl), allocatable :: Blll(:,:,:)
    integer :: count
    integer,allocatable :: kmaxInt(:)
    real(dl),allocatable :: TransferCos1(:,:,:), TransferCos2(:,:,:)  
    real(dl),allocatable :: TransferSin1(:,:,:), TransferSin2(:,:,:)  
    integer :: l1, l2, l3, l1min
    character(120) :: B_TTTfile, SNfile, NoiseData
    character(120) :: fnSLSS,fnTLSS,fnPolTLSS,fnPolSLSS,CLTfile, CLSfile
    character(80) :: ShapeName

    integer  :: lx1, ly1, lx2, ly2
    integer  :: NearIntLength, NearIntl1, NearIntL2
    real(dl) :: lengthl1l2, DSN3, DSN4
    !just to be sure
    scalars  = .true. 
    polarization = .false. 
    AppLSS = .true.

    if (AppLss) then 
       fnSLSS = Trim(homefolder)//Trim(NameTransferT)//Trim(Scaltxt)
       fnPolTLSS = Trim(homefolder)//Trim(NameTransferB)//Trim(PolTtxt)
       fnPolSLSS = Trim(homefolder)//Trim(NameTransferE)//Trim(PolStxt)
       B_TTTfile = Trim(homefolder)//Trim(rootnamebl)//trim('_Blll_TTT.txt')
    else
       fnSLSS = Trim(homefolder)//Trim(NameTransferT)//Trim('b')//Trim(Scaltxt)
       fnPolTLSS = Trim(homefolder)//Trim(NameTransferB)//Trim('b')//Trim(PolTtxt)
       fnPolSLSS = Trim(homefolder)//Trim(NameTransferE)//Trim('b')//Trim(PolStxt)
       B_TTTfile = Trim(homefolder)//Trim(rootnamebl)//trim('_Blll_TTTb.txt')
    endif
    !for testing
    !diag_only = .false. 
    if(diag_only) then 
       write(*,*) ""
       write(*,'(A31)') "Only computing single slice TTT"
    else
       write(*,*) ""
       write(*,'(A31)') "Computing Full TTT Bispectrum.."
       if(shape .eq. 1) then
          ShapeName  = 'Local       '
       elseif(shape .eq. 2) then
          ShapeName  = 'Equilateral '
       elseif(shape .eq. 3) then
          ShapeName  = 'Orthogonal  '
       elseif(shape .eq. 4) then
          ShapeName  = 'Flat/Enfoled'
       else
          ShapeName  = 'Unknown     '
       endif
       
       write(*,'(A6,X,A12)') "Shape:", ShapeName
    endif
    !required for limited stack size MacOsX + openmp
    !allocate(TransferS(2*lmaxS,2*lmaxS,2))
    !allocate(karrS(2*lmaxS))
    !yallocate(kmaxInt(2*lmaxS))

    allocate(TransferS(5000,400,2))
    allocate(karrS(5000))
    allocate(kmaxInt(5000))
    j = 0
    n = 1
    templ = lmin-1
    !only need scalar temperature transfer function
    open(unit=21,file=fnSLSS, status='old')
    do i = 1, imax

       read(21,'(I4,3E17.7)',iostat=eof) ell, k, T1, T2
       !write(*,*) ell, k, T1, T2
       if (eof < 0 ) exit !end of file
       if (ell > templ) then
          j = j + 1
          n = 1	
          !write(*,*) "Here!"
       endif
       !write(*,*) i
       templ = ell
       ellarrS(j) = ell
       karrS(n) = k
       TransferS(n,j,1) = T1
       TransferS(n,j,2) = T2
       n = n + 1		
    enddo
    intellmaxS = j
    intkmaxS = n-1
    close(21)
    write(*,*) ""
    write(*,'(A30)') "<<<<<<<<<<<<Scalars>>>>>>>>>>>>>"
    write(*,'(A25,I5)') "Number of ell in scal:     ", intellmaxS
    write(*,'(A25,I5)') "Number of k in scal:       ", intkmaxS
    write(*,'(A25,I5)') "Delta ell:                 ", ellarrS(2)-ellarrS(1)
    write(*,'(A25,F5.2)') "kmax:                      ", karrS(intkmaxS)
    write(*,'(A25,I5)') "lmax:                      ", ellarrS(intellmaxS)
    !lmaxS = ellarrS(intellmaxS)
    do i = 1, intellmaxS
       count = 1
       do j = 1, intkmaxS
          !this is just a crazy guess, but it works pretty well
          !first of these is better, but second one is ok as well, and lowers 
          !the sampling even more. This is necessary for bispectrum.
          !if (karrS(j) .ge. 2.d0*sqrt(1.0*lmaxS)*sqrt(1.d0*ellarrS(i))/tau0) exit
          if (karrS(j) .ge. 2.d0*(1.0*ellarrS(intellmaxS))**(1./3.)*(1.d0*ellarrS(i))**(2./3.)/tau0) exit
          count = count + 1
       enddo
       kmaxInt(i) = count-1
       !write(*,*) ellarrS(i),kmaxInt(i)
    enddo
    write(*,*) ""
    !for testing:
    if (testlmax .ne. 0) then 
       intellmaxS = testlmax 
       write(*,'(A25,I5)') "test lmax:                 ", ellarrS(testlmax)
    endif
    !for testing
    if (testkmax .ne. 0) then 
       intkmaxS = testkmax
       write(*,'(A25,F5.2)') "test kmax:                 ", karrS(testkmax)
    endif
    allocate(TransferCos1(intkmaxS,intkmaxS,intellmaxS))
    allocate(TransferCos2(intkmaxS,intkmaxS,intellmaxS))

    allocate(TransferSin1(intkmaxS,intkmaxS,intellmaxS))
    allocate(TransferSin2(intkmaxS,intkmaxS,intellmaxS))

    !precompute at points needed. Using relatively fast interpolation scheme. Still slow. On a single core takes about 6 hours. Have
    !thought how to make this faster, but seems impossible at this point. Using 16 cores would only require 30 minutes. Once these have 
    !been computed bispectrum is really fast. 
    i_progress = int(intellmaxS/pstep)
    write(*,*) ""
    write(*,'(A32)') "Precomputing Spline Coef Scalars"
    do i = 1, pstep
       write(*,'(a)',advance='no')  '*'
    enddo
    write(*,*) ""

    !$OMP PARALLEL DO DEFAUlT(SHARED) &
    !$OMP PRIVATE(j,i,s,ell3,k1,k2), &
    !$OMP PRIVATE(kzSa,kzSb), &
    !$OMP PRIVATE(TranSTempSin1,TranSTempSin2), &
    !$OMP PRIVATE(TranSTempCos1,TranSTempCos2)
    do s = 1, intellmaxS
       ell3  = ellarrS(s)
       !write(*,*) ell3
       do k1 = 1, intkmaxS
          !write(*,*) k1
          do k2 = 1, intkmaxS 
             kzSa = karrS(k1)+karrS(k2)
             !if kzSa gets larger than this, the tranfer function is out of bounds, and my guess
             !is that since this tranfer function multiplies everything, it would render the contribution 
             !zero. This is a little bit of a guess. 
             !if(kzSa .ge. karrS(kmaxInt(s))) exit
             if(kzSa .ge. karrS(intkmaxS)) then  				
                !write(*,*) kzSa, k1, k2 
                TransferCos1(k2,k1,s) = 0.d0
                TransferSin1(k2,k1,s) = 0.d0
                exit !this is the least I can do. 
             else 
                call linint(kzSa,TranSTempCos1,karrS(1:intkmaxS),TransferS(1:intkmaxS,s,2),intkmaxS)
                call linint(kzSa,TranSTempSin1,karrS(1:intkmaxS),TransferS(1:intkmaxS,s,1),intkmaxS)
                TransferCos1(k2,k1,s) = TranSTempCos1
                TransferSin1(k2,k1,s) = TranSTempSin1
             endif
          enddo
          do k2 = 1, intkmaxS
             kzSb = abs(karrS(k1)-karrS(k2)) 
             if (kzSb .ge. karrS(intkmaxS)) then 
                !set transfer functions out of bounds to zero
                TransferCos2(k2,k1,s) = 0.d0
                TransferSin2(k2,k1,s) = 0.d0
             else
                call linint(kzSb,TranSTempCos2,karrS(1:intkmaxS),TransferS(1:intkmaxS,s,2),intkmaxS)
                call linint(kzSb,TranSTempSin2,karrS(1:intkmaxS),TransferS(1:intkmaxS,s,1),intkmaxS)
                !if (ell3 .eq. 100 .and. k1 .eq. 100) write(*,*) kzSa,TranSTemp1, karrS(k2),TransferS(2,s,k2) 
                TransferCos2(k2,k1,s) = TranSTempCos2
                !sine changes sign
                if (k2 .ge. k1) then 
                   TransferSin2(k2,k1,s) = -TranSTempSin2
                else
                   TransferSin2(k2,k1,s) = TranSTempSin2
                endif
             endif
          enddo

       enddo
       if(mod(s,i_progress) .eq. 0) write(*,'(a)',advance='no')  '*'
    enddo
    !$OMP END PARALLEL DO 

    write(*,*) ""
    allocate(Blll(intellmaxS,intellmaxS,intellmaxS))

    !for testing
    !intellmaxS = 12
    if(diag_only) then
       open(unit=28,file='../data/Blll_TTT_slice2.dat' , status="replace")
       !$OMP PARALLEL DO DEFAUlT(SHARED)  &
       !$OMP PRIVATE(ell1,ell2,ell3,j,i,s,k1,k2), &
       !$OMP PRIVATE(q1,q2,kzSa,kzSb,q3a,q3b,dk2,dk1), &
       !$OMP PRIVATE(kintres2,kintres1,blocala,blocalb)
       do j = 1, intellmaxS - 10 !loop over ells
          !ell2 = ellarrS(j)
          !ell3 = ell2
          !ell1 = 100
          s = j
          i = j
          ell1 = ellarrS(j)
          ell2 = ellarrS(i)
          ell3 = ellarrS(s)
          kintres1 = 0.0d0
          do k1 = 1,  kmaxInt(j) !intkmaxS integrals over k. 
             dk1 = karrS(k1+1) - karrS(k1)
             kintres2 = 0.0d0

             do k2 = 1, kmaxInt(i)  !intkmaxS 

                dk2 = karrS(k2+1) - karrS(k2)
                q1 = sqrt(karrS(k1)**2+(ell1/(tauRS-tau0))**2)
                q2 = sqrt(karrS(k2)**2+(ell2/(tauRS-tau0))**2)
                kzSa = karrS(k1)+karrS(k2)
                kzSb = abs(karrS(k1)-karrS(k2))
                q3a = sqrt((kzSa)**2+(ell3/(tauRS-tau0))**2)
                q3b = sqrt((kzSb)**2+(ell3/(tauRS-tau0))**2)
                blocala = 1.d0/(q1*q2)**3 + 1.d0/(q3a*q2)**3 + 1.d0/(q3a*q1)**3
                blocalb = 1.d0/(q1*q2)**3 + 1.d0/(q3b*q2)**3 + 1.d0/(q3b*q1)**3
                !first the k1+k2 part
                kintres2 = kintres2 + (blocala*TransferCos1(k2,k1,s)*(TransferS(k1,j,2)*TransferS(k2,i,2) - & 
                     TransferS(k1,j,1)*TransferS(k2,i,1)) + &
                     blocala*TransferSin1(k2,k1,s)*(TransferS(k1,j,1)*TransferS(k2,i,2) + & 
                     TransferS(k1,j,2)*TransferS(k2,i,1)) + &
                                !now the k1-k2 part (is symmetric under interchanging k1 and k2)
                     blocalb*TransferCos2(k2,k1,s)*(TransferS(k1,j,2)*TransferS(k2,i,2) + & 
                     TransferS(k1,j,1)*TransferS(k2,i,1)) + &
                     blocalb*TransferSin2(k2,k1,s)*(TransferS(k1,j,1)*TransferS(k2,i,2) - & 
                     TransferS(k1,j,2)*TransferS(k2,i,1)))*dk2
                !result for the diagonal looks ok, but certainly not spot on. Which is a little strange. 					
             enddo
             kintres1  = kintres1+kintres2*dk1

          enddo
          !Babich, page 3 (local norm), for f_NL = 1
          !only (2 pi)^2 because the bispectrum is devided by (2 pi)^2
          !the factor 4 comes from the trigonometric identities above
          !As^2 is the amplitude of the primordial power spectrum 
          !If it is ok, we could add this to the paper as evidence that we got this right (even as a insanity check). 
          !the only problem would be that local NGS would get most of their signal to noise from the squeezed limit
          !although, I think it is not as bad as for the bias. 
          !Blll(j,i,s) = -6.d0*(2.d0*pi)**2*As**2*4.d0*(tau0-tauRS)**2*kintres1/5.d0

          Blll(s,i,j) = (2.d0*pi)**2*2.0*(tau0-tauRS)**2*kintres1*As**2*(COBE_CMBTemp*1d6)**3

          !here we go. These will not be printed in order:
          write(28,'(3I5, E17.7)') ell1, ell2, ell3, Blll(s,i,j)
          !for check write the diagonal
          write(*,'(3I5, E17.7)') ell1, ell2, ell3, Blll(s,i,j)

       enddo
       !$OMP END PARALLEL DO
       close(28)
    else
       !you want to do dynamic omp because the outer loop is slow for low values of ell1
       !you can probably optimze this by adjusting chunks (default = 1, works pretty good, factor of 3 improv)
       open(unit=28,file=B_TTTfile , status="replace")
       !$OMP PARALLEL DO DEFAUlT(SHARED) SCHEDULE(DYNAMIC), &
       !$OMP PRIVATE(ell1,ell2,ell3,j,i,s,k1,k2), &
       !$OMP PRIVATE(q1,q2,kzSa,kzSb,q3a,q3b,dk2,dk1), &
       !$OMP PRIVATE(kintres2,kintres1,bispeca,bispecb)
       do j = 1, intellmaxS !loop over ells
          ell1 = ellarrS(j)
          !write(*,*) ell1
          do i = j, intellmaxS !only for i .ge. j
             ell2 = ellarrS(i)
             do s = i, intellmaxS !only for s .ge. i
                ell3 = ellarrS(s)
                kintres1 = 0.0d0
                do k1 = 1, kmaxInt(j) !integrals over k.  
                   dk1 = karrS(k1+1) - karrS(k1)
                   kintres2 = 0.0d0
                   do k2 = 1, kmaxInt(i) !split up the integral into 2 pieces. 

                      dk2 = karrS(k2+1) - karrS(k2)
                      q1 = sqrt(karrS(k1)**2+(ell1/(tauRS-tau0))**2)
                      q2 = sqrt(karrS(k2)**2+(ell2/(tauRS-tau0))**2)
                      kzSa = karrS(k1)+karrS(k2)
                      kzSb = abs(-karrS(k1)+karrS(k2))
                      q3a = sqrt((kzSa)**2+(ell3/(tauRS-tau0))**2)
                      q3b = sqrt((kzSb)**2+(ell3/(tauRS-tau0))**2)
                      !local (default)
                      bispeca = 1.d0/(q1*q2)**3 + 1.d0/(q3a*q2)**3 + 1.d0/(q3a*q1)**3
                      bispecb = 1.d0/(q1*q2)**3 + 1.d0/(q3b*q2)**3 + 1.d0/(q3b*q1)**3

                      !equilateral, same story. Also included rel. normalization.
                      if(shape .eq. 2) then 
                         bispeca = 3.d0*(-bispeca-2.d0/(q1*q2*q3a)**2+1.d0/(q3a*q1**2*q2**3)+1.d0/(q1*q3a**2*q2**3) + &
                              1.d0/(q1*q2**2*q3a**3) + 1.d0/(q3a*q2**2*q1**3) + 1.d0/(q2*q1**2*q3a**3) + &
                              1.d0/(q2*q3a**2*q1**3))
                         bispecb = 3.d0*(-bispecb-2.d0/(q1*q2*q3b)**2+1.d0/(q3b*q1**2*q2**3)+1.d0/(q1*q3b**2*q2**3) + &
                              1.d0/(q1*q2**2*q3b**3) + 1.d0/(q3b*q2**2*q1**3) + 1.d0/(q2*q1**2*q3b**3) + &
                              1.d0/(q2*q3b**2*q1**3))
                      endif

                      !orthogonal, same story. Also included rel. normalization.
                      if(shape .eq. 3) then
                         bispeca = 3.d0*(-3.0*bispeca-8.d0/(q1*q2*q3a)**2+3.d0/(q3a*q1**2*q2**3)+3.d0/(q1*q3a**2*q2**3) + &
                              3.d0/(q1*q2**2*q3a**3) + 3.d0/(q3a*q2**2*q1**3) + 3.d0/(q2*q1**2*q3a**3) + &
                              3.d0/(q2*q3a**2*q1**3))
                         bispecb = 3.d0*(-3.0*bispecb-8.d0/(q1*q2*q3b)**2+3.d0/(q3b*q1**2*q2**3)+3.d0/(q1*q3b**2*q2**3) + &
                              3.d0/(q1*q2**2*q3b**3) + 3.d0/(q3b*q2**2*q1**3) + 3.d0/(q2*q1**2*q3b**3) + &
                              3.d0/(q2*q3b**2*q1**3))
                      endif

                      !flat or enfolded:
                      if(shape .eq. 4) then
                         bispeca = 3.d0*(bispeca+3.d0/(q1*q2*q3a)**2-1.d0/(q3a*q1**2*q2**3)-1.d0/(q1*q3a**2*q2**3) - &
                              1.d0/(q1*q2**2*q3a**3) - 1.d0/(q3a*q2**2*q1**3) - 1.d0/(q2*q1**2*q3a**3) - &
                              1.d0/(q2*q3a**2*q1**3))
                         bispecb = 3.d0*(bispecb+3.d0/(q1*q2*q3b)**2-1.d0/(q3b*q1**2*q2**3)-1.d0/(q1*q3b**2*q2**3) - &
                              1.d0/(q1*q2**2*q3b**3) - 1.d0/(q3b*q2**2*q1**3) - 1.d0/(q2*q1**2*q3b**3) - &
                              1.d0/(q2*q3b**2*q1**3))
                      endif
                      kintres2 = kintres2 + (bispeca*TransferCos1(k2,k1,s)*(TransferS(k1,j,2)*TransferS(k2,i,2) - & 
                           TransferS(k1,j,1)*TransferS(k2,i,1)) + &
                           bispeca*TransferSin1(k2,k1,s)*(TransferS(k1,j,1)*TransferS(k2,i,2) + & 
                           TransferS(k1,j,2)*TransferS(k2,i,1)) + &
                           bispecb*TransferCos2(k2,k1,s)*(TransferS(k1,j,2)*TransferS(k2,i,2) + & 
                           TransferS(k1,j,1)*TransferS(k2,i,1)) + &
                           bispecb*TransferSin2(k2,k1,s)*(TransferS(k1,j,1)*TransferS(k2,i,2) - & 
                           TransferS(k1,j,2)*TransferS(k2,i,1)))*dk2

                   enddo
                   kintres1  = kintres1+kintres2*dk1

                enddo
                !Babich, page 3 (local norm), for f_NL = 1
                Blll(s,i,j) = (2*pi)**2*2.0*(3./5.)*(tau0-tauRS)**2*kintres1*As**2*(COBE_CMBTemp*1d6)**3
                !(might need some pi^2's)
                !for check write the diagonal
                if(ell1 .eq. ell2 .and. ell2 .eq. ell3) write(*,'(3I5, E17.7)') ell1, ell2, ell3, Blll(s,i,j)
             enddo
          enddo

       enddo
       !$OMP END PARALLEL DO
       do j = 1, intellmaxS !loop over ells
          ell1 = ellarrS(j)
          !write(*,*) ell1
          do i = j, intellmaxS !only for i .ge. j
             ell2 = ellarrS(i)
             do s = i, intellmaxS !should do all ell   
                ell3 = ellarrS(s)

                write(28,'(3I5, E17.7)') ell1, ell2, ell3, Blll(s,i,j)
                !do I get them all like this?

             enddo
          enddo
       enddo
       close(28)
    endif


    deallocate(TransferS)
    deallocate(karrS)
    deallocate(Blll)
    deallocate(kmaxInt)
    deallocate(TransferCos1)
    deallocate(TransferCos2)
    deallocate(TransferSin1)
    deallocate(TransferSin2)
  end subroutine Compute_Blll_TTT_flat

  integer function DeltaBis(ell1,ell2,ell3)
    integer :: ell1, ell2, ell3

    !factor for symmetric only in 2 out of 3 comp, e.g. BTT
    if(ell1 .eq. ell2) then 
       DeltaBis = 2
    else
       DeltaBis = 1
    endif

  end function DeltaBis

  integer function DeltaBisFS(ell1,ell2,ell3)
    integer :: ell1, ell2, ell3
    !factor for fullt symmetric spectrum (e.g. TTT, EEE etc)
    if(ell1 .eq. ell2 .and. ell2 .eq. ell3) then 
       DeltaBisFS = 6
    elseif(ell1 .eq. ell2 .and. ell2 .ne. ell3) then
       DeltaBisFS = 2
    elseif(ell1 .ne. ell2 .and. ell2 .eq. ell3) then
       DeltaBisFS = 2
    elseif(ell1 .ne. ell2 .and. ell1 .eq. ell3) then
       DeltaBisFS = 2
    else 
       DeltaBisFS = 1
    endif

  end function DeltaBisFS

  real function Illl(ell1,ell2,ell3) 
    integer :: ell1, ell2, ell3
    real(dl) :: prefac
    !some papers gace a factor 2 in front. 
    Illl = sqrt((2.d0*ell1+1.d0)*(2.d0*ell2+1.d0)*(2.d0*ell3+1.d0) & 
         /4.d0/pi)

  end function Illl


  !copied from camb utils.f90
  subroutine GetThreeJs(thrcof,l2in,l3in,m2in,m3in)
    !Recursive evaluation of 3j symbols. Does minimal error checking on input
    !parameters.
    implicit none
    integer, parameter :: dl = KIND(1.d0)
    integer, intent(in) :: l2in,l3in, m2in,m3in
    real(dl), dimension(*) :: thrcof
    INTEGER, PARAMETER :: i8 = selected_int_kind(18)
    integer(i8) :: l2,l3,m2,m3
    integer(i8) :: l1, m1, l1min,l1max, lmatch, nfin, a1, a2

    real(dl) :: newfac, oldfac, sumfor, c1,c2,c1old, dv, denom, x, sum1,sumuni
    real(dl) :: x1,x2,x3, y,y1,y2,y3,sum2,sumbac, ratio,cnorm, sign1, thresh
    integer i,ier, index, nlim, sign2
    integer nfinp1,nfinp2,nfinp3, lstep, nstep2,n
    real(dl), parameter :: zero = 0._dl, one = 1._dl
    real(dl), parameter ::  tiny = 1.0d-30, srtiny=1.0d-15, huge = 1.d30,srhuge = 1.d15

    ! routine to generate set of 3j-coeffs (l1,l2,l3\\ m1,m2,m3)

    ! by recursion from l1min = max(abs(l2-l3),abs(m1)) 
    !                to l1max = l2+l3
    ! the resulting 3j-coeffs are stored as thrcof(l1-l1min+1)

    ! to achieve the numerical stability, the recursion will proceed
    ! simultaneously forwards and backwards, starting from l1min and l1max
    ! respectively.
    !
    ! lmatch is the l1-value at which forward and backward recursion are
    ! matched.
    !
    ! ndim is the length of the array thrcof
    !
    ! ier = -1 for all 3j vanish(l2-abs(m2)<0, l3-abs(m3)<0 or not integer)
    ! ier = -2 if possible 3j's exceed ndim
    ! ier >= 0 otherwise

    l2=l2in
    l3=l3in
    m2=m2in
    m3=m3in
    newfac = 0
    lmatch = 0
    m1 = -(m2+m3)

    ! check relative magnitude of l and m values
    ier = 0

    if (l2 < abs(m2) .or. l3 < m3) then
       ier = -1
       ! call MpiStop('error ier = -1')
       print*, 'error ier = -1'
       stop
       return
    end if

    ! limits for l1
    l1min = max(abs(l2-l3),abs(m1))
    l1max = l2+l3

    if (l1min >= l1max) then
       if (l1min/=l1max) then
          ier = -1

          !call MpiStop('error ier = -1')
          print*, 'error ier = -1' 
          stop
          return
       end if

       ! reached if l1 can take only one value, i.e.l1min=l1max
       thrcof(1) = (-1)**abs(l2+m2-l3+m3)/sqrt(real(l1min+l2+l3+1,dl))
       return

    end if

    nfin = l1max-l1min+1

    ! starting forward recursion from l1min taking nstep1 steps
    l1 = l1min
    thrcof(1) = srtiny
    sum1 = (2*l1 + 1)*tiny

    lstep = 1

30  lstep = lstep+1
    l1 = l1+1

    oldfac = newfac
    a1 = (l1+l2+l3+1)*(l1-l2+l3)*(l1+l2-l3)
    a2 = (l1+m1)*(l1-m1)*(-l1+l2+l3+1)
    newfac = sqrt(a2*real(a1,dl))
    if (l1 == 1) then
       !IF L1 = 1  (L1-1) HAS TO BE FACTORED OUT OF DV, HENCE
       c1 = -(2*l1-1)*l1*(m3-m2)/newfac
    else

       dv = -l2*(l2+1)*m1 + l3*(l3+1)*m1 + l1*(l1-1)*(m3-m2)
       denom = (l1-1)*newfac

       if (lstep > 2) c1old = abs(c1)
       c1 = -(2*l1-1)*dv/denom

    end if

    if (lstep<= 2) then

       ! if l1=l1min+1 the third term in the recursion eqn vanishes, hence
       x = srtiny*c1
       thrcof(2) = x
       sum1 = sum1+tiny*(2*l1+1)*c1*c1
       if(lstep==nfin) then
          sumuni=sum1
          go to 230
       end if
       goto 30

    end if

    c2 = -l1*oldfac/denom

    ! recursion to the next 3j-coeff x  
    x = c1*thrcof(lstep-1) + c2*thrcof(lstep-2)
    thrcof(lstep) = x
    sumfor = sum1
    sum1 = sum1 + (2*l1+1)*x*x
    if (lstep/=nfin) then

       ! see if last unnormalised 3j-coeff exceeds srhuge
       if (abs(x) >= srhuge) then

          ! REACHED IF LAST 3J-COEFFICIENT LARGER THAN SRHUGE
          ! SO THAT THE RECURSION SERIES THRCOF(1), ... , THRCOF(LSTEP)
          ! HAS TO BE RESCALED TO PREVENT OVERFLOW

          ier = ier+1
          do i = 1, lstep
             if (abs(thrcof(i)) < srtiny) thrcof(i)= zero
             thrcof(i) = thrcof(i)/srhuge
          end do

          sum1 = sum1/huge
          sumfor = sumfor/huge
          x = x/srhuge

       end if

       ! as long as abs(c1) is decreasing, the recursion proceeds towards
       ! increasing
       ! 3j-valuse and so is numerically stable. Once an increase of abs(c1) is 
       ! detected, the recursion direction is reversed.

       if (c1old > abs(c1)) goto 30

    end if !lstep/=nfin

    ! keep three 3j-coeffs around lmatch for comparison with backward recursion

    lmatch = l1-1
    x1 = x
    x2 = thrcof(lstep-1)
    x3 = thrcof(lstep-2)
    nstep2 = nfin-lstep+3

    ! --------------------------------------------------------------------------
    !
    ! starting backward recursion from l1max taking nstep2 stpes, so that
    ! forward and backward recursion overlap at 3 points 
    ! l1 = lmatch-1, lmatch, lmatch+1

    nfinp1 = nfin+1
    nfinp2 = nfin+2
    nfinp3 = nfin+3
    l1 = l1max
    thrcof(nfin) = srtiny
    sum2 = tiny*(2*l1+1)

    l1 = l1+2
    lstep=1

    do
       lstep = lstep + 1
       l1= l1-1

       oldfac = newfac
       a1 = (l1+l2+l3)*(l1-l2+l3-1)*(l1+l2-l3-1)
       a2 = (l1+m1-1)*(l1-m1-1)*(-l1+l2+l3+2)
       newfac = sqrt(a1*real(a2,dl))

       dv = -l2*(l2+1)*m1 + l3*(l3+1)*m1 +l1*(l1-1)*(m3-m2)

       denom = l1*newfac
       c1 = -(2*l1-1)*dv/denom
       if (lstep <= 2) then

          ! if l2=l2max+1, the third term in the recursion vanishes

          y = srtiny*c1
          thrcof(nfin-1) = y
          sumbac = sum2
          sum2 = sum2 + tiny*(2*l1-3)*c1*c1

          cycle

       end if

       c2 = -(l1-1)*oldfac/denom

       ! recursion to the next 3j-coeff y
       y = c1*thrcof(nfinp2-lstep)+c2*thrcof(nfinp3-lstep)

       if (lstep==nstep2) exit

       thrcof(nfinp1-lstep) = y
       sumbac = sum2
       sum2 = sum2+(2*l1-3)*y*y

       ! see if last unnormalised 3j-coeff exceeds srhuge
       if (abs(y) >= srhuge) then

          ! reached if 3j-coeff larger than srhuge so that the recursion series
          ! thrcof(nfin),..., thrcof(nfin-lstep+1) has to be rescaled to prevent
          ! overflow

          ier=ier+1
          do i = 1, lstep
             index=nfin-i+1
             if (abs(thrcof(index)) < srtiny) thrcof(index)=zero
             thrcof(index) = thrcof(index)/srhuge
          end do

          sum2=sum2/huge
          sumbac=sumbac/huge

       end if

    end do

    ! the forward recursion 3j-coeffs x1, x2, x3 are to be matched with the 
    ! corresponding backward recursion vals y1, y2, y3

    y3 = y
    y2 = thrcof(nfinp2-lstep)
    y1 = thrcof(nfinp3-lstep)

    ! determine now ratio such that yi=ratio*xi (i=1,2,3) holds with minimal
    ! error

    ratio = (x1*y1+x2*y2+x3*y3)/(x1*x1+x2*x2+x3*x3)
    nlim = nfin-nstep2+1

    if (abs(ratio) >= 1) then

       thrcof(1:nlim) = ratio*thrcof(1:nlim) 
       sumuni = ratio*ratio*sumfor + sumbac

    else

       nlim = nlim+1
       ratio = 1/ratio
       do n = nlim, nfin
          thrcof(n) = ratio*thrcof(n)
       end do
       sumuni = sumfor + ratio*ratio*sumbac

    end if
    ! normalise 3j-coeffs

230 cnorm = 1/sqrt(sumuni)

    ! sign convention for last 3j-coeff determines overall phase

    sign1 = sign(one,thrcof(nfin))
    sign2 = (-1)**(abs(l2+m2-l3+m3))
    if (sign1*sign2 <= 0) then
       cnorm = -cnorm
    end if
    if (abs(cnorm) >= one) then
       thrcof(1:nfin) = cnorm*thrcof(1:nfin)
       return
    end if

    thresh = tiny/abs(cnorm)

    do n = 1, nfin
       if (abs(thrcof(n)) < thresh) thrcof(n) = zero
       thrcof(n) = cnorm*thrcof(n)
    end do
    return 

  end subroutine GetThreeJs

  !From http://adsabs.harvard.edu/abs/2012ApJ...760....5B , Eq 8
  real(dl) function LargeArg3Js(l1,l2,l3)
    integer, intent (in) :: l1, l2, l3
    integer :: lt
    lt = l1+l2+l3
    !there are also infinities when and of the l is lt/2
    !these are not infinities, but do not know how else to deal with them
    if(l1 .eq. lt/2 .or. l2 .eq. lt/2 .or. l3 .eq. lt/2) lt = lt - 1
    LargeArg3Js = sqrt(2.d0/pi)*(-1.d0)**(lt/2.d0)/ &
         (lt*(lt-2.d0*l1)*(lt-2.d0*l2)*(lt-2.d0*l3))**(1./4.)
    !get rid of NAN's
    if(LargeArg3Js .ne. LargeArg3Js) LargeArg3Js = 0.d0

  end function LargeArg3Js
end module CMBFlat
