!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!module computes Cl(TT) and Cl(BB) in flat sky. Also B_lll(BTT) and B_lll(TTT). !!!!!!!!!!
!Can be modified to print other spectra D. Meerburg 2016!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module CMBFlat

use settings
use interpolation

implicit none 
real(dl), public :: CLTT(lmaxS), CLBB(lmaxT)

contains

subroutine Compute_CL_flat

	
	integer     :: i, imax = 100000000, j, n, eof
	real(dl), allocatable    :: TransferS(:,:,:) 
	real(dl), allocatable    :: TransferT(:,:,:) 
	real(dl), allocatable    :: karrS(:), karrT(:) !number of tau samples for each k
	real(dl)    :: k, tau, T1, T2, T3, T4
	integer     :: intellmaxS, intellmaxT
	integer     :: intkmaxS, intkmaxT, templ
	real(dl)    :: dkS, dkT, kintresS, kintresT  
	real(dl)    :: qS, qT, q2S, q2T , q2S1, q2S2
    integer :: ell, s
	integer, allocatable :: ellarrS(:), ellarrT(:)
	character(100) :: fnSLSS,fnTLSS,CLTfile, CLSfile
	real(dl) :: kintegrandS, kintegrandT
	integer :: count
	integer,allocatable :: kmaxInt(:)

    !required for limited stack size MacOsX + openmp
	allocate(TransferS(4,1200,3000))
	allocate(TransferT(4,1200,3000))
	allocate(karrS(3000))
	allocate(karrT(3000))
	allocate(ellarrS(1200))
	allocate(kmaxInt(1200))
	allocate(ellarrT(1200))


	if (AppLss) then 
		fnSLSS = "clTransferS.txt"
		fnTLSS = "clTransferT.txt"
		CLSfile = "clTTb.txt"
		CLTfile = "clBB.txt"
	else
		fnSLSS = "clTransferSb.txt"
		fnTLSS = "clTransferTb.txt"
		CLSfile = "clTTb.txt"
		CLTfile = "clBBf.txt"
	endif
	if (scalars) then
	j = 0
	n = 1
	templ = lmin-1
	open(unit=21,file=fnSLSS, status='old')
	do i = 1, imax
	    
	    if(AppLSS) then 
		read(21,'(I4,3E17.7)',iostat=eof) ell, k, T1, T2
		else
		read(21,'(I4,5E17.7)',iostat=eof) ell, k, T1, T2, T3, T4
		endif
		!write(*,*) ell, k, T1, T2
		if (eof < 0 ) exit !end of file
		if (ell > templ) then
			j = j + 1
			n = 1	
			!write(*,*) "Here!"
		endif
		!write(*,*) i
		templ = ell
		ellarrS(j) = ell
		karrS(n) = k
		TransferS(1,j,n) = T1
		TransferS(2,j,n) = T2
		TransferS(3,j,n) = T3
		TransferS(4,j,n) = T4
		n = n + 1		
	enddo 
    intellmaxS = j
    intkmaxS = n-1
    close(21)
    write(*,*) "number of ell in scal", intellmaxS
    write(*,*) "Number of k", intkmaxS
    endif
    if (tensors) then
    j = 0
	n = 1
	templ = lmin-1
	open(unit=21,file=fnTLSS, status='old')
	do i = 1, imax
	    if(AppLSS) then 
		read(21,'(I4,3E17.7)',iostat=eof) ell, k, T1, T2
		else
		read(21,'(I4,5E17.7)',iostat=eof) ell, k, T1, T2, T3, T4
		endif
		!if (j .eq. 10) write(*,*) s, k, tau, S1, S2, S3 
		if (eof < 0 ) exit !end of file
		if (ell > templ) then

			j = j + 1
			n = 1
		
		endif
		templ = ell
		ellarrT(j) = ell
		karrT(n) = k
		TransferT(1,j,n) = T1
		TransferT(2,j,n) = T2
		TransferT(3,j,n) = T3
		TransferT(4,j,n) = T4
		n = n + 1		
	enddo 
    intellmaxT = j
    intkmaxT = n-1
    close(21)
    !ell = 1000
	
    write(*,*) "number of ell in tens", intellmaxT
    write(*,*) "Number of k", intkmaxT
    
    endif
    !determine intkmax per ell
    do i = 1, intellmaxS
    	count = 1
        do j = 1, intkmaxS
		!this is just a crazy guess, but it works pretty well
		!first of these is better, but second one is ok as well, and lowers 
		!the sampling even more. This is necessary for bispectrum.
		!if (karrS(j) .ge. 2.d0*sqrt(1.0*lmaxS)*sqrt(1.d0*ellarrS(i))/tau0) exit
		if (karrS(j) .ge. 2.d0*(1.0*lmaxS)**(1./3.)*(1.d0*ellarrS(i))**(2./3.)/tau0) exit
        count = count + 1
        enddo 
        kmaxInt(i) = count-1
        !write(*,*) ellarrS(i),kmaxInt(i)
	enddo
    
    if (scalars) then
    open(unit=21,file=CLSfile, status="replace")
    s = 1
    do j = 1, intellmaxS !loop over ell
    ell = ellarrS(j)
    kintresS = 0.d0
    !flat sky TT 
		do i = 1, kmaxInt(j) !Integrate over k
		if (i < intkmaxS) then 
			dkS = karrS(i+1) - karrS(i)
		else 
			dkS = karrS(i) - karrS(i-1)
		endif

		q2S1 = sqrt(karrS(i)**2+(ell/(tauRS-tau0))**2)
	    q2S2 = sqrt(karrS(i+1)**2+(ell/(tauRS-tau0))**2)
		if (AppLSS) then 
			!recall j = ell, i = k
		    kintegrandS = ((TransferS(1,j,i)**2+TransferS(2,j,i)**2)/q2S1**3 + &
		    				(TransferS(1,j,i+1)**2+TransferS(2,j,i+1)**2)/q2S2**3)/2.0d0	
			!kintresS = kintresS + (TransferS(1,j,i)**2+TransferS(2,j,i)**2)*dkS/q2S**3
			kintresS = kintresS + kintegrandS*dkS
		else
			
		    kintegrandS = ((TransferS(1,j,i)*TransferS(3,j,i) + & 
								TransferS(2,j,i)*TransferS(4,j,i)) + &
		    				(TransferS(1,j,i+1)*TransferS(3,j,i+1) + & 
								TransferS(2,j,i+1)*TransferS(4,j,i+1)))/2.0d0
			kintresS = kintresS + kintegrandS*dkS
			!(TransferS(1,j,i)*TransferS(3,j,i) + & 
			!					TransferS(2,j,i)*TransferS(4,j,i))*dkS
		endif

		enddo
		if (AppLSS) then 
			write(21,*) ell, CMBuK*(TauRS-Tau0)**2*As*ell*(ell+1.d0)*kintresS
			CLTT(j) =  As*(TauRS-Tau0)**2*kintresS
		else 
			write(21,*) ell, CMBuK*As*ell*(ell+1.d0)*kintresS
			CLTT(j) =  As*kintresS
		endif
    enddo 
    close(21)
    endif
    if(tensors) then 
    open(unit=28,file=CLTfile, status="replace")
    s = 1
    do j = 1, intellmaxT !loop over ell
    ell = ellarrT(j)
    kintresT = 0.d0

    !flat sky TT 
		do i = 1, intkmaxT !Integrate over k
		if (i < intkmaxT) then 
			dkT = karrT(i+1) - karrT(i)
		else 
			dkT = karrT(i) - karrT(i-1)
		endif
	    q2T = sqrt(karrT(i)**2+(ell/(tauRT-tau0))**2)
		if (AppLSS) then 
			!this seems to lead to the best result. Not sure why, is not the same as Maresuke. if
			!I add the factor (k_z/k)^2 I get something that looks totally off.  
			kintresT = kintresT +(TransferT(1,j,i)**2+TransferT(2,j,i)**2)*dkT/q2T**3
			if (ell .eq. 100) write(*,*) karrT(i), q2T, kintresT
		else
			kintresT = kintresT + (TransferT(1,j,i)*TransferT(3,j,i) + & 
								TransferT(2,j,i)*TransferT(4,j,i))*dkT
		endif

		enddo
		s = s + 1
		if (AppLSS) then 
		write(28,*) ell, 2*CMBuK*As*TtoS*ell*(ell+1.d0)*kintresT*(TauRS-Tau0)**2
		CLBB(j) =  kintresT
		else
        write(28,*) ell, 2*CMBuK*As*TtoS*ell*(ell+1.d0)*kintresT
        CLBB(j) =  kintresT

        endif
    enddo 
    close(28)
    endif
    deallocate(ellarrS)
    deallocate(ellarrT)
	deallocate(TransferS)
	deallocate(TransferT)
	deallocate(karrS)
	deallocate(karrT)
	deallocate(kmaxInt)
end subroutine Compute_CL_flat

subroutine Compute_Blll_TTB_flat(want_SN)
	logical, intent(in) :: want_SN
	real(dl) :: DSN, B2, sigmaBTT
	real(dl) :: Bnoise(lmaxT)
	integer  :: i, imax = 100000000, j, n, s, eof 
	real(dl), allocatable    :: TransferS(:,:,:) 
	real(dl), allocatable    :: TransferT(:,:,:) 
	real(dl), allocatable    :: karrS(:), karrT(:)
	real(dl)    :: k, tau, T1, T2
	integer     :: intellmaxS, intellmaxT
	integer     :: intkmaxS, intkmaxT, templ
	real(dl)    :: dk1, dk2, kintres1, kintres2  
	integer 	:: ell, ell1, ell2, ell3, il
	integer     :: k1, k2
	real(dl)    :: q1, q2, q3, kt, TranTTemp, kzT
	integer 	:: ellarrS(1000), ellarrT(1000)
	real(dl)    :: bispec
	
	real(dl), allocatable :: sp1t(:,:), sp2t(:,:), sp3t(:,:)
	real(dl), allocatable :: Blll(:,:,:)
	if(want_SN) then 	
		call Compute_CL_flat
	endif
	!required for limited stack size MacOsX + openmp
	allocate(TransferS(2,1000,3000))
	allocate(TransferT(2,1000,3000))
	allocate(karrS(3000))
	allocate(karrT(3000))
	allocate(Blll(lmaxS,lmaxS,lmaxT))
	j = 0
	n = 1
	templ = lmin
	open(unit=21,file="clTransferS.txt", status='old')
	do i = 1, imax
	    
		read(21,'(I4,3E17.7)',iostat=eof) ell, k, T1, T2
		!write(*,*) ell, k, T1, T2
		if (eof < 0 ) exit !end of file
		if (ell > templ) then
			j = j + 1
			n = 1	
			!write(*,*) "Here!"
		endif
		!write(*,*) i
		templ = ell
		ellarrS(j) = ell
		karrS(n) = k
		TransferS(1,j,n) = T1
		TransferS(2,j,n) = T2
		n = n + 1		
	enddo 
    intellmaxS = j
    intkmaxS = n-1
    close(21)
    write(*,*) "number of ell in scal", intellmaxS
    
    j = 0
	n = 1
	templ = lmin
	open(unit=21,file="clTransferTb3.txt", status='old')
	do i = 1, imax
	    
		read(21,'(I4,3E17.7)',iostat=eof) ell, k, T1, T2
		!if (j .eq. 10) write(*,*) s, k, tau, S1, S2, S3 
		if (eof < 0 ) exit !end of file
		if (ell > templ) then

			j = j + 1
			n = 1
		
		endif
		templ = ell
		ellarrT(j) = ell
		karrT(n) = k
		TransferT(1,j,n) = T1
		TransferT(2,j,n) = T2
		n = n + 1		
	enddo 
    intellmaxT = j
    intkmaxT = n-1
    close(21)
    !ell = 1000

    write(*,*) "number of ell in tens", intellmaxT
    write(*,*) "Number of k", intkmaxT
    !spline the tensor transfer function with a cosine

    allocate(sp1t(intellmaxT,intkmaxT))
    allocate(sp2t(intellmaxT,intkmaxT))
    allocate(sp3t(intellmaxT,intkmaxT))
    do j = 1, intellmaxT
    ell = ellarrT(j)
    	call spline(karrT(1:intkmaxT),TransferT(2,j,1:intkmaxT),sp1t(j,1:intkmaxT) & 
    							,sp2t(j,1:intkmaxT),sp3t(j,1:intkmaxT),intkmaxT)
	enddo 
    open(unit=28,file="Blll_SST2.txt", status="replace")
    
    !$OMP PARALLEL DO DEFAUlT(SHARED), &
    !$OMP PRIVATE(ell1, ell2,ell3,j,i,s,sp1t,sp2t,sp3t), &
    !$OMP PRIVATE(q1,q2,kzT,q3,dk2,dk1,bispec,TranTTemp,kintres2,kintres1)
    do j = 1, intellmaxS, DeltalBS !loop over ells
    ell1 = ellarrS(j)
		do i = j, intellmaxS, DeltalBS !only for i .ge. j
		ell2 = ellarrS(i)
			do s = 1, intellmaxT, DeltalBS
			ell3 = ellarrT(s)
			kintres1 = 0.0d0
				do k1 = 1, 100 !integrals over k. Now some arbitrary max.Very low. But fast for now.  
				dk1 = karrS(k1+1) - karrS(k1)
				kintres2 = 0.0d0
					do k2 = 1, 100
					dk2 = karrS(k2+1) - karrS(k2)
					q1 = sqrt(karrS(k1)**2+(ell1/(tauRS-tau0))**2)
					q2 = sqrt(karrS(k2)**2+(ell2/(tauRS-tau0))**2)
					kzT = karrS(k1)+karrS(k2)
					q3 = sqrt((kzT)**2+(ell3/(tauRT-tau0))**2)
					kt = q1 + q2 + q3
					bispec = (-kt + (q1*q2+q2*q3+q3*q1)/kt + q1*q2*q3/kt**2)/(q1*q2*q3)**3 
					!get the tensor transfer function with the correct k
					
					TranTTemp  = ispline(kzT,karrT(1:intkmaxT),TransferT(2,s,1:intkmaxT), & 
    							sp1t(s,1:intkmaxT),sp2t(s,1:intkmaxT),sp3t(s,1:intkmaxT),intkmaxT)
    				kintres2 = kintres2 + bispec*TranTTemp*TransferS(2,j,k1)*TransferS(2,i,k2)*dk1
    				enddo 
    			kintres1  = kintres1+kintres2*dk1
    			enddo 
    			!here we go. These will not be printed in order:
    			write(28,'(3I5, E17.7)') ell1, ell2, ell3, kintres1
    			!bispectrum squared
    			!want signal to noise?

    	    enddo 
        enddo 
        write(*,*) ell1
    enddo 
    !$OMP END PARALLEL DO 
    close(28) 		
	if(want_SN) then
	 
	!as a function of temp lmax:
	do il = 200, intellmaxS, 10
	DSN = 0.0d0
	    do j = 1, il, 10 !loop over ells
    	ell1 = ellarrS(j)
			do i = j, il, 10 !only for i .ge. j
			ell2 = ellarrS(i)
				do s = 1, intellmaxT, 10
				ell3 = ellarrT(s)
				B2 = Blll(j,i,s)**2
				sigmaBTT = Bnoise(s)*ClTT(j)*ClTT(i)
				!I think i need to multiply by cubed of DeltalBS. Think about it some more. 
				DSN = DSN + B2/(DeltaBis(ell1,ell2,ell3)*sigmaBTT)*(DeltalBS)**3
				enddo 
			enddo 
		enddo 
		write(*,*) il, DSN
	enddo
	endif 

	deallocate(sp1t)
	deallocate(sp2t)
	deallocate(sp3t)
	deallocate(TransferS)
	deallocate(TransferT)
	deallocate(karrS)
	deallocate(karrT)
	deallocate(Blll)
end subroutine Compute_Blll_TTB_flat


subroutine Compute_Blll_TTT_flat(want_SN)
!routine from babich et al. As a check for the BTT version. 
	logical, intent(in) :: want_SN
	real(dl) :: DSN, B2, sigmaTTT
	integer  :: i, imax = 100000000, j, n, s, eof 
	real(dl), allocatable    :: TransferS(:,:,:) 
	real(dl), allocatable    :: karrS(:)
	real(dl)    :: k, tau, T1, T2
	integer     :: intellmaxS
	integer     :: intkmaxS, templ
	real(dl)    :: dk1, dk2, kintres1, kintres2  
	integer 	:: ell, ell1, ell2, ell3, il
	integer     :: k1, k2
	real(dl)    :: q1, q2, q3a, q3b, TranSTemp1,TranSTemp2, kzSa, kzSb
	integer 	:: ellarrS(1000)
	real(dl)    :: blocala, blocalb
	
	real(dl), allocatable :: sp1t(:,:), sp2t(:,:), sp3t(:,:)
	real(dl), allocatable :: Blll(:,:,:)
	integer :: count
	integer,allocatable :: kmaxInt(:)
	real(dl),allocatable :: TransferF1(:,:,:), TransferF2(:,:,:)  
	
	!just to be sure
	scalars  = .true. 
	tensors = .false. 
	AppLSS = .true.
	if(want_SN) then 	
		call Compute_CL_flat
	endif
	!required for limited stack size MacOsX + openmp
	allocate(TransferS(2,1200,3000))
	allocate(karrS(3000))
	allocate(Blll(lmaxS,lmaxS,lmaxT))
	allocate(kmaxInt(1200))

	
	j = 0
	n = 1
	templ = lmin-1
	!only need scalar temperature transfer function
	open(unit=21,file="clTransferS.txt", status='old')
	do i = 1, imax
	    
		read(21,'(I4,3E17.7)',iostat=eof) ell, k, T1, T2
		!write(*,*) ell, k, T1, T2
		if (eof < 0 ) exit !end of file
		if (ell > templ) then
			j = j + 1
			n = 1	
			!write(*,*) "Here!"
		endif
		!write(*,*) i
		templ = ell
		ellarrS(j) = ell
		karrS(n) = k
		TransferS(1,j,n) = T1
		TransferS(2,j,n) = T2
		n = n + 1		
	enddo 
    intellmaxS = j
    intkmaxS = n-1
    close(21)
    write(*,*) "number of ell in scal", intellmaxS
    
    do i = 1, intellmaxS
    	count = 1
        do j = 1, intkmaxS
		!this is just a crazy guess, but it works pretty well
		!first of these is better, but second one is ok as well, and lowers 
		!the sampling even more. This is necessary for bispectrum.
		!if (karrS(j) .ge. 2.d0*sqrt(1.0*lmaxS)*sqrt(1.d0*ellarrS(i))/tau0) exit
		if (karrS(j) .ge. 2.d0*(1.0*lmaxS)**(1./3.)*(1.d0*ellarrS(i))**(2./3.)/tau0) exit
        count = count + 1
        enddo 
        kmaxInt(i) = count-1
        !write(*,*) ellarrS(i),kmaxInt(i)
	enddo
	!for testing:
	intellmaxS = 10
    allocate(TransferF1(intellmaxS,intkmaxS,intkmaxS))
    allocate(TransferF2(intellmaxS,intkmaxS,intkmaxS))

	!precompute at points needed. Using relatively fast interpolation scheme. Still slow. On a single core takes about 6 hours. Have
	!thought how to make this faster, but seems impossible at this point. Using 32 cores would only require 15 minutes. Once these have 
	!been computed bispectrum is really fast. 
	
	!$OMP PARALLEL DO DEFAUlT(SHARED), &
    !$OMP PRIVATE(j,i,s,ell3), &
    !$OMP PRIVATE(kzSa,kzSb), &
    !$OMP PRIVATE(TranSTemp1,TranSTemp2)
	do s = 1, intellmaxS
	    ell3  = ellarrS(s)
		write(*,*) ell3
		do k1 = 1, intkmaxS
		!write(*,*) k1
			do k2 = 1, k1 
			kzSa = karrS(k1)+karrS(k2)
			!if kzSa gets larger than this, the tranfer function is out of bounds, and my guess
			!is that since this tranfer function multiplies everything, it would render the contribution 
			!zero. This is a little bit of a guess. 
			!if(kzSa .ge. karrS(kmaxInt(s))) exit
			if(kzSa .ge. karrS(intkmaxS)) exit !this is the least I can do. 
			call linint(kzSa,TranSTemp1,karrS(1:intkmaxS),TransferS(2,s,1:intkmaxS),intkmaxS)
			kzSb = karrS(k1)-karrS(k2) + karrS(1)
			call linint(kzSb,TranSTemp2,karrS(1:intkmaxS),TransferS(2,s,1:intkmaxS),intkmaxS)
			!if (ell3 .eq. 100 .and. k1 .eq. 100) write(*,*) kzSa,TranSTemp1, karrS(k2),TransferS(2,s,k2) 
			TransferF1(s,k1,k2) = TranSTemp1
			TransferF1(s,k1,k2) = TranSTemp2
			!if (ell3 .eq. 10 .and. k1 .eq. 100) write(*,*) k2
			enddo 
			do k2 = k1+1, intkmaxS
			kzSa = karrS(k1)+karrS(k2)
			if(kzSa .ge. karrS(intkmaxS)) exit 
			call linint(kzSa,TranSTemp1,karrS(1:intkmaxS),TransferS(2,s,1:intkmaxS),intkmaxS)
			kzSb = karrS(k2)-karrS(k1) + karrS(1) !this should guarentee always be > 0
			call linint(kzSb,TranSTemp2,karrS(1:intkmaxS),TransferS(2,s,1:intkmaxS),intkmaxS)
			TransferF1(s,k1,k2) = TranSTemp1
			TransferF1(s,k1,k2) = TranSTemp2
			!is it contineous
			!if (ell3 .eq. 10 .and. k1 .eq. 100) write(*,*) k2
			enddo
		enddo 
	enddo 
	!$OMP END PARALLEL DO 

	
    open(unit=28,file="Blll_SSS.txt", status="replace")
    !for testing
    !intellmaxS = 12

    !$OMP PARALLEL DO DEFAUlT(SHARED), &
    !$OMP PRIVATE(ell1,ell2,ell3,j,i,s,sp1t,sp2t,sp3t), &
    !$OMP PRIVATE(q1,q2,kzSa,kzSb,q3a,q3b,dk2,dk1), &
    !$OMP PRIVATE(TranSTemp1,TranSTemp2,kintres2,kintres1,blocala,blocalb)
    do j = 1, intellmaxS !loop over ells
    ell1 = ellarrS(j)
    write(*,*) ell1
		do i = j, intellmaxS !only for i .ge. j
		ell2 = ellarrS(i)
			do s = i, intellmaxS !only for s .ge. i
			ell3 = ellarrS(s)
			kintres1 = 0.0d0
				do k1 = 1, kmaxInt(j) !integrals over k. Now some arbitrary max.Very low. But fast for now.  
				dk1 = karrS(k1+1) - karrS(k1)
				kintres2 = 0.0d0
					do k2 = 1, k1 !split up the integral into 2 pieces. 
					
					dk2 = karrS(k2+1) - karrS(k2)
					q1 = sqrt(karrS(k1)**2+(ell1/(tauRS-tau0))**2)
					q2 = sqrt(karrS(k2)**2+(ell2/(tauRS-tau0))**2)
					kzSa = karrS(k1)+karrS(k2)
					kzSb = karrS(k1)-karrS(k2) + karrS(1) !this should guarentee always be > 0
					q3a = sqrt((kzSa)**2+(ell3/(tauRS-tau0))**2)
					q3b = sqrt((kzSb)**2+(ell3/(tauRS-tau0))**2)
					blocala = 1.d0/(q1*q2)**3 + 1.d0/(q3a*q2)**3 + 1.d0/(q3a*q1)**3
					blocalb = 1.d0/(q1*q2)**3 + 1.d0/(q3b*q2)**3 + 1.d0/(q3b*q1)**3
					!get the tensor transfer function with the correct k
					
					
					!see notes, the following is not trivial
!					TranSTemp1  = ispline(kzSa,karrS(1:intkmaxS),TransferS(2,s,1:intkmaxS), & 
!    							sp1t(s,1:intkmaxS),sp2t(s,1:intkmaxS),sp3t(s,1:intkmaxS),intkmaxS)
!    				TranSTemp2  = ispline(kzSb,karrS(1:intkmaxS),TransferS(2,s,1:intkmaxS), & 
!    							sp1t(s,1:intkmaxS),sp2t(s,1:intkmaxS),sp3t(s,1:intkmaxS),intkmaxS)
    				kintres2 = kintres2 + blocala*TransferF1(s,k1,k2)*(TransferS(2,j,k1)*TransferS(2,i,k2) - & 
    									TransferS(1,j,k1)*TransferS(1,i,k2)) + &
    									blocalb*TransferF2(s,k1,k2)*(TransferS(2,j,k1)*TransferS(2,i,k2) + & 
    									TransferS(1,j,k1)*TransferS(1,i,k2))
    				enddo 
    				do k2 = k1+1, kmaxInt(i) !second piece
    				
					dk2 = karrS(k2+1) - karrS(k2)
					q1 = sqrt(karrS(k1)**2+(ell1/(tauRS-tau0))**2)
					q2 = sqrt(karrS(k2)**2+(ell2/(tauRS-tau0))**2)
					kzSa = karrS(k1)+karrS(k2)
					kzSb = karrS(k2)-karrS(k1) + karrS(1) !this should guarentee always be > 0
					q3a = sqrt((kzSa)**2+(ell3/(tauRS-tau0))**2)
					q3b = sqrt((kzSb)**2+(ell3/(tauRS-tau0))**2)
					blocala = 1.d0/(q1*q2)**3 + 1.d0/(q3a*q2)**3 + 1.d0/(q3a*q1)**3
					blocalb = 1.d0/(q1*q2)**3 + 1.d0/(q3b*q2)**3 + 1.d0/(q3b*q1)**3
					!get the tensor transfer function with the correct k
					
					
					!see notes, the following is not trivial
!					TranSTemp1  = ispline(kzSa,karrS(1:intkmaxS),TransferS(2,s,1:intkmaxS), & 
!    							sp1t(s,1:intkmaxS),sp2t(s,1:intkmaxS),sp3t(s,1:intkmaxS),intkmaxS)
!    				TranSTemp2  = ispline(kzSb,karrS(1:intkmaxS),TransferS(2,s,1:intkmaxS), & 
!    							sp1t(s,1:intkmaxS),sp2t(s,1:intkmaxS),sp3t(s,1:intkmaxS),intkmaxS)
    				kintres2 = kintres2 + blocala*TransferF1(s,k1,k2)*(TransferS(2,j,k1)*TransferS(2,i,k2) - & 
    									TransferS(1,j,k1)*TransferS(1,i,k2)) + &
    									blocalb*TransferF2(s,k1,k2)*(TransferS(2,j,k1)*TransferS(2,i,k2) + & 
    									TransferS(1,j,k1)*TransferS(1,i,k2))    				
    				
    				enddo 
    			kintres1  = kintres1+kintres2*dk1
    			
    			enddo 
    			!Babich, page 3 (local norm), for f_NL = 1
    			!only (2 pi)^2 because the bispectrum is devided by (2 pi)^2
    			!the factor 4 comes from the trigonometric identities above
    			!As^2 is the amplitude of the primordial power spectrum 
    			!If it is ok, we could add this to the paper as evidence that we got this right (even as a insanity check). 
    			!the only problem would be that local NGS would get most of their signal to noise from the squeezed limit
    			!although, I think it is not as bad as for the bias. 
    			Blll(j,i,s) = -6.d0*(2.d0*pi)**2*As**2*4.d0*(tau0-tauRS)**2*kintres1/5.d0
    			!here we go. These will not be printed in order:
    			write(28,'(3I5, E17.7)') ell1, ell2, ell3, Blll(j,i,s)
    			
    			write(*,'(3I5, E17.7)') ell1, ell2, ell3, Blll(j,i,s)
    	    enddo 
        enddo 
        
    enddo 
    !$OMP END PARALLEL DO 
    close(28) 		
	if(want_SN) then
	!as a function of temp lmax:
	do il = 200, intellmaxS, 10
	DSN = 0.0d0
	    do j = 1, il, 10 !loop over ells
    	ell1 = ellarrS(j)
			do i = j, il, 10 !only for i .ge. j
			ell2 = ellarrS(i)
				do s = 1, il, 10 
				ell3 = ellarrS(s)
				B2 = Blll(j,i,s)**2
				sigmaTTT = DeltaBisFS(ell1,ell2,ell3)*ClTT(s)*ClTT(j)*ClTT(i)
				!I think i need to multiply by cubed of DeltalBS. Think about it some more. 
				DSN = DSN + B2/(sigmaTTT)*(lstep)**3
				enddo 
			enddo 
		enddo 
		write(*,*) il, DSN
	enddo
	endif 
!
!	deallocate(sp1t)
!	deallocate(sp2t)
!	deallocate(sp3t)
	deallocate(TransferS)
	deallocate(karrS)
	deallocate(Blll)
	deallocate(kmaxInt)
	deallocate(TransferF1)
	deallocate(TransferF2)

end subroutine Compute_Blll_TTT_flat

integer function DeltaBis(ell1,ell2,ell3)
	integer :: ell1, ell2, ell3
	
	!factor for symmetric only in 2 out of 3 comp, e.g. BTT
    if(ell1 .eq. ell2) then 
    	DeltaBis = 2
    else
    	DeltaBis = 1
    endif 
	
end function DeltaBis

integer function DeltaBisFS(ell1,ell2,ell3)
	integer :: ell1, ell2, ell3
	!factor for fullt symmetric spectrum (e.g. TTT, EEE etc)
    if(ell1 .eq. ell2 .and. ell2 .eq. ell3) then 
    	DeltaBisFS = 6
    elseif(ell1 .eq. ell2 .and. ell2 .ne. ell3) then
    	DeltaBisFS = 2
    elseif(ell1 .ne. ell2 .and. ell2 .eq. ell3) then
    	DeltaBisFS = 2
    elseif(ell1 .ne. ell2 .and. ell1 .eq. ell3) then
    	DeltaBisFS = 2
    else 
    	DeltaBisFS = 1
    endif 
	
end function DeltaBisFS


end module CMBFlat