!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!module with various settings!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!D. Meerburg 2015!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


module settings


  implicit none 


  integer, parameter :: dl= KIND(1.d0)
  real(dl), parameter :: pi = 3.14159265359
  real(dl), parameter :: Euler = 2.7182818284590452353602
  !want polarization/tensors/scalars?
  logical :: polarization = .true., scalars = .true., tensors = .true.
  logical :: Tmode = .true., Emode = .true., Bmode  = .true. 
  !change if you want last scattering approximation off/on (off not fully implemented)
  logical :: AppLSS = .true.
  !whether to use CAMB or CLASS source function for E
  logical :: CLASS  = .true. , CAMB = .false. 

  logical :: wantRelFlocal = .true.

  !location of transfer functions etc
  character(120) :: homefolder = '../data/'
  !location of source functions
  character(120) :: sourcefunctions = '../data/'
  character(120) :: noise_folder = '../input/'
  !will appear in front of output
  character(80) :: rootnameCl = "CLASSx3"
  character(80) :: rootnameBl = "CLASSxCAMB_lmax1000x3500_ellGRID_equil"
  !name of transfer functions:
  !character(80) :: NameTransferT = 'FlatTransfer_ellGRID_T_lmax3500'
  character(80) :: NameTransferE = 'FlatTransfer_ellGRID_E_lmax4500'
  !character(80) :: NameTransferB = 'FlatTransfer_ellGRID_B_lmax500'

  !old ones (for current S/N calculation):
  character(80) :: NameTransferT = 'FlatTransfer_ellGRID_lmax4500'
  character(80) :: NameTransferB = 'FlatTransfer_ellGRID_lmax500'

  character(80) :: NameSource = 'Sources'
  !tensor polarization source function:
  character(80) :: PolTtxt = '_h_P.txt' !from CLASS
  !scalar polarization source function:
  character(80) :: PolStxt = '_z_P.txt' !from CLASS
  !scalar intensity source function:
  character(80) :: Scaltxt = '_CAMB_z_T.txt' !from CAMB

  character(120) :: fname
  !ending of scalar and tensors (change to anything you like)

  !lmax of Tensors and Scalars
  integer, parameter :: lmaxPoltens = 1000
  integer, parameter :: lmaxPolScal = 4500 
  integer, parameter :: lmaxScal = 4500
  
  !minimum value of multipole (flat sky, so 10 is limit)
  integer :: lmin = 10
  !delta l for precomputing flat sky transfer functions
  integer :: lstep = 20

  !settings same as CAMB for comparisson. Note that A_s and ns can
  !always be adjusted; they are not part of source functions. 
  real(dl) :: As = 2.215E-9 
  real(dl) :: ns = 1.0
  !reionization optical depth --> needed for CLASS spectra:
  real(dl) :: ReiTau = 0.06
  real(dl) :: Etau
  real(dl) :: CMBuK = 7.42835025E12 !CAMB
  !real(dl) :: h0 = 0.7
  real(dl) :: TtoS = 0.01 !tensor to scalar ratio 
  real(dl), parameter :: COBE_CMBTemp = 2.7255_dl !(Fixsen 2009)
  real(dl) :: tau0 = 14165.045412, tauRS = 280.576042, tauRT = 280.576042  !from CLASS
  integer :: I_progress, pstep = 32
  integer :: elltable(400)
  logical :: do_log_ell = .true.
  integer :: gridDell(3)


  
contains
  !used to generate a more efficient grid. 
  subroutine set_ell_values
    integer :: i
    !set stepsizes:
    gridDell(1) = 1
    gridDell(2) = 10
    gridDell(3) = 20
    do i = 1, 333
       if (i .le. 91) then
          !hmm start at 11, mistake. Want to start at 10. 
          elltable(i) = 10+(i-1)
       elseif (i .ge. 91 .and. i .le. 131 ) then 
          elltable(i) = elltable(i-1) + gridDell(2)
       elseif (i .ge. 132) then
          elltable(i) = elltable(i-1) + gridDell(3)
       endif
       !write(*,*) i, elltable(i)
    enddo
  end subroutine set_ell_values

  
end module settings
