!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!    
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!module with various settings!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!D. Meerburg 2015!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


module settings


  implicit none 


  integer, parameter :: dl= KIND(1.d0)
  real(dl), parameter :: pi = 3.14159265359
  !want tensors/scalars?
  logical :: tensors = .true., scalars = .true. 
  !change if you want last scattering approximation off/on
  logical :: AppLSS = .true.
  !lmax of Tensors and Scalars
  integer, parameter :: lmaxT = 2000
  integer, parameter :: lmaxS = 2000
  !minimum value of multipole (flat sky, so 10 is limit)
  integer :: lmin = 10
  !delta l for precomputing flat sky transfer functions
  integer :: lstep = 20
  !location of transfer functions etc
  character(120) :: homefolder = '/mnt/scratch-lustre/meerburg/'
  !location of source functions
  character(120) :: sourcefunctions = '/mnt/scratch-lustre/meerburg/'
  character(120) :: noise_folder = 'Noise/'
  !will appear in front of output
  character(80) :: rootnameCl = "Cl_deltaEll_20"
  character(80) :: rootnameBl = "Full_Blll_deltaEll_20"

  !some names (with default, change as you like)
  !Transfer functions
  character(80) :: NameTransfer = 'FlatTransferZ'  
  character(80) :: NameSource = 'Sources_lmax3000_'
  
  character(120) :: fname
  !ending of scalar and tensors (change to anything you like)
  character(80) :: Stxt = 'S_BTT.txt'
  character(80) :: Ttxt = 'T_BTT.txt'
  
  
  !settings same as CAMB for comparisson. Note that A_s and ns can
  !always be adjusted; they are not part of source functions. 
  real(dl) :: As = 2.1E-9 
  real(dl) :: ns = 1.0
  real(dl) :: CMBuK = 7.42835025E12 !CAMB
  !real(dl) :: h0 = 0.7
  real(dl) :: TtoS = 0.001 !tensor to scalar ratio 
  real(dl), parameter :: COBE_CMBTemp = 2.7255_dl !(Fixsen 2009)
  real(dl)    :: tau0 = 14384.7, tauRS = 284.87, tauRT = 284.82  !from CAMB
  integer :: I_progress, pstep = 32

end module settings
